/*----------------------------------------
description file: cheese.m13126

%   file cheese.m
%   Cumulative probabilities  multinomial model
resp y; 
varind  cat, ch, n;
aux p,  beta, pc1, pc2, pc3, pc4, pc5, pc6, pc7, pc8, pc9, b2, b3, b4, b5, b6, b7, b8; 
var v;
parresp teta1,teta2,teta3,teta4,teta5,teta6,teta7,teta8,beta1,beta2,beta3;
subroutine;
begin
beta = if (ch==1) then beta1 else
       if (ch==2) then beta2 else
       if (ch==3) then beta3 else
       -beta1-beta2-beta3
       fi fi fi;
b2  = teta1 + exp(teta2);
b3  = b2 + exp(teta3);
b4  = b3 + exp(teta4);
b5  = b4 + exp(teta5);
b6  = b5 + exp(teta6);
b7  = b6 + exp(teta7);
b8  = b7 + exp(teta8);
pc1 = exp(teta1+beta)/(1+exp(teta1+beta)) ;
pc2 = exp(b2+beta)/(1+exp(b2+beta)) ;
pc3 = exp(b3+beta)/(1+exp(b3+beta)) ;
pc4 = exp(b4+beta)/(1+exp(b4+beta)) ;
pc5 = exp(b5+beta)/(1+exp(b5+beta)) ;
pc6 = exp(b6+beta)/(1+exp(b6+beta)) ;
pc7 = exp(b7+beta)/(1+exp(b7+beta)) ;
pc8 = exp(b8+beta)/(1+exp(b8+beta)) ;
pc9 = 1;
p   = if (cat==2) then pc2-pc1 else
      if (cat==3) then pc3-pc2 else
      if (cat==4) then pc4-pc3 else
      if (cat==5) then pc5-pc4 else
      if (cat==6) then pc6-pc5 else
      if (cat==7) then pc7-pc6 else
      if (cat==8) then pc8-pc7 else
      if (cat==9) then pc9-pc8 else
      pc1
fi fi fi fi fi fi fi fi;
y = 52*p;
v = 52*p;
end 
----------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "nltypes.h"
#include "nlcodes.h"
#include "nlmacros.h"
#include "nlfonc.h"

short int calcf_(nbt, nbg, nbl, nbc, t, g, x, f, df, le, ie)
      short int nbt, nbg, nbl, nbc;
      double *t, *g, **x, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
double a[18], da[18][11];
ECRTRACE("calcf");
for (i=0; i<nbl; i++)
  {
    res= ((x[i][1]) == ((double)1)) ? (t[8]) : (
      ((x[i][1]) == ((double)2)) ? (t[9]) : (((
      x[i][1]) == ((double)3)) ? (t[10]) : (((-(
      t[8])) - (t[9])) - (t[10]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[0]= res;
    res= mydiv((double)myexp((t[0]) + (a[0])), (
      (double)1) + ((double)myexp((t[0]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[1]= res;
    res= (double)1;
    a[2]= res;
    res= (t[0]) + ((double)myexp(t[1]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[3]= res;
    res= mydiv((double)myexp((a[3]) + (a[0])), (
      (double)1) + ((double)myexp((a[3]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[4]= res;
    res= (a[3]) + ((double)myexp(t[2]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[5]= res;
    res= mydiv((double)myexp((a[5]) + (a[0])), (
      (double)1) + ((double)myexp((a[5]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[6]= res;
    res= (a[5]) + ((double)myexp(t[3]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[7]= res;
    res= mydiv((double)myexp((a[7]) + (a[0])), (
      (double)1) + ((double)myexp((a[7]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[8]= res;
    res= (a[7]) + ((double)myexp(t[4]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[9]= res;
    res= mydiv((double)myexp((a[9]) + (a[0])), (
      (double)1) + ((double)myexp((a[9]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[10]= res;
    res= (a[9]) + ((double)myexp(t[5]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[11]= res;
    res= mydiv((double)myexp((a[11]) + (a[0])), (
      (double)1) + ((double)myexp((a[11]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[12]= res;
    res= (a[11]) + ((double)myexp(t[6]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[13]= res;
    res= mydiv((double)myexp((a[13]) + (a[0])), (
      (double)1) + ((double)myexp((a[13]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[14]= res;
    res= (a[13]) + ((double)myexp(t[7]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[15]= res;
    res= mydiv((double)myexp((a[15]) + (a[0])), (
      (double)1) + ((double)myexp((a[15]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[16]= res;
    res= ((x[i][0]) == ((double)2)) ? ((a[4]) - (
      a[1])) : (((x[i][0]) == ((double)3)) ? ((
      a[6]) - (a[4])) : (((x[i][0]) == (
      (double)4)) ? ((a[8]) - (a[6])) : (((x[i][0]) == (
      (double)5)) ? ((a[10]) - (a[8])) : (((x[i][0]) == (
      (double)6)) ? ((a[12]) - (a[10])) : (((x[i][0]) == (
      (double)7)) ? ((a[14]) - (a[12])) : (((x[i][0]) == (
      (double)8)) ? ((a[16]) - (a[14])) : (((x[i][0]) == (
      (double)9)) ? ((a[2]) - (a[16])) : (a[1]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[17]= res;
    res= ((double)52) * (a[17]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=F;
        return(ERRMATH);
      }
    f[i]= res;
    res= (double)0;
    da[0][0]= res;
    res= (double)0;
    da[0][1]= res;
    res= (double)0;
    da[0][2]= res;
    res= (double)0;
    da[0][3]= res;
    res= (double)0;
    da[0][4]= res;
    res= (double)0;
    da[0][5]= res;
    res= (double)0;
    da[0][6]= res;
    res= (double)0;
    da[0][7]= res;
    res= ((x[i][1]) == ((double)1)) ? (
      (double)1) : (((x[i][1]) == (
      (double)2)) ? ((double)0) : (((x[i][1]) == (
      (double)3)) ? ((double)0) : (
      (double)-1)));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][8]= res;
    res= ((x[i][1]) == ((double)1)) ? (
      (double)0) : (((x[i][1]) == (
      (double)2)) ? ((double)1) : (((x[i][1]) == (
      (double)3)) ? ((double)0) : (-(
      (double)1))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][9]= res;
    res= ((x[i][1]) == ((double)1)) ? (
      (double)0) : (((x[i][1]) == (
      (double)2)) ? ((double)0) : (((x[i][1]) == (
      (double)3)) ? ((double)1) : (-(
      (double)1))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][10]= res;
    res= mydiv((((((double)1) + (da[0][0])) * ((double)myexp(
      (t[0]) + (a[0])))) * (((double)1) + ((double)myexp(
      (t[0]) + (a[0]))))) - (((double)myexp((t[0]) + (a[0]))) * (
      (((double)1) + (da[0][0])) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][0]= res;
    res= mydiv((((da[0][1]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][1]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][1]= res;
    res= mydiv((((da[0][2]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][2]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][2]= res;
    res= mydiv((((da[0][3]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][3]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][3]= res;
    res= mydiv((((da[0][4]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][4]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][4]= res;
    res= mydiv((((da[0][5]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][5]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][5]= res;
    res= mydiv((((da[0][6]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][6]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][6]= res;
    res= mydiv((((da[0][7]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][7]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][7]= res;
    res= mydiv((((da[0][8]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][8]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][8]= res;
    res= mydiv((((da[0][9]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][9]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][9]= res;
    res= mydiv((((da[0][10]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][10]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][10]= res;
    res= (double)0;
    da[2][0]= res;
    res= (double)0;
    da[2][1]= res;
    res= (double)0;
    da[2][2]= res;
    res= (double)0;
    da[2][3]= res;
    res= (double)0;
    da[2][4]= res;
    res= (double)0;
    da[2][5]= res;
    res= (double)0;
    da[2][6]= res;
    res= (double)0;
    da[2][7]= res;
    res= (double)0;
    da[2][8]= res;
    res= (double)0;
    da[2][9]= res;
    res= (double)0;
    da[2][10]= res;
    res= (double)1;
    da[3][0]= res;
    res= (double)myexp(t[1]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[3][1]= res;
    res= (double)0;
    da[3][2]= res;
    res= (double)0;
    da[3][3]= res;
    res= (double)0;
    da[3][4]= res;
    res= (double)0;
    da[3][5]= res;
    res= (double)0;
    da[3][6]= res;
    res= (double)0;
    da[3][7]= res;
    res= (double)0;
    da[3][8]= res;
    res= (double)0;
    da[3][9]= res;
    res= (double)0;
    da[3][10]= res;
    res= mydiv(((((da[3][0]) + (da[0][0])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][0]) + (da[0][0])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][0]= res;
    res= mydiv(((((da[3][1]) + (da[0][1])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][1]) + (da[0][1])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][1]= res;
    res= mydiv(((((da[3][2]) + (da[0][2])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][2]) + (da[0][2])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][2]= res;
    res= mydiv(((((da[3][3]) + (da[0][3])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][3]) + (da[0][3])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][3]= res;
    res= mydiv(((((da[3][4]) + (da[0][4])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][4]) + (da[0][4])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][4]= res;
    res= mydiv(((((da[3][5]) + (da[0][5])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][5]) + (da[0][5])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][5]= res;
    res= mydiv(((((da[3][6]) + (da[0][6])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][6]) + (da[0][6])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][6]= res;
    res= mydiv(((((da[3][7]) + (da[0][7])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][7]) + (da[0][7])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][7]= res;
    res= mydiv(((((da[3][8]) + (da[0][8])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][8]) + (da[0][8])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][8]= res;
    res= mydiv(((((da[3][9]) + (da[0][9])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][9]) + (da[0][9])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][9]= res;
    res= mydiv(((((da[3][10]) + (da[0][10])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][10]) + (da[0][10])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][10]= res;
    res= da[3][0];
    da[5][0]= res;
    res= da[3][1];
    da[5][1]= res;
    res= (da[3][2]) + ((double)myexp(t[2]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[5][2]= res;
    res= da[3][3];
    da[5][3]= res;
    res= da[3][4];
    da[5][4]= res;
    res= da[3][5];
    da[5][5]= res;
    res= da[3][6];
    da[5][6]= res;
    res= da[3][7];
    da[5][7]= res;
    res= da[3][8];
    da[5][8]= res;
    res= da[3][9];
    da[5][9]= res;
    res= da[3][10];
    da[5][10]= res;
    res= mydiv(((((da[5][0]) + (da[0][0])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][0]) + (da[0][0])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][0]= res;
    res= mydiv(((((da[5][1]) + (da[0][1])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][1]) + (da[0][1])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][1]= res;
    res= mydiv(((((da[5][2]) + (da[0][2])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][2]) + (da[0][2])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][2]= res;
    res= mydiv(((((da[5][3]) + (da[0][3])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][3]) + (da[0][3])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][3]= res;
    res= mydiv(((((da[5][4]) + (da[0][4])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][4]) + (da[0][4])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][4]= res;
    res= mydiv(((((da[5][5]) + (da[0][5])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][5]) + (da[0][5])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][5]= res;
    res= mydiv(((((da[5][6]) + (da[0][6])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][6]) + (da[0][6])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][6]= res;
    res= mydiv(((((da[5][7]) + (da[0][7])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][7]) + (da[0][7])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][7]= res;
    res= mydiv(((((da[5][8]) + (da[0][8])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][8]) + (da[0][8])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][8]= res;
    res= mydiv(((((da[5][9]) + (da[0][9])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][9]) + (da[0][9])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][9]= res;
    res= mydiv(((((da[5][10]) + (da[0][10])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][10]) + (da[0][10])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][10]= res;
    res= da[5][0];
    da[7][0]= res;
    res= da[5][1];
    da[7][1]= res;
    res= da[5][2];
    da[7][2]= res;
    res= (da[5][3]) + ((double)myexp(t[3]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[7][3]= res;
    res= da[5][4];
    da[7][4]= res;
    res= da[5][5];
    da[7][5]= res;
    res= da[5][6];
    da[7][6]= res;
    res= da[5][7];
    da[7][7]= res;
    res= da[5][8];
    da[7][8]= res;
    res= da[5][9];
    da[7][9]= res;
    res= da[5][10];
    da[7][10]= res;
    res= mydiv(((((da[7][0]) + (da[0][0])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][0]) + (da[0][0])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][0]= res;
    res= mydiv(((((da[7][1]) + (da[0][1])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][1]) + (da[0][1])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][1]= res;
    res= mydiv(((((da[7][2]) + (da[0][2])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][2]) + (da[0][2])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][2]= res;
    res= mydiv(((((da[7][3]) + (da[0][3])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][3]) + (da[0][3])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][3]= res;
    res= mydiv(((((da[7][4]) + (da[0][4])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][4]) + (da[0][4])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][4]= res;
    res= mydiv(((((da[7][5]) + (da[0][5])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][5]) + (da[0][5])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][5]= res;
    res= mydiv(((((da[7][6]) + (da[0][6])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][6]) + (da[0][6])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][6]= res;
    res= mydiv(((((da[7][7]) + (da[0][7])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][7]) + (da[0][7])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][7]= res;
    res= mydiv(((((da[7][8]) + (da[0][8])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][8]) + (da[0][8])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][8]= res;
    res= mydiv(((((da[7][9]) + (da[0][9])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][9]) + (da[0][9])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][9]= res;
    res= mydiv(((((da[7][10]) + (da[0][10])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][10]) + (da[0][10])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][10]= res;
    res= da[7][0];
    da[9][0]= res;
    res= da[7][1];
    da[9][1]= res;
    res= da[7][2];
    da[9][2]= res;
    res= da[7][3];
    da[9][3]= res;
    res= (da[7][4]) + ((double)myexp(t[4]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[9][4]= res;
    res= da[7][5];
    da[9][5]= res;
    res= da[7][6];
    da[9][6]= res;
    res= da[7][7];
    da[9][7]= res;
    res= da[7][8];
    da[9][8]= res;
    res= da[7][9];
    da[9][9]= res;
    res= da[7][10];
    da[9][10]= res;
    res= mydiv(((((da[9][0]) + (da[0][0])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][0]) + (da[0][0])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][0]= res;
    res= mydiv(((((da[9][1]) + (da[0][1])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][1]) + (da[0][1])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][1]= res;
    res= mydiv(((((da[9][2]) + (da[0][2])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][2]) + (da[0][2])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][2]= res;
    res= mydiv(((((da[9][3]) + (da[0][3])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][3]) + (da[0][3])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][3]= res;
    res= mydiv(((((da[9][4]) + (da[0][4])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][4]) + (da[0][4])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][4]= res;
    res= mydiv(((((da[9][5]) + (da[0][5])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][5]) + (da[0][5])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][5]= res;
    res= mydiv(((((da[9][6]) + (da[0][6])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][6]) + (da[0][6])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][6]= res;
    res= mydiv(((((da[9][7]) + (da[0][7])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][7]) + (da[0][7])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][7]= res;
    res= mydiv(((((da[9][8]) + (da[0][8])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][8]) + (da[0][8])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][8]= res;
    res= mydiv(((((da[9][9]) + (da[0][9])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][9]) + (da[0][9])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][9]= res;
    res= mydiv(((((da[9][10]) + (da[0][10])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][10]) + (da[0][10])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][10]= res;
    res= da[9][0];
    da[11][0]= res;
    res= da[9][1];
    da[11][1]= res;
    res= da[9][2];
    da[11][2]= res;
    res= da[9][3];
    da[11][3]= res;
    res= da[9][4];
    da[11][4]= res;
    res= (da[9][5]) + ((double)myexp(t[5]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[11][5]= res;
    res= da[9][6];
    da[11][6]= res;
    res= da[9][7];
    da[11][7]= res;
    res= da[9][8];
    da[11][8]= res;
    res= da[9][9];
    da[11][9]= res;
    res= da[9][10];
    da[11][10]= res;
    res= mydiv(((((da[11][0]) + (da[0][0])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][0]) + (da[0][0])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][0]= res;
    res= mydiv(((((da[11][1]) + (da[0][1])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][1]) + (da[0][1])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][1]= res;
    res= mydiv(((((da[11][2]) + (da[0][2])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][2]) + (da[0][2])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][2]= res;
    res= mydiv(((((da[11][3]) + (da[0][3])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][3]) + (da[0][3])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][3]= res;
    res= mydiv(((((da[11][4]) + (da[0][4])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][4]) + (da[0][4])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][4]= res;
    res= mydiv(((((da[11][5]) + (da[0][5])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][5]) + (da[0][5])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][5]= res;
    res= mydiv(((((da[11][6]) + (da[0][6])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][6]) + (da[0][6])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][6]= res;
    res= mydiv(((((da[11][7]) + (da[0][7])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][7]) + (da[0][7])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][7]= res;
    res= mydiv(((((da[11][8]) + (da[0][8])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][8]) + (da[0][8])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][8]= res;
    res= mydiv(((((da[11][9]) + (da[0][9])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][9]) + (da[0][9])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][9]= res;
    res= mydiv(((((da[11][10]) + (da[0][10])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][10]) + (da[0][10])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][10]= res;
    res= da[11][0];
    da[13][0]= res;
    res= da[11][1];
    da[13][1]= res;
    res= da[11][2];
    da[13][2]= res;
    res= da[11][3];
    da[13][3]= res;
    res= da[11][4];
    da[13][4]= res;
    res= da[11][5];
    da[13][5]= res;
    res= (da[11][6]) + ((double)myexp(t[6]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[13][6]= res;
    res= da[11][7];
    da[13][7]= res;
    res= da[11][8];
    da[13][8]= res;
    res= da[11][9];
    da[13][9]= res;
    res= da[11][10];
    da[13][10]= res;
    res= mydiv(((((da[13][0]) + (da[0][0])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][0]) + (da[0][0])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][0]= res;
    res= mydiv(((((da[13][1]) + (da[0][1])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][1]) + (da[0][1])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][1]= res;
    res= mydiv(((((da[13][2]) + (da[0][2])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][2]) + (da[0][2])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][2]= res;
    res= mydiv(((((da[13][3]) + (da[0][3])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][3]) + (da[0][3])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][3]= res;
    res= mydiv(((((da[13][4]) + (da[0][4])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][4]) + (da[0][4])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][4]= res;
    res= mydiv(((((da[13][5]) + (da[0][5])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][5]) + (da[0][5])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][5]= res;
    res= mydiv(((((da[13][6]) + (da[0][6])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][6]) + (da[0][6])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][6]= res;
    res= mydiv(((((da[13][7]) + (da[0][7])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][7]) + (da[0][7])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][7]= res;
    res= mydiv(((((da[13][8]) + (da[0][8])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][8]) + (da[0][8])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][8]= res;
    res= mydiv(((((da[13][9]) + (da[0][9])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][9]) + (da[0][9])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][9]= res;
    res= mydiv(((((da[13][10]) + (da[0][10])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][10]) + (da[0][10])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][10]= res;
    res= da[13][0];
    da[15][0]= res;
    res= da[13][1];
    da[15][1]= res;
    res= da[13][2];
    da[15][2]= res;
    res= da[13][3];
    da[15][3]= res;
    res= da[13][4];
    da[15][4]= res;
    res= da[13][5];
    da[15][5]= res;
    res= da[13][6];
    da[15][6]= res;
    res= (da[13][7]) + ((double)myexp(t[7]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[15][7]= res;
    res= da[13][8];
    da[15][8]= res;
    res= da[13][9];
    da[15][9]= res;
    res= da[13][10];
    da[15][10]= res;
    res= mydiv(((((da[15][0]) + (da[0][0])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][0]) + (da[0][0])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][0]= res;
    res= mydiv(((((da[15][1]) + (da[0][1])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][1]) + (da[0][1])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][1]= res;
    res= mydiv(((((da[15][2]) + (da[0][2])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][2]) + (da[0][2])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][2]= res;
    res= mydiv(((((da[15][3]) + (da[0][3])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][3]) + (da[0][3])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][3]= res;
    res= mydiv(((((da[15][4]) + (da[0][4])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][4]) + (da[0][4])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][4]= res;
    res= mydiv(((((da[15][5]) + (da[0][5])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][5]) + (da[0][5])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][5]= res;
    res= mydiv(((((da[15][6]) + (da[0][6])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][6]) + (da[0][6])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][6]= res;
    res= mydiv(((((da[15][7]) + (da[0][7])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][7]) + (da[0][7])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][7]= res;
    res= mydiv(((((da[15][8]) + (da[0][8])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][8]) + (da[0][8])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][8]= res;
    res= mydiv(((((da[15][9]) + (da[0][9])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][9]) + (da[0][9])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][9]= res;
    res= mydiv(((((da[15][10]) + (da[0][10])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][10]) + (da[0][10])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][10]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][0]) - (
      da[1][0])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][0]) - (da[4][0])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][0]) - (da[6][0])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][0]) - (
      da[8][0])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][0]) - (da[10][0])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][0]) - (da[12][0])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][0]) - (
      da[14][0])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][0]) - (da[16][0])) : (da[1][0]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][0]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][1]) - (
      da[1][1])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][1]) - (da[4][1])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][1]) - (da[6][1])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][1]) - (
      da[8][1])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][1]) - (da[10][1])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][1]) - (da[12][1])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][1]) - (
      da[14][1])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][1]) - (da[16][1])) : (da[1][1]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][1]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][2]) - (
      da[1][2])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][2]) - (da[4][2])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][2]) - (da[6][2])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][2]) - (
      da[8][2])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][2]) - (da[10][2])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][2]) - (da[12][2])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][2]) - (
      da[14][2])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][2]) - (da[16][2])) : (da[1][2]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][2]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][3]) - (
      da[1][3])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][3]) - (da[4][3])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][3]) - (da[6][3])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][3]) - (
      da[8][3])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][3]) - (da[10][3])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][3]) - (da[12][3])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][3]) - (
      da[14][3])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][3]) - (da[16][3])) : (da[1][3]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][3]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][4]) - (
      da[1][4])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][4]) - (da[4][4])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][4]) - (da[6][4])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][4]) - (
      da[8][4])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][4]) - (da[10][4])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][4]) - (da[12][4])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][4]) - (
      da[14][4])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][4]) - (da[16][4])) : (da[1][4]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][4]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][5]) - (
      da[1][5])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][5]) - (da[4][5])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][5]) - (da[6][5])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][5]) - (
      da[8][5])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][5]) - (da[10][5])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][5]) - (da[12][5])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][5]) - (
      da[14][5])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][5]) - (da[16][5])) : (da[1][5]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][5]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][6]) - (
      da[1][6])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][6]) - (da[4][6])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][6]) - (da[6][6])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][6]) - (
      da[8][6])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][6]) - (da[10][6])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][6]) - (da[12][6])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][6]) - (
      da[14][6])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][6]) - (da[16][6])) : (da[1][6]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][6]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][7]) - (
      da[1][7])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][7]) - (da[4][7])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][7]) - (da[6][7])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][7]) - (
      da[8][7])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][7]) - (da[10][7])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][7]) - (da[12][7])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][7]) - (
      da[14][7])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][7]) - (da[16][7])) : (da[1][7]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][7]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][8]) - (
      da[1][8])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][8]) - (da[4][8])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][8]) - (da[6][8])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][8]) - (
      da[8][8])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][8]) - (da[10][8])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][8]) - (da[12][8])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][8]) - (
      da[14][8])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][8]) - (da[16][8])) : (da[1][8]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][8]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][9]) - (
      da[1][9])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][9]) - (da[4][9])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][9]) - (da[6][9])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][9]) - (
      da[8][9])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][9]) - (da[10][9])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][9]) - (da[12][9])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][9]) - (
      da[14][9])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][9]) - (da[16][9])) : (da[1][9]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][9]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][10]) - (
      da[1][10])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][10]) - (da[4][10])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][10]) - (da[6][10])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][10]) - (
      da[8][10])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][10]) - (da[10][10])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][10]) - (da[12][10])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][10]) - (
      da[14][10])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][10]) - (da[16][10])) : (da[1][10]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][10]= res;
    res= ((double)52) * (da[17][0]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][0]= res;
    res= ((double)52) * (da[17][1]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][1]= res;
    res= ((double)52) * (da[17][2]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][2]= res;
    res= ((double)52) * (da[17][3]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][3]= res;
    res= ((double)52) * (da[17][4]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][4]= res;
    res= ((double)52) * (da[17][5]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][5]= res;
    res= ((double)52) * (da[17][6]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][6]= res;
    res= ((double)52) * (da[17][7]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][7]= res;
    res= ((double)52) * (da[17][8]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][8]= res;
    res= ((double)52) * (da[17][9]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][9]= res;
    res= ((double)52) * (da[17][10]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][10]= res;
  }
return(OK);
}

short int calcv_(nbt, nbb, nbg, nbl, nbc, t, b, g,
                f, df, x, v, dtv, dbv, le, ie)
      short int nbt, nbb, nbg, nbl, nbc;
      double *t, *b, *g, **x, *v, **dtv, **dbv, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
double a[18], da[18][11];
ECRTRACE("calcv");
for (i=0; i<nbl; i++)
  {
    res= ((x[i][1]) == ((double)1)) ? (t[8]) : (
      ((x[i][1]) == ((double)2)) ? (t[9]) : (((
      x[i][1]) == ((double)3)) ? (t[10]) : (((-(
      t[8])) - (t[9])) - (t[10]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[0]= res;
    res= mydiv((double)myexp((t[0]) + (a[0])), (
      (double)1) + ((double)myexp((t[0]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[1]= res;
    res= (double)1;
    a[2]= res;
    res= (t[0]) + ((double)myexp(t[1]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[3]= res;
    res= mydiv((double)myexp((a[3]) + (a[0])), (
      (double)1) + ((double)myexp((a[3]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[4]= res;
    res= (a[3]) + ((double)myexp(t[2]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[5]= res;
    res= mydiv((double)myexp((a[5]) + (a[0])), (
      (double)1) + ((double)myexp((a[5]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[6]= res;
    res= (a[5]) + ((double)myexp(t[3]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[7]= res;
    res= mydiv((double)myexp((a[7]) + (a[0])), (
      (double)1) + ((double)myexp((a[7]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[8]= res;
    res= (a[7]) + ((double)myexp(t[4]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[9]= res;
    res= mydiv((double)myexp((a[9]) + (a[0])), (
      (double)1) + ((double)myexp((a[9]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[10]= res;
    res= (a[9]) + ((double)myexp(t[5]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[11]= res;
    res= mydiv((double)myexp((a[11]) + (a[0])), (
      (double)1) + ((double)myexp((a[11]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[12]= res;
    res= (a[11]) + ((double)myexp(t[6]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[13]= res;
    res= mydiv((double)myexp((a[13]) + (a[0])), (
      (double)1) + ((double)myexp((a[13]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[14]= res;
    res= (a[13]) + ((double)myexp(t[7]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[15]= res;
    res= mydiv((double)myexp((a[15]) + (a[0])), (
      (double)1) + ((double)myexp((a[15]) + (a[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[16]= res;
    res= ((x[i][0]) == ((double)2)) ? ((a[4]) - (
      a[1])) : (((x[i][0]) == ((double)3)) ? ((
      a[6]) - (a[4])) : (((x[i][0]) == (
      (double)4)) ? ((a[8]) - (a[6])) : (((x[i][0]) == (
      (double)5)) ? ((a[10]) - (a[8])) : (((x[i][0]) == (
      (double)6)) ? ((a[12]) - (a[10])) : (((x[i][0]) == (
      (double)7)) ? ((a[14]) - (a[12])) : (((x[i][0]) == (
      (double)8)) ? ((a[16]) - (a[14])) : (((x[i][0]) == (
      (double)9)) ? ((a[2]) - (a[16])) : (a[1]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[17]= res;
    res= ((double)52) * (a[17]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=V;
        return(ERRMATH);
      }
    v[i]= res;
    res= (double)0;
    da[0][0]= res;
    res= (double)0;
    da[0][1]= res;
    res= (double)0;
    da[0][2]= res;
    res= (double)0;
    da[0][3]= res;
    res= (double)0;
    da[0][4]= res;
    res= (double)0;
    da[0][5]= res;
    res= (double)0;
    da[0][6]= res;
    res= (double)0;
    da[0][7]= res;
    res= ((x[i][1]) == ((double)1)) ? (
      (double)1) : (((x[i][1]) == (
      (double)2)) ? ((double)0) : (((x[i][1]) == (
      (double)3)) ? ((double)0) : (
      (double)-1)));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][8]= res;
    res= ((x[i][1]) == ((double)1)) ? (
      (double)0) : (((x[i][1]) == (
      (double)2)) ? ((double)1) : (((x[i][1]) == (
      (double)3)) ? ((double)0) : (-(
      (double)1))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][9]= res;
    res= ((x[i][1]) == ((double)1)) ? (
      (double)0) : (((x[i][1]) == (
      (double)2)) ? ((double)0) : (((x[i][1]) == (
      (double)3)) ? ((double)1) : (-(
      (double)1))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][10]= res;
    res= mydiv((((((double)1) + (da[0][0])) * ((double)myexp(
      (t[0]) + (a[0])))) * (((double)1) + ((double)myexp(
      (t[0]) + (a[0]))))) - (((double)myexp((t[0]) + (a[0]))) * (
      (((double)1) + (da[0][0])) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][0]= res;
    res= mydiv((((da[0][1]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][1]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][1]= res;
    res= mydiv((((da[0][2]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][2]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][2]= res;
    res= mydiv((((da[0][3]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][3]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][3]= res;
    res= mydiv((((da[0][4]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][4]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][4]= res;
    res= mydiv((((da[0][5]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][5]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][5]= res;
    res= mydiv((((da[0][6]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][6]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][6]= res;
    res= mydiv((((da[0][7]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][7]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][7]= res;
    res= mydiv((((da[0][8]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][8]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][8]= res;
    res= mydiv((((da[0][9]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][9]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][9]= res;
    res= mydiv((((da[0][10]) * ((double)myexp((t[0]) + (a[0])))) * (
      ((double)1) + ((double)myexp((t[0]) + (a[0]))))) - (
      ((double)myexp((t[0]) + (a[0]))) * ((da[0][10]) * ((double)myexp(
      (t[0]) + (a[0]))))), mypow(((double)1) + (
      (double)myexp((t[0]) + (a[0]))), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][10]= res;
    res= (double)0;
    da[2][0]= res;
    res= (double)0;
    da[2][1]= res;
    res= (double)0;
    da[2][2]= res;
    res= (double)0;
    da[2][3]= res;
    res= (double)0;
    da[2][4]= res;
    res= (double)0;
    da[2][5]= res;
    res= (double)0;
    da[2][6]= res;
    res= (double)0;
    da[2][7]= res;
    res= (double)0;
    da[2][8]= res;
    res= (double)0;
    da[2][9]= res;
    res= (double)0;
    da[2][10]= res;
    res= (double)1;
    da[3][0]= res;
    res= (double)myexp(t[1]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[3][1]= res;
    res= (double)0;
    da[3][2]= res;
    res= (double)0;
    da[3][3]= res;
    res= (double)0;
    da[3][4]= res;
    res= (double)0;
    da[3][5]= res;
    res= (double)0;
    da[3][6]= res;
    res= (double)0;
    da[3][7]= res;
    res= (double)0;
    da[3][8]= res;
    res= (double)0;
    da[3][9]= res;
    res= (double)0;
    da[3][10]= res;
    res= mydiv(((((da[3][0]) + (da[0][0])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][0]) + (da[0][0])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][0]= res;
    res= mydiv(((((da[3][1]) + (da[0][1])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][1]) + (da[0][1])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][1]= res;
    res= mydiv(((((da[3][2]) + (da[0][2])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][2]) + (da[0][2])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][2]= res;
    res= mydiv(((((da[3][3]) + (da[0][3])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][3]) + (da[0][3])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][3]= res;
    res= mydiv(((((da[3][4]) + (da[0][4])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][4]) + (da[0][4])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][4]= res;
    res= mydiv(((((da[3][5]) + (da[0][5])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][5]) + (da[0][5])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][5]= res;
    res= mydiv(((((da[3][6]) + (da[0][6])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][6]) + (da[0][6])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][6]= res;
    res= mydiv(((((da[3][7]) + (da[0][7])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][7]) + (da[0][7])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][7]= res;
    res= mydiv(((((da[3][8]) + (da[0][8])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][8]) + (da[0][8])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][8]= res;
    res= mydiv(((((da[3][9]) + (da[0][9])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][9]) + (da[0][9])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][9]= res;
    res= mydiv(((((da[3][10]) + (da[0][10])) * ((double)myexp(
      (a[3]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[3]) + (a[0]))))) - (((double)myexp((a[3]) + (a[0]))) * (
      ((da[3][10]) + (da[0][10])) * ((double)myexp((a[3]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[3]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[4][10]= res;
    res= da[3][0];
    da[5][0]= res;
    res= da[3][1];
    da[5][1]= res;
    res= (da[3][2]) + ((double)myexp(t[2]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[5][2]= res;
    res= da[3][3];
    da[5][3]= res;
    res= da[3][4];
    da[5][4]= res;
    res= da[3][5];
    da[5][5]= res;
    res= da[3][6];
    da[5][6]= res;
    res= da[3][7];
    da[5][7]= res;
    res= da[3][8];
    da[5][8]= res;
    res= da[3][9];
    da[5][9]= res;
    res= da[3][10];
    da[5][10]= res;
    res= mydiv(((((da[5][0]) + (da[0][0])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][0]) + (da[0][0])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][0]= res;
    res= mydiv(((((da[5][1]) + (da[0][1])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][1]) + (da[0][1])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][1]= res;
    res= mydiv(((((da[5][2]) + (da[0][2])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][2]) + (da[0][2])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][2]= res;
    res= mydiv(((((da[5][3]) + (da[0][3])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][3]) + (da[0][3])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][3]= res;
    res= mydiv(((((da[5][4]) + (da[0][4])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][4]) + (da[0][4])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][4]= res;
    res= mydiv(((((da[5][5]) + (da[0][5])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][5]) + (da[0][5])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][5]= res;
    res= mydiv(((((da[5][6]) + (da[0][6])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][6]) + (da[0][6])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][6]= res;
    res= mydiv(((((da[5][7]) + (da[0][7])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][7]) + (da[0][7])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][7]= res;
    res= mydiv(((((da[5][8]) + (da[0][8])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][8]) + (da[0][8])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][8]= res;
    res= mydiv(((((da[5][9]) + (da[0][9])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][9]) + (da[0][9])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][9]= res;
    res= mydiv(((((da[5][10]) + (da[0][10])) * ((double)myexp(
      (a[5]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[5]) + (a[0]))))) - (((double)myexp((a[5]) + (a[0]))) * (
      ((da[5][10]) + (da[0][10])) * ((double)myexp((a[5]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[5]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[6][10]= res;
    res= da[5][0];
    da[7][0]= res;
    res= da[5][1];
    da[7][1]= res;
    res= da[5][2];
    da[7][2]= res;
    res= (da[5][3]) + ((double)myexp(t[3]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[7][3]= res;
    res= da[5][4];
    da[7][4]= res;
    res= da[5][5];
    da[7][5]= res;
    res= da[5][6];
    da[7][6]= res;
    res= da[5][7];
    da[7][7]= res;
    res= da[5][8];
    da[7][8]= res;
    res= da[5][9];
    da[7][9]= res;
    res= da[5][10];
    da[7][10]= res;
    res= mydiv(((((da[7][0]) + (da[0][0])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][0]) + (da[0][0])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][0]= res;
    res= mydiv(((((da[7][1]) + (da[0][1])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][1]) + (da[0][1])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][1]= res;
    res= mydiv(((((da[7][2]) + (da[0][2])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][2]) + (da[0][2])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][2]= res;
    res= mydiv(((((da[7][3]) + (da[0][3])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][3]) + (da[0][3])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][3]= res;
    res= mydiv(((((da[7][4]) + (da[0][4])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][4]) + (da[0][4])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][4]= res;
    res= mydiv(((((da[7][5]) + (da[0][5])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][5]) + (da[0][5])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][5]= res;
    res= mydiv(((((da[7][6]) + (da[0][6])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][6]) + (da[0][6])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][6]= res;
    res= mydiv(((((da[7][7]) + (da[0][7])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][7]) + (da[0][7])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][7]= res;
    res= mydiv(((((da[7][8]) + (da[0][8])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][8]) + (da[0][8])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][8]= res;
    res= mydiv(((((da[7][9]) + (da[0][9])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][9]) + (da[0][9])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][9]= res;
    res= mydiv(((((da[7][10]) + (da[0][10])) * ((double)myexp(
      (a[7]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[7]) + (a[0]))))) - (((double)myexp((a[7]) + (a[0]))) * (
      ((da[7][10]) + (da[0][10])) * ((double)myexp((a[7]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[7]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[8][10]= res;
    res= da[7][0];
    da[9][0]= res;
    res= da[7][1];
    da[9][1]= res;
    res= da[7][2];
    da[9][2]= res;
    res= da[7][3];
    da[9][3]= res;
    res= (da[7][4]) + ((double)myexp(t[4]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[9][4]= res;
    res= da[7][5];
    da[9][5]= res;
    res= da[7][6];
    da[9][6]= res;
    res= da[7][7];
    da[9][7]= res;
    res= da[7][8];
    da[9][8]= res;
    res= da[7][9];
    da[9][9]= res;
    res= da[7][10];
    da[9][10]= res;
    res= mydiv(((((da[9][0]) + (da[0][0])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][0]) + (da[0][0])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][0]= res;
    res= mydiv(((((da[9][1]) + (da[0][1])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][1]) + (da[0][1])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][1]= res;
    res= mydiv(((((da[9][2]) + (da[0][2])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][2]) + (da[0][2])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][2]= res;
    res= mydiv(((((da[9][3]) + (da[0][3])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][3]) + (da[0][3])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][3]= res;
    res= mydiv(((((da[9][4]) + (da[0][4])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][4]) + (da[0][4])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][4]= res;
    res= mydiv(((((da[9][5]) + (da[0][5])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][5]) + (da[0][5])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][5]= res;
    res= mydiv(((((da[9][6]) + (da[0][6])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][6]) + (da[0][6])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][6]= res;
    res= mydiv(((((da[9][7]) + (da[0][7])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][7]) + (da[0][7])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][7]= res;
    res= mydiv(((((da[9][8]) + (da[0][8])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][8]) + (da[0][8])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][8]= res;
    res= mydiv(((((da[9][9]) + (da[0][9])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][9]) + (da[0][9])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][9]= res;
    res= mydiv(((((da[9][10]) + (da[0][10])) * ((double)myexp(
      (a[9]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[9]) + (a[0]))))) - (((double)myexp((a[9]) + (a[0]))) * (
      ((da[9][10]) + (da[0][10])) * ((double)myexp((a[9]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[9]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[10][10]= res;
    res= da[9][0];
    da[11][0]= res;
    res= da[9][1];
    da[11][1]= res;
    res= da[9][2];
    da[11][2]= res;
    res= da[9][3];
    da[11][3]= res;
    res= da[9][4];
    da[11][4]= res;
    res= (da[9][5]) + ((double)myexp(t[5]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[11][5]= res;
    res= da[9][6];
    da[11][6]= res;
    res= da[9][7];
    da[11][7]= res;
    res= da[9][8];
    da[11][8]= res;
    res= da[9][9];
    da[11][9]= res;
    res= da[9][10];
    da[11][10]= res;
    res= mydiv(((((da[11][0]) + (da[0][0])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][0]) + (da[0][0])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][0]= res;
    res= mydiv(((((da[11][1]) + (da[0][1])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][1]) + (da[0][1])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][1]= res;
    res= mydiv(((((da[11][2]) + (da[0][2])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][2]) + (da[0][2])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][2]= res;
    res= mydiv(((((da[11][3]) + (da[0][3])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][3]) + (da[0][3])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][3]= res;
    res= mydiv(((((da[11][4]) + (da[0][4])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][4]) + (da[0][4])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][4]= res;
    res= mydiv(((((da[11][5]) + (da[0][5])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][5]) + (da[0][5])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][5]= res;
    res= mydiv(((((da[11][6]) + (da[0][6])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][6]) + (da[0][6])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][6]= res;
    res= mydiv(((((da[11][7]) + (da[0][7])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][7]) + (da[0][7])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][7]= res;
    res= mydiv(((((da[11][8]) + (da[0][8])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][8]) + (da[0][8])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][8]= res;
    res= mydiv(((((da[11][9]) + (da[0][9])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][9]) + (da[0][9])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][9]= res;
    res= mydiv(((((da[11][10]) + (da[0][10])) * ((double)myexp(
      (a[11]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[11]) + (a[0]))))) - (((double)myexp((a[11]) + (a[0]))) * (
      ((da[11][10]) + (da[0][10])) * ((double)myexp((a[11]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[11]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[12][10]= res;
    res= da[11][0];
    da[13][0]= res;
    res= da[11][1];
    da[13][1]= res;
    res= da[11][2];
    da[13][2]= res;
    res= da[11][3];
    da[13][3]= res;
    res= da[11][4];
    da[13][4]= res;
    res= da[11][5];
    da[13][5]= res;
    res= (da[11][6]) + ((double)myexp(t[6]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[13][6]= res;
    res= da[11][7];
    da[13][7]= res;
    res= da[11][8];
    da[13][8]= res;
    res= da[11][9];
    da[13][9]= res;
    res= da[11][10];
    da[13][10]= res;
    res= mydiv(((((da[13][0]) + (da[0][0])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][0]) + (da[0][0])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][0]= res;
    res= mydiv(((((da[13][1]) + (da[0][1])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][1]) + (da[0][1])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][1]= res;
    res= mydiv(((((da[13][2]) + (da[0][2])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][2]) + (da[0][2])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][2]= res;
    res= mydiv(((((da[13][3]) + (da[0][3])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][3]) + (da[0][3])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][3]= res;
    res= mydiv(((((da[13][4]) + (da[0][4])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][4]) + (da[0][4])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][4]= res;
    res= mydiv(((((da[13][5]) + (da[0][5])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][5]) + (da[0][5])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][5]= res;
    res= mydiv(((((da[13][6]) + (da[0][6])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][6]) + (da[0][6])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][6]= res;
    res= mydiv(((((da[13][7]) + (da[0][7])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][7]) + (da[0][7])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][7]= res;
    res= mydiv(((((da[13][8]) + (da[0][8])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][8]) + (da[0][8])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][8]= res;
    res= mydiv(((((da[13][9]) + (da[0][9])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][9]) + (da[0][9])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][9]= res;
    res= mydiv(((((da[13][10]) + (da[0][10])) * ((double)myexp(
      (a[13]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[13]) + (a[0]))))) - (((double)myexp((a[13]) + (a[0]))) * (
      ((da[13][10]) + (da[0][10])) * ((double)myexp((a[13]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[13]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[14][10]= res;
    res= da[13][0];
    da[15][0]= res;
    res= da[13][1];
    da[15][1]= res;
    res= da[13][2];
    da[15][2]= res;
    res= da[13][3];
    da[15][3]= res;
    res= da[13][4];
    da[15][4]= res;
    res= da[13][5];
    da[15][5]= res;
    res= da[13][6];
    da[15][6]= res;
    res= (da[13][7]) + ((double)myexp(t[7]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[15][7]= res;
    res= da[13][8];
    da[15][8]= res;
    res= da[13][9];
    da[15][9]= res;
    res= da[13][10];
    da[15][10]= res;
    res= mydiv(((((da[15][0]) + (da[0][0])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][0]) + (da[0][0])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][0]= res;
    res= mydiv(((((da[15][1]) + (da[0][1])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][1]) + (da[0][1])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][1]= res;
    res= mydiv(((((da[15][2]) + (da[0][2])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][2]) + (da[0][2])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][2]= res;
    res= mydiv(((((da[15][3]) + (da[0][3])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][3]) + (da[0][3])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][3]= res;
    res= mydiv(((((da[15][4]) + (da[0][4])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][4]) + (da[0][4])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][4]= res;
    res= mydiv(((((da[15][5]) + (da[0][5])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][5]) + (da[0][5])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][5]= res;
    res= mydiv(((((da[15][6]) + (da[0][6])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][6]) + (da[0][6])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][6]= res;
    res= mydiv(((((da[15][7]) + (da[0][7])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][7]) + (da[0][7])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][7]= res;
    res= mydiv(((((da[15][8]) + (da[0][8])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][8]) + (da[0][8])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][8]= res;
    res= mydiv(((((da[15][9]) + (da[0][9])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][9]) + (da[0][9])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][9]= res;
    res= mydiv(((((da[15][10]) + (da[0][10])) * ((double)myexp(
      (a[15]) + (a[0])))) * (((double)1) + ((double)myexp(
      (a[15]) + (a[0]))))) - (((double)myexp((a[15]) + (a[0]))) * (
      ((da[15][10]) + (da[0][10])) * ((double)myexp((a[15]) + (
      a[0]))))), mypow(((double)1) + ((double)myexp(
      (a[15]) + (a[0]))), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[16][10]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][0]) - (
      da[1][0])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][0]) - (da[4][0])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][0]) - (da[6][0])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][0]) - (
      da[8][0])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][0]) - (da[10][0])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][0]) - (da[12][0])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][0]) - (
      da[14][0])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][0]) - (da[16][0])) : (da[1][0]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][0]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][1]) - (
      da[1][1])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][1]) - (da[4][1])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][1]) - (da[6][1])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][1]) - (
      da[8][1])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][1]) - (da[10][1])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][1]) - (da[12][1])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][1]) - (
      da[14][1])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][1]) - (da[16][1])) : (da[1][1]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][1]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][2]) - (
      da[1][2])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][2]) - (da[4][2])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][2]) - (da[6][2])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][2]) - (
      da[8][2])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][2]) - (da[10][2])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][2]) - (da[12][2])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][2]) - (
      da[14][2])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][2]) - (da[16][2])) : (da[1][2]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][2]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][3]) - (
      da[1][3])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][3]) - (da[4][3])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][3]) - (da[6][3])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][3]) - (
      da[8][3])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][3]) - (da[10][3])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][3]) - (da[12][3])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][3]) - (
      da[14][3])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][3]) - (da[16][3])) : (da[1][3]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][3]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][4]) - (
      da[1][4])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][4]) - (da[4][4])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][4]) - (da[6][4])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][4]) - (
      da[8][4])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][4]) - (da[10][4])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][4]) - (da[12][4])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][4]) - (
      da[14][4])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][4]) - (da[16][4])) : (da[1][4]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][4]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][5]) - (
      da[1][5])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][5]) - (da[4][5])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][5]) - (da[6][5])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][5]) - (
      da[8][5])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][5]) - (da[10][5])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][5]) - (da[12][5])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][5]) - (
      da[14][5])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][5]) - (da[16][5])) : (da[1][5]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][5]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][6]) - (
      da[1][6])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][6]) - (da[4][6])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][6]) - (da[6][6])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][6]) - (
      da[8][6])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][6]) - (da[10][6])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][6]) - (da[12][6])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][6]) - (
      da[14][6])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][6]) - (da[16][6])) : (da[1][6]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][6]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][7]) - (
      da[1][7])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][7]) - (da[4][7])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][7]) - (da[6][7])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][7]) - (
      da[8][7])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][7]) - (da[10][7])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][7]) - (da[12][7])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][7]) - (
      da[14][7])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][7]) - (da[16][7])) : (da[1][7]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][7]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][8]) - (
      da[1][8])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][8]) - (da[4][8])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][8]) - (da[6][8])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][8]) - (
      da[8][8])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][8]) - (da[10][8])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][8]) - (da[12][8])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][8]) - (
      da[14][8])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][8]) - (da[16][8])) : (da[1][8]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][8]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][9]) - (
      da[1][9])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][9]) - (da[4][9])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][9]) - (da[6][9])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][9]) - (
      da[8][9])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][9]) - (da[10][9])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][9]) - (da[12][9])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][9]) - (
      da[14][9])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][9]) - (da[16][9])) : (da[1][9]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][9]= res;
    res= ((x[i][0]) == ((double)2)) ? ((da[4][10]) - (
      da[1][10])) : (((x[i][0]) == ((double)3)) ? (
      (da[6][10]) - (da[4][10])) : (((x[i][0]) == (
      (double)4)) ? ((da[8][10]) - (da[6][10])) : (
      ((x[i][0]) == ((double)5)) ? ((da[10][10]) - (
      da[8][10])) : (((x[i][0]) == ((double)6)) ? (
      (da[12][10]) - (da[10][10])) : (((x[i][0]) == (
      (double)7)) ? ((da[14][10]) - (da[12][10])) : (
      ((x[i][0]) == ((double)8)) ? ((da[16][10]) - (
      da[14][10])) : (((x[i][0]) == ((double)9)) ? (
      (da[2][10]) - (da[16][10])) : (da[1][10]))))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[17][10]= res;
    res= ((double)52) * (da[17][0]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][0]= res;
    res= ((double)52) * (da[17][1]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][1]= res;
    res= ((double)52) * (da[17][2]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][2]= res;
    res= ((double)52) * (da[17][3]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][3]= res;
    res= ((double)52) * (da[17][4]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][4]= res;
    res= ((double)52) * (da[17][5]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][5]= res;
    res= ((double)52) * (da[17][6]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][6]= res;
    res= ((double)52) * (da[17][7]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][7]= res;
    res= ((double)52) * (da[17][8]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][8]= res;
    res= ((double)52) * (da[17][9]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][9]= res;
    res= ((double)52) * (da[17][10]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][10]= res;
  }
return(OK);
}

calcodes_()
{}

calcjac_()
{}

calcphi_()
{}
