/* ------------------------------------------------------
Example of call to nls2C
 ----------------------------------------------------------- */
#define precision 12 /* Number of significant digits on the written files */
double unevariable ;


/* +++++++++++++++++++++++++++++++++++++++++++++++++++
 includes 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#include "nls2C.h"

/* ------------------------------------------------------------
Calling program
---------------------------------------------------------------*/

int main(argc, argv)
  int argc;
  char *argv[];
{

/* Local variables: */
int i, nparam, iarg, code;
double   *theta, *beta, *res;
char * modelfile;
FILE *filesplus;
char splusfilename[100], splusname[100], dataname[100], objectname[100];
char nominput[100];
TLogic voulusplus = FAUX;
TLogic entree= FAUX;

/* Argument treatement -----------------------------*/

if ((argc < 3) || (argc > 5) || (strncmp(argv[1], "-h",2)==0))
  {
  return(erreur());
  }

iarg=1;
while( iarg< argc)
  {

    if (strncmp(argv[iarg], "-s", 2) ==0)
      {
	if (argc <= iarg)
	  {
	   return(erreur());
	  }
	iarg++;
	strcpy(splusname, argv[iarg]);
	iarg++;
	voulusplus=VRAI;
	continue;
      }


    if (strncmp(argv[iarg], "-i", 2) ==0)
      {
	if (argc <= iarg)
	  {
	   return(erreur());
	  }
	iarg++;
	strcpy(nominput, argv[iarg]);
	iarg++;
	entree=VRAI;
	continue;
      }

    if (strncmp(argv[iarg], "-h",2) ==0)
      {
	erreur(); /* ce n'est pas une erreur mais c'est pour faire ecrire la syntaxe */
      return(OK);
      }



    if (strncmp(argv[iarg], "-",1) ==0)
      {
	return(erreur());
      }
  } /* fin iarg */

if (entree== FAUX)
  return(erreur()); /* pas d'option -i */


/* ------- Calling  nls2C ------------ */
 printf("\n OTER ESSAIMAIN\n");
 unevariable = 10;


if ( (code =nls2C(nominput)) != 0)
  {
  fprintf(stderr,"Fatal error in nls2C, code %d \n", code);
  exit(code);
  }


/* Input print
printf("\n\n\n");
 ecrDonnees(stdout);
ecrCtxPuss(stdout);
ecrCtxNum(stdout);
ecrCrole(stdout);
*/

/* ------- Calling access subroutines --- */
 printf("\nThe structure Model:\n"); /* OTER */
 ecrModele(stdout);
printf(
"\nSome more print to check:\n-------------------------\n");

modelfile = recup1C("file",1);
printf("\nThe name of model-description file: %s\n", modelfile);

/* return the estimated values of the parameters of the last step */
printf("\nValue of the estimated values for 'theta' parameters:\n");
theta=recup1D("theta" , recup0L("n.steps" , 1), &nparam);
for (i=0; i <nparam; i++)
  printf( " %.*g ", precision, theta[i]);
printf( " \n");
nparam = recup0L("n.beta", 1);
if (nparam >0)
  {
    beta=recup1D("beta" , recup0L("n.steps" , 1), &nparam);
    printf("\nValue of the estimated values for 'beta' parameters:\n");
    for (i=0; i <nparam; i++)
      printf( " %.*g ", precision, beta[i]);
    printf( " \n");
  }

/* return of the statistical criterion */
printf("\nValue of the statistical criterion: %g\n", 
       recup0D("stat.crit", 1));

/* return of the type of calculation of the statistical criterion */
printf("\nType of the statistical criterion:\n %s\n",
       recup1C("stat.crit.type",1));

/* return of the type of family */
printf("\nFamily:\n %s\n",
       recup1C("family",1));

/* return of the log  of family */
 printf("\nLog.%s:\n %.*g\n", recup1C("family",1),
       precision, recup0D("logfamily",1));

/* return the deviance */
printf("\nDeviance:\n %.*g\n",precision,
       recup0D("deviance",1));

/* return the dev.residuals */
/*
res=recup1D("dev.residuals" , 1, &nparam);
    printf("\nValue of the deviance residuals:\n");
    for (i=0; i <nparam; i++)
      printf( " %.*g ", precision, res[i]);
    printf( " \n");

*/


if (voulusplus==VRAI)
  {
/* Create a splus file for Splus */
sprintf(splusfilename, "%s.splus", splusname);
if ((filesplus=fopen(splusfilename, "w")) == NULL)
  {
    printf("Cannot open the output splus-file %s\n", splusfilename);
    return(ERRINPUT);
  }

sprintf(objectname, "%s.nls2", splusname);
sprintf(dataname, "%s.data", splusname);

if ((code= splus2C(objectname , dataname, filesplus)) != OK)
  {
    printf("Error in 'splus2C'\n");
    return(ERRINPUT);
  }

if ((code= splusData(dataname , filesplus)) != OK)
  {
    printf("Error in 'splusData'\n");
    return(ERRINPUT);
  }

printf("\n\nThe file '%s' is created:\n",splusfilename);
printf("it contains the Splus (or R) command to create an nls2.object\n");
printf("called %s ", objectname); 
printf( " and a data-frame called %s.\n\n", dataname);

  } /* fin voulusplus */

/* Destruction des structures */
/* delnls2();*/
return(0);
}

/* ------------------------------------------------------------------
Gestion des erreurs d'appel
-------------------------------------------------------------------- */
int erreur()
{

  fprintf(stderr,"Arguments: [ -s[plus] splusfilename ] -i input-file\n");
  return(ERRARG);
}
