/*----------------------------------------
description file: miners.m13314

%  miners.m
%  multinomial  model
resp y; 
varind t, n, cat;
aux p, eta, eta2, eta3; 
var v;
parresp a2,b2,a3,b3;
subroutine;
begin
eta3 = a3 + b3*log(t) ;
eta2 = a2 + b2*log(t) ;
eta  = if (cat==3) then eta3 else
       if (cat==2) then eta2 else
      0
fi fi; 
p = exp(eta)/(1+exp(eta2)+exp(eta3)) ;
y = n*p;
v = n*p;
end 


----------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "nltypes.h"
#include "nlcodes.h"
#include "nlmacros.h"
#include "nlfonc.h"

short int calcf_(nbt, nbg, nbl, nbc, t, g, x, f, df, le, ie)
      short int nbt, nbg, nbl, nbc;
      double *t, *g, **x, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
double a[4], da[4][4];
ECRTRACE("calcf");
for (i=0; i<nbl; i++)
  {
    res= (t[0]) + ((t[1]) * (myln(x[i][0])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[0]= res;
    res= (t[2]) + ((t[3]) * (myln(x[i][0])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[1]= res;
    res= ((x[i][2]) == ((double)3)) ? (a[1]) : (
      ((x[i][2]) == ((double)2)) ? (a[0]) : (
      (double)0));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[2]= res;
    res= mydiv((double)myexp(a[2]), (((double)1) + (
      (double)myexp(a[0]))) + ((double)myexp(a[1])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[3]= res;
    res= (x[i][1]) * (a[3]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=F;
        return(ERRMATH);
      }
    f[i]= res;
    res= (double)1;
    da[0][0]= res;
    res= myln(x[i][0]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][1]= res;
    res= (double)0;
    da[0][2]= res;
    res= (double)0;
    da[0][3]= res;
    res= (double)0;
    da[1][0]= res;
    res= (double)0;
    da[1][1]= res;
    res= (double)1;
    da[1][2]= res;
    res= myln(x[i][0]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][3]= res;
    res= ((x[i][2]) == ((double)3)) ? (da[1][0]) : (
      ((x[i][2]) == ((double)2)) ? (da[0][0]) : (
      (double)0));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][0]= res;
    res= ((x[i][2]) == ((double)3)) ? (da[1][1]) : (
      ((x[i][2]) == ((double)2)) ? (da[0][1]) : (
      (double)0));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][1]= res;
    res= ((x[i][2]) == ((double)3)) ? (da[1][2]) : (
      ((x[i][2]) == ((double)2)) ? (da[0][2]) : (
      (double)0));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][2]= res;
    res= ((x[i][2]) == ((double)3)) ? (da[1][3]) : (
      ((x[i][2]) == ((double)2)) ? (da[0][3]) : (
      (double)0));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][3]= res;
    res= mydiv((((da[2][0]) * ((double)myexp(a[2]))) * (((
      (double)1) + ((double)myexp(a[0]))) + ((double)myexp(
      a[1])))) - (((double)myexp(a[2])) * (((da[0][0]) * (
      (double)myexp(a[0]))) + ((da[1][0]) * ((double)myexp(
      a[1]))))), mypow((((double)1) + ((double)myexp(
      a[0]))) + ((double)myexp(a[1])), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[3][0]= res;
    res= mydiv((((da[2][1]) * ((double)myexp(a[2]))) * (((
      (double)1) + ((double)myexp(a[0]))) + ((double)myexp(
      a[1])))) - (((double)myexp(a[2])) * (((da[0][1]) * (
      (double)myexp(a[0]))) + ((da[1][1]) * ((double)myexp(
      a[1]))))), mypow((((double)1) + ((double)myexp(
      a[0]))) + ((double)myexp(a[1])), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[3][1]= res;
    res= mydiv((((da[2][2]) * ((double)myexp(a[2]))) * (((
      (double)1) + ((double)myexp(a[0]))) + ((double)myexp(
      a[1])))) - (((double)myexp(a[2])) * (((da[0][2]) * (
      (double)myexp(a[0]))) + ((da[1][2]) * ((double)myexp(
      a[1]))))), mypow((((double)1) + ((double)myexp(
      a[0]))) + ((double)myexp(a[1])), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[3][2]= res;
    res= mydiv((((da[2][3]) * ((double)myexp(a[2]))) * (((
      (double)1) + ((double)myexp(a[0]))) + ((double)myexp(
      a[1])))) - (((double)myexp(a[2])) * (((da[0][3]) * (
      (double)myexp(a[0]))) + ((da[1][3]) * ((double)myexp(
      a[1]))))), mypow((((double)1) + ((double)myexp(
      a[0]))) + ((double)myexp(a[1])), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[3][3]= res;
    res= (x[i][1]) * (da[3][0]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][0]= res;
    res= (x[i][1]) * (da[3][1]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][1]= res;
    res= (x[i][1]) * (da[3][2]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][2]= res;
    res= (x[i][1]) * (da[3][3]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][3]= res;
  }
return(OK);
}

short int calcv_(nbt, nbb, nbg, nbl, nbc, t, b, g,
                f, df, x, v, dtv, dbv, le, ie)
      short int nbt, nbb, nbg, nbl, nbc;
      double *t, *b, *g, **x, *v, **dtv, **dbv, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
double a[4], da[4][4];
ECRTRACE("calcv");
for (i=0; i<nbl; i++)
  {
    res= (t[0]) + ((t[1]) * (myln(x[i][0])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[0]= res;
    res= (t[2]) + ((t[3]) * (myln(x[i][0])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[1]= res;
    res= ((x[i][2]) == ((double)3)) ? (a[1]) : (
      ((x[i][2]) == ((double)2)) ? (a[0]) : (
      (double)0));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[2]= res;
    res= mydiv((double)myexp(a[2]), (((double)1) + (
      (double)myexp(a[0]))) + ((double)myexp(a[1])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[3]= res;
    res= (x[i][1]) * (a[3]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=V;
        return(ERRMATH);
      }
    v[i]= res;
    res= (double)1;
    da[0][0]= res;
    res= myln(x[i][0]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][1]= res;
    res= (double)0;
    da[0][2]= res;
    res= (double)0;
    da[0][3]= res;
    res= (double)0;
    da[1][0]= res;
    res= (double)0;
    da[1][1]= res;
    res= (double)1;
    da[1][2]= res;
    res= myln(x[i][0]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[1][3]= res;
    res= ((x[i][2]) == ((double)3)) ? (da[1][0]) : (
      ((x[i][2]) == ((double)2)) ? (da[0][0]) : (
      (double)0));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][0]= res;
    res= ((x[i][2]) == ((double)3)) ? (da[1][1]) : (
      ((x[i][2]) == ((double)2)) ? (da[0][1]) : (
      (double)0));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][1]= res;
    res= ((x[i][2]) == ((double)3)) ? (da[1][2]) : (
      ((x[i][2]) == ((double)2)) ? (da[0][2]) : (
      (double)0));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][2]= res;
    res= ((x[i][2]) == ((double)3)) ? (da[1][3]) : (
      ((x[i][2]) == ((double)2)) ? (da[0][3]) : (
      (double)0));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][3]= res;
    res= mydiv((((da[2][0]) * ((double)myexp(a[2]))) * (((
      (double)1) + ((double)myexp(a[0]))) + ((double)myexp(
      a[1])))) - (((double)myexp(a[2])) * (((da[0][0]) * (
      (double)myexp(a[0]))) + ((da[1][0]) * ((double)myexp(
      a[1]))))), mypow((((double)1) + ((double)myexp(
      a[0]))) + ((double)myexp(a[1])), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[3][0]= res;
    res= mydiv((((da[2][1]) * ((double)myexp(a[2]))) * (((
      (double)1) + ((double)myexp(a[0]))) + ((double)myexp(
      a[1])))) - (((double)myexp(a[2])) * (((da[0][1]) * (
      (double)myexp(a[0]))) + ((da[1][1]) * ((double)myexp(
      a[1]))))), mypow((((double)1) + ((double)myexp(
      a[0]))) + ((double)myexp(a[1])), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[3][1]= res;
    res= mydiv((((da[2][2]) * ((double)myexp(a[2]))) * (((
      (double)1) + ((double)myexp(a[0]))) + ((double)myexp(
      a[1])))) - (((double)myexp(a[2])) * (((da[0][2]) * (
      (double)myexp(a[0]))) + ((da[1][2]) * ((double)myexp(
      a[1]))))), mypow((((double)1) + ((double)myexp(
      a[0]))) + ((double)myexp(a[1])), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[3][2]= res;
    res= mydiv((((da[2][3]) * ((double)myexp(a[2]))) * (((
      (double)1) + ((double)myexp(a[0]))) + ((double)myexp(
      a[1])))) - (((double)myexp(a[2])) * (((da[0][3]) * (
      (double)myexp(a[0]))) + ((da[1][3]) * ((double)myexp(
      a[1]))))), mypow((((double)1) + ((double)myexp(
      a[0]))) + ((double)myexp(a[1])), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[3][3]= res;
    res= (x[i][1]) * (da[3][0]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][0]= res;
    res= (x[i][1]) * (da[3][1]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][1]= res;
    res= (x[i][1]) * (da[3][2]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][2]= res;
    res= (x[i][1]) * (da[3][3]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][3]= res;
  }
return(OK);
}

calcodes_()
{}

calcjac_()
{}

calcphi_()
{}
