/*----------------------------------------
description file: nas.mod13334

% model NASTURTIUM
resp y; 
varind x; 
parresp t1,t2,t3;
subroutine;
begin 
y =  if x==0 then t1 else 
     t1/(1+exp(t2+t3*log(x)))
          fi; 
end
----------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "nltypes.h"
#include "nlcodes.h"
#include "nlmacros.h"
#include "nlfonc.h"

short int calcf_(nbt, nbg, nbl, nbc, t, g, x, f, df, le, ie)
      short int nbt, nbg, nbl, nbc;
      double *t, *g, **x, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
ECRTRACE("calcf");
for (i=0; i<nbl; i++)
  {
    res= ((x[i][0]) == ((double)0)) ? (t[0]) : (
      mydiv(t[0], ((double)1) + ((double)myexp((t[1]) + (
      (t[2]) * (myln(x[i][0])))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=F;
        return(ERRMATH);
      }
    f[i]= res;
    res= ((x[i][0]) == ((double)0)) ? (
      (double)1) : (mydiv(((double)1) + (
      (double)myexp((t[1]) + ((t[2]) * (myln(x[i][0]))))), 
      mypow(((double)1) + ((double)myexp((t[1]) + (
      (t[2]) * (myln(x[i][0]))))), (double)2)));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][0]= res;
    res= ((x[i][0]) == ((double)0)) ? (
      (double)0) : (mydiv(-((t[0]) * ((double)myexp(
      (t[1]) + ((t[2]) * (myln(x[i][0])))))), mypow((
      (double)1) + ((double)myexp((t[1]) + ((t[2]) * (
      myln(x[i][0]))))), (double)2)));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][1]= res;
    res= ((x[i][0]) == ((double)0)) ? (
      (double)0) : (mydiv(-((t[0]) * ((myln(x[i][0])) * (
      (double)myexp((t[1]) + ((t[2]) * (myln(x[i][0]))))))), 
      mypow(((double)1) + ((double)myexp((t[1]) + (
      (t[2]) * (myln(x[i][0]))))), (double)2)));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][2]= res;
  }
return(OK);
}

calcv_()
{}

calcodes_()
{}

calcjac_()
{}

calcphi_()
{}
