/*----------------------------------------
description file: ovo.mod113435

resp V;
varind T;
parresp Pw, Ps, ov;
varint t;
valint T;
pbisresp mm, mv, mo, mme, mve, Vo, a, moe, moi, phi;
aux z1, z3, g1,g2,g3,g4,g5;
F Vw, Vs;
dF dVw, dVs;
subroutine;
begin
z1 = Vo*(1-ov)*moi/1e+3;
z3 = a*phi*mv/mm ;
g1 = -a*(mme/mve)*(moe+mo)/1e+3;
g2 = (mme/mve)*a*z1;
g3 = (mme/mve)*z3;
g4 = (mm/mv)*a*mo/1e+3;
g5 = -a*phi;
dVw = Pw*(g1 + g2/Vw + g3*Vs/Vw);
dVs = Ps*(g4 + g5*Vs/Vw);
V = Vw[T]/Vo + Vs[T]/Vo + ov;
end
----------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "nltypes.h"
#include "nlcodes.h"
#include "nlmacros.h"
#include "nlfonc.h"

calcf_()
{}

calcv_()
{}

short int calcphi_(nbt, nbg, nbl, nbc, t, g, x, Fsedo, dFsedo, f, df, le, ie)
      short int nbt, nbg, nbl, nbc;
      double *t, *g, **x, *f, **df, ***Fsedo, ***dFsedo;
      short int *le, *ie;
{
short int i;
double res;
double a[7], da[7][3];
ECRTRACE("calcphi");
for (i=0; i<nbl; i++)
  {
    res= ((mydiv(Fsedo[i][0][0], g[5])) + (mydiv(Fsedo[i][0][1], 
      g[5]))) + (t[2]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=F;
        return(ERRMATH);
      }
    f[i]= res;
    res= (mydiv((dFsedo[i][0][0]) * (g[5]), mypow(g[5], 
      (double)2))) + (mydiv((dFsedo[i][0][3]) * (
      g[5]), mypow(g[5], (double)2)));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][0]= res;
    res= (mydiv((dFsedo[i][0][1]) * (g[5]), mypow(g[5], 
      (double)2))) + (mydiv((dFsedo[i][0][4]) * (
      g[5]), mypow(g[5], (double)2)));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][1]= res;
    res= ((mydiv((dFsedo[i][0][2]) * (g[5]), mypow(g[5], 
      (double)2))) + (mydiv((dFsedo[i][0][5]) * (
      g[5]), mypow(g[5], (double)2)))) + (
      (double)1);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][2]= res;
  }
return(OK);
}

short int calcodes_(neq, t, y, ydot)
      int *neq;
      double *t, *y, *ydot;
{
short int nbobs, idobs;
double res;
double a[7], da[7][3];
ECRTRACE("calcodes");
nbobs=neq[4];
idobs=neq[3];
res= mydiv(((y[16]) * (((double)1) - (y[10]))) * (y[19]), 
      (double)1000);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
a[0]= res;
res= mydiv(((y[17]) * (y[20])) * (y[12]), y[11]);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
a[1]= res;
res= mydiv(((-(y[17])) * (mydiv(y[14], y[15]))) * ((y[18]) + (y[13])), 
      (double)1000);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
a[2]= res;
res= ((mydiv(y[14], y[15])) * (y[17])) * (a[0]);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
a[3]= res;
res= (mydiv(y[14], y[15])) * (a[1]);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
a[4]= res;
res= mydiv(((mydiv(y[11], y[12])) * (y[17])) * (y[13]), 
      (double)1000);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
a[5]= res;
res= (-(y[17])) * (y[20]);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
a[6]= res;
res= (y[8]) * (((a[2]) + (mydiv(a[3], y[0]))) + (mydiv((a[4]) * (
      y[1]), y[0])));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[0]= res;
res= (y[9]) * ((a[5]) + (mydiv((a[6]) * (y[1]), y[0])));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[1]= res;
res= (double)0;
da[0][0]= res;
res= (double)0;
da[0][1]= res;
res= mydiv((((y[16]) * (-((double)1))) * (y[19])) * (
      (double)1000), mypow((double)1000, 
      (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[0][2]= res;
res= (double)0;
da[1][0]= res;
res= (double)0;
da[1][1]= res;
res= (double)0;
da[1][2]= res;
res= (double)0;
da[2][0]= res;
res= (double)0;
da[2][1]= res;
res= (double)0;
da[2][2]= res;
res= ((mydiv(y[14], y[15])) * (y[17])) * (da[0][0]);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[3][0]= res;
res= ((mydiv(y[14], y[15])) * (y[17])) * (da[0][1]);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[3][1]= res;
res= ((mydiv(y[14], y[15])) * (y[17])) * (da[0][2]);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[3][2]= res;
res= (mydiv(y[14], y[15])) * (da[1][0]);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[4][0]= res;
res= (mydiv(y[14], y[15])) * (da[1][1]);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[4][1]= res;
res= (mydiv(y[14], y[15])) * (da[1][2]);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[4][2]= res;
res= (double)0;
da[5][0]= res;
res= (double)0;
da[5][1]= res;
res= (double)0;
da[5][2]= res;
res= (double)0;
da[6][0]= res;
res= (double)0;
da[6][1]= res;
res= (double)0;
da[6][2]= res;
res= ((y[8]) * (((da[2][0]) + (mydiv(((da[3][0]) * (y[0])) - (
      (a[3]) * (y[2])), mypow(y[0], 
      (double)2)))) + (mydiv(((((a[4]) * (y[5])) + (
      (da[4][0]) * (y[1]))) * (y[0])) - (((a[4]) * (y[1])) * (
      y[2])), mypow(y[0], (double)2))))) + ((
      (a[2]) + (mydiv(a[3], y[0]))) + (mydiv((a[4]) * (y[1]), 
      y[0])));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[2]= res;
res= (y[8]) * (((da[2][1]) + (mydiv(((da[3][1]) * (y[0])) - (
      (a[3]) * (y[3])), mypow(y[0], 
      (double)2)))) + (mydiv(((((a[4]) * (y[6])) + (
      (da[4][1]) * (y[1]))) * (y[0])) - (((a[4]) * (y[1])) * (
      y[3])), mypow(y[0], (double)2))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[3]= res;
res= (y[8]) * (((da[2][2]) + (mydiv(((da[3][2]) * (y[0])) - (
      (a[3]) * (y[4])), mypow(y[0], 
      (double)2)))) + (mydiv(((((a[4]) * (y[7])) + (
      (da[4][2]) * (y[1]))) * (y[0])) - (((a[4]) * (y[1])) * (
      y[4])), mypow(y[0], (double)2))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[4]= res;
res= (y[9]) * ((da[5][0]) + (mydiv(((((a[6]) * (y[5])) + (
      (da[6][0]) * (y[1]))) * (y[0])) - (((a[6]) * (y[1])) * (
      y[2])), mypow(y[0], (double)2))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[5]= res;
res= ((y[9]) * ((da[5][1]) + (mydiv(((((a[6]) * (y[6])) + (
      (da[6][1]) * (y[1]))) * (y[0])) - (((a[6]) * (y[1])) * (
      y[3])), mypow(y[0], (double)2))))) + ((
      a[5]) + (mydiv((a[6]) * (y[1]), y[0])));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[6]= res;
res= (y[9]) * ((da[5][2]) + (mydiv(((((a[6]) * (y[7])) + (
      (da[6][2]) * (y[1]))) * (y[0])) - (((a[6]) * (y[1])) * (
      y[4])), mypow(y[0], (double)2))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[7]= res;
return(OK);
}

calcjac_()
{}
