/*----------------------------------------
description file: own.roots.mod13455

% model racines
resp y; 
var v;
varind x; 
parresp a,b; 
parvar phi,sig;
 
subroutine;
  begin 
%    y = a*x/(1+b*x);
    y = a*(1-exp(-b*x)); 
    v = sig/(1-phi*phi);
  end 
----------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "nltypes.h"
#include "nlcodes.h"
#include "nlmacros.h"
#include "nlfonc.h"

short int calcf_(nbt, nbg, nbl, nbc, t, g, x, f, df, le, ie)
      short int nbt, nbg, nbl, nbc;
      double *t, *g, **x, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
ECRTRACE("calcf");
for (i=0; i<nbl; i++)
  {
    res= (t[0]) * (((double)1) - ((double)myexp(
      (-(t[1])) * (x[i][0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=F;
        return(ERRMATH);
      }
    f[i]= res;
    res= ((double)1) - ((double)myexp((-(t[1])) * (
      x[i][0])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][0]= res;
    res= (t[0]) * (-((-(x[i][0])) * ((double)myexp((-(t[1])) * (
      x[i][0])))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][1]= res;
  }
return(OK);
}

short int calcv_(nbt, nbb, nbg, nbl, nbc, t, b, g,
                f, df, x, v, dtv, dbv, le, ie)
      short int nbt, nbb, nbg, nbl, nbc;
      double *t, *b, *g, **x, *v, **dtv, **dbv, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
ECRTRACE("calcv");
for (i=0; i<nbl; i++)
  {
    res= mydiv(b[1], ((double)1) - ((b[0]) * (b[0])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=V;
        return(ERRMATH);
      }
    v[i]= res;
    res= (double)0;
    dtv[i][0]= res;
    res= (double)0;
    dtv[i][1]= res;
    res= mydiv(-((b[1]) * (-((b[0]) + (b[0])))), mypow((
      (double)1) - ((b[0]) * (b[0])), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDB;
        return(ERRMATH);
      }
    dbv[i][0]= res;
    res= mydiv(((double)1) - ((b[0]) * (b[0])), 
      mypow(((double)1) - ((b[0]) * (b[0])), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDB;
        return(ERRMATH);
      }
    dbv[i][1]= res;
  }
return(OK);
}

calcodes_()
{}

calcjac_()
{}

calcphi_()
{}
