/*----------------------------------------
description file: own.simul.mod13475

% model SIMEXP
resp y;
var v;
varind x;
parresp a;
parvar phi, sig;

subroutine;
  begin
    y=exp(a*x);
    v=sig/(1-phi**2);
% v=1;
  end






----------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "nltypes.h"
#include "nlcodes.h"
#include "nlmacros.h"
#include "nlfonc.h"

short int calcf_(nbt, nbg, nbl, nbc, t, g, x, f, df, le, ie)
      short int nbt, nbg, nbl, nbc;
      double *t, *g, **x, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
ECRTRACE("calcf");
for (i=0; i<nbl; i++)
  {
    res= (double)myexp((t[0]) * (x[i][0]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=F;
        return(ERRMATH);
      }
    f[i]= res;
    res= (x[i][0]) * ((double)myexp((t[0]) * (x[i][0])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][0]= res;
  }
return(OK);
}

short int calcv_(nbt, nbb, nbg, nbl, nbc, t, b, g,
                f, df, x, v, dtv, dbv, le, ie)
      short int nbt, nbb, nbg, nbl, nbc;
      double *t, *b, *g, **x, *v, **dtv, **dbv, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
ECRTRACE("calcv");
for (i=0; i<nbl; i++)
  {
    res= mydiv(b[1], ((double)1) - (mypow(b[0], 
      (double)2)));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=V;
        return(ERRMATH);
      }
    v[i]= res;
    res= (double)0;
    dtv[i][0]= res;
    res= mydiv(-((b[1]) * (-(((double)2) * (mypow(
      b[0], ((double)2) - ((double)1)))))), 
      mypow(((double)1) - (mypow(b[0], 
      (double)2)), (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDB;
        return(ERRMATH);
      }
    dbv[i][0]= res;
    res= mydiv(((double)1) - (mypow(b[0], 
      (double)2)), mypow(((double)1) - (
      mypow(b[0], (double)2)), 
      (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDB;
        return(ERRMATH);
      }
    dbv[i][1]= res;
  }
return(OK);
}

calcodes_()
{}

calcjac_()
{}

calcphi_()
{}
