/*----------------------------------------
description file: pept.m313610

% model pept.m3
resp solubility;
varind RetTime;
var v;
aux a1;
parresp  ed50, sl ;
parvar h;
subroutine ;
begin
a1 = 1 + exp (sl*(RetTime-ed50)) ;
solubility = 100. /a1 ;
v= 1 + h*solubility*(100.-solubility)  ;
end
----------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "nltypes.h"
#include "nlcodes.h"
#include "nlmacros.h"
#include "nlfonc.h"

short int calcf_(nbt, nbg, nbl, nbc, t, g, x, f, df, le, ie)
      short int nbt, nbg, nbl, nbc;
      double *t, *g, **x, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
double a[1], da[1][2];
ECRTRACE("calcf");
for (i=0; i<nbl; i++)
  {
    res= ((double)1) + ((double)myexp((t[1]) * (
      (x[i][0]) - (t[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[0]= res;
    res= mydiv((double)100, a[0]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=F;
        return(ERRMATH);
      }
    f[i]= res;
    res= ((t[1]) * (-((double)1))) * ((double)myexp(
      (t[1]) * ((x[i][0]) - (t[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][0]= res;
    res= ((x[i][0]) - (t[0])) * ((double)myexp((t[1]) * (
      (x[i][0]) - (t[0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][1]= res;
    res= mydiv(-(((double)100) * (da[0][0])), mypow(
      a[0], (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][0]= res;
    res= mydiv(-(((double)100) * (da[0][1])), mypow(
      a[0], (double)2));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][1]= res;
  }
return(OK);
}

short int calcv_(nbt, nbb, nbg, nbl, nbc, t, b, g,
                f, df, x, v, dtv, dbv, le, ie)
      short int nbt, nbb, nbg, nbl, nbc;
      double *t, *b, *g, **x, *v, **dtv, **dbv, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
double a[1], da[1][3];
ECRTRACE("calcv");
for (i=0; i<nbl; i++)
  {
    res= ((double)1) + (((b[0]) * (f[i])) * ((
      (double)100) - (f[i])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=V;
        return(ERRMATH);
      }
    v[i]= res;
    res= (((b[0]) * (f[i])) * (-(df[i][0]))) + (((b[0]) * (df[i][0])) * (
      ((double)100) - (f[i])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][0]= res;
    res= (((b[0]) * (f[i])) * (-(df[i][1]))) + (((b[0]) * (df[i][1])) * (
      ((double)100) - (f[i])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDT;
        return(ERRMATH);
      }
    dtv[i][1]= res;
    res= (((b[0]) * (f[i])) * (-((double)0))) + (
      (f[i]) * (((double)100) - (f[i])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DVDB;
        return(ERRMATH);
      }
    dbv[i][0]= res;
  }
return(OK);
}

calcodes_()
{}

calcjac_()
{}

calcphi_()
{}
