/*----------------------------------------
description file: perm.mod13671

% Example PERM
resp f;
varind time;
parresp pe, pc, mm, mv, mo, ov;
varint x;
valint time;
pbisresp mme, mve, vt0, a, moe, moi, phi;
aux z1, z2;
F Ve, Vc;
dF dVe, dVc;
subroutine;
begin
z1 = vt0*(1-ov)*moi/1e+3;
z2 = phi*mv*Vc/mm ;
dVe = -(mme/mve)*pe*a*((moe+mo)/1e+3 - (z1+z2)/Ve);
dVc = (mm/mv)*pc*a*(mo/1e+3 - z2/Ve);
f = Ve[time]/vt0 + Vc[time]/vt0 + ov;
end
----------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "nltypes.h"
#include "nlcodes.h"
#include "nlmacros.h"
#include "nlfonc.h"

calcf_()
{}

calcv_()
{}

short int calcphi_(nbt, nbg, nbl, nbc, t, g, x, Fsedo, dFsedo, f, df, le, ie)
      short int nbt, nbg, nbl, nbc;
      double *t, *g, **x, *f, **df, ***Fsedo, ***dFsedo;
      short int *le, *ie;
{
short int i;
double res;
double a[2], da[2][6];
ECRTRACE("calcphi");
for (i=0; i<nbl; i++)
  {
    res= ((mydiv(Fsedo[i][0][0], g[2])) + (mydiv(Fsedo[i][0][1], 
      g[2]))) + (t[5]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=F;
        return(ERRMATH);
      }
    f[i]= res;
    res= (mydiv((dFsedo[i][0][0]) * (g[2]), mypow(g[2], 
      (double)2))) + (mydiv((dFsedo[i][0][6]) * (
      g[2]), mypow(g[2], (double)2)));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][0]= res;
    res= (mydiv((dFsedo[i][0][1]) * (g[2]), mypow(g[2], 
      (double)2))) + (mydiv((dFsedo[i][0][7]) * (
      g[2]), mypow(g[2], (double)2)));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][1]= res;
    res= (mydiv((dFsedo[i][0][2]) * (g[2]), mypow(g[2], 
      (double)2))) + (mydiv((dFsedo[i][0][8]) * (
      g[2]), mypow(g[2], (double)2)));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][2]= res;
    res= (mydiv((dFsedo[i][0][3]) * (g[2]), mypow(g[2], 
      (double)2))) + (mydiv((dFsedo[i][0][9]) * (
      g[2]), mypow(g[2], (double)2)));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][3]= res;
    res= (mydiv((dFsedo[i][0][4]) * (g[2]), mypow(g[2], 
      (double)2))) + (mydiv((dFsedo[i][0][10]) * (
      g[2]), mypow(g[2], (double)2)));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][4]= res;
    res= ((mydiv((dFsedo[i][0][5]) * (g[2]), mypow(g[2], 
      (double)2))) + (mydiv((dFsedo[i][0][11]) * (
      g[2]), mypow(g[2], (double)2)))) + (
      (double)1);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][5]= res;
  }
return(OK);
}

short int calcodes_(neq, t, y, ydot)
      int *neq;
      double *t, *y, *ydot;
{
short int nbobs, idobs;
double res;
double a[2], da[2][6];
ECRTRACE("calcodes");
nbobs=neq[4];
idobs=neq[3];
res= mydiv(((y[22]) * (((double)1) - (y[19]))) * (y[25]), 
      (double)1000);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
a[0]= res;
res= mydiv(((y[26]) * (y[17])) * (y[1]), y[16]);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
a[1]= res;
res= (((-(mydiv(y[20], y[21]))) * (y[14])) * (y[23])) * ((mydiv(
      (y[24]) + (y[18]), (double)1000)) - (mydiv((a[0]) + (
      a[1]), y[0])));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[0]= res;
res= (((mydiv(y[16], y[17])) * (y[15])) * (y[23])) * ((mydiv(y[18], 
      (double)1000)) - (mydiv(a[1], y[0])));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[1]= res;
res= (double)0;
da[0][0]= res;
res= (double)0;
da[0][1]= res;
res= (double)0;
da[0][2]= res;
res= (double)0;
da[0][3]= res;
res= (double)0;
da[0][4]= res;
res= mydiv((((y[22]) * (-((double)1))) * (y[25])) * (
      (double)1000), mypow((double)1000, 
      (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[0][5]= res;
res= mydiv((((y[26]) * (y[17])) * (y[8])) * (y[16]), mypow(
      y[16], (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][0]= res;
res= mydiv((((y[26]) * (y[17])) * (y[9])) * (y[16]), mypow(
      y[16], (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][1]= res;
res= mydiv(((((y[26]) * (y[17])) * (y[10])) * (y[16])) - (((y[26]) * (
      y[17])) * (y[1])), mypow(y[16], 
      (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][2]= res;
res= mydiv(((((y[26]) * (y[17])) * (y[11])) + ((y[26]) * (y[1]))) * (
      y[16]), mypow(y[16], (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][3]= res;
res= mydiv((((y[26]) * (y[17])) * (y[12])) * (y[16]), mypow(
      y[16], (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][4]= res;
res= mydiv((((y[26]) * (y[17])) * (y[13])) * (y[16]), mypow(
      y[16], (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][5]= res;
res= ((((-(mydiv(y[20], y[21]))) * (y[14])) * (y[23])) * (-(mydiv(
      (((da[0][0]) + (da[1][0])) * (y[0])) - (((a[0]) + (
      a[1])) * (y[2])), mypow(y[0], 
      (double)2))))) + (((-(mydiv(y[20], y[21]))) * (
      y[23])) * ((mydiv((y[24]) + (y[18]), 
      (double)1000)) - (mydiv((a[0]) + (a[1]), y[0]))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[2]= res;
res= (((-(mydiv(y[20], y[21]))) * (y[14])) * (y[23])) * (-(mydiv(
      (((da[0][1]) + (da[1][1])) * (y[0])) - (((a[0]) + (
      a[1])) * (y[3])), mypow(y[0], 
      (double)2))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[3]= res;
res= (((-(mydiv(y[20], y[21]))) * (y[14])) * (y[23])) * (-(mydiv(
      (((da[0][2]) + (da[1][2])) * (y[0])) - (((a[0]) + (
      a[1])) * (y[4])), mypow(y[0], 
      (double)2))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[4]= res;
res= (((-(mydiv(y[20], y[21]))) * (y[14])) * (y[23])) * (-(mydiv(
      (((da[0][3]) + (da[1][3])) * (y[0])) - (((a[0]) + (
      a[1])) * (y[5])), mypow(y[0], 
      (double)2))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[5]= res;
res= (((-(mydiv(y[20], y[21]))) * (y[14])) * (y[23])) * ((mydiv(
      (double)1000, mypow((double)1000, 
      (double)2))) - (mydiv((((da[0][4]) + (da[1][4])) * (
      y[0])) - (((a[0]) + (a[1])) * (y[6])), mypow(y[0], 
      (double)2))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[6]= res;
res= (((-(mydiv(y[20], y[21]))) * (y[14])) * (y[23])) * (-(mydiv(
      (((da[0][5]) + (da[1][5])) * (y[0])) - (((a[0]) + (
      a[1])) * (y[7])), mypow(y[0], 
      (double)2))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[7]= res;
res= (((mydiv(y[16], y[17])) * (y[15])) * (y[23])) * (-(mydiv((
      (da[1][0]) * (y[0])) - ((a[1]) * (y[2])), mypow(
      y[0], (double)2))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[8]= res;
res= ((((mydiv(y[16], y[17])) * (y[15])) * (y[23])) * (-(mydiv(
      ((da[1][1]) * (y[0])) - ((a[1]) * (y[3])), mypow(
      y[0], (double)2))))) + (((mydiv(y[16], y[17])) * (
      y[23])) * ((mydiv(y[18], (double)1000)) - (mydiv(
      a[1], y[0]))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[9]= res;
res= ((((mydiv(y[16], y[17])) * (y[15])) * (y[23])) * (-(mydiv(
      ((da[1][2]) * (y[0])) - ((a[1]) * (y[4])), mypow(
      y[0], (double)2))))) + ((((mydiv(y[17], mypow(
      y[17], (double)2))) * (y[15])) * (y[23])) * (
      (mydiv(y[18], (double)1000)) - (mydiv(a[1], y[0]))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[10]= res;
res= ((((mydiv(y[16], y[17])) * (y[15])) * (y[23])) * (-(mydiv(
      ((da[1][3]) * (y[0])) - ((a[1]) * (y[5])), mypow(
      y[0], (double)2))))) + ((((mydiv(-(y[16]), 
      mypow(y[17], (double)2))) * (y[15])) * (y[23])) * (
      (mydiv(y[18], (double)1000)) - (mydiv(a[1], y[0]))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[11]= res;
res= (((mydiv(y[16], y[17])) * (y[15])) * (y[23])) * ((mydiv(
      (double)1000, mypow((double)1000, 
      (double)2))) - (mydiv(((da[1][4]) * (y[0])) - (
      (a[1]) * (y[6])), mypow(y[0], 
      (double)2))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[12]= res;
res= (((mydiv(y[16], y[17])) * (y[15])) * (y[23])) * (-(mydiv((
      (da[1][5]) * (y[0])) - ((a[1]) * (y[7])), mypow(
      y[0], (double)2))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[13]= res;
return(OK);
}

calcjac_()
{}
