/* ------------------------------------------------------
Example "weibull" of call to renls2C: 
return the successive values of "rss"
by removing one observation each time.
 ----------------------------------------------------------- */


/* +++++++++++++++++++++++++++++++++++++++++++++++++++
 includes 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#include "nls2C.h"
/* ------------------------------------------------------------
Calling program
---------------------------------------------------------------*/

int main(argc, argv)
  int argc;
  char *argv[];
{
/* --------  Declarations ------------ */


/* Local variables: */
int iarg, n1, code=OK,  b;
long int nobst;
double rss, *weights;
char nominput[100];
TLogic entree= FAUX;

/* Argument treatement -----------------------------*/
if ((argc < 3) || (argc > 5) || (strncmp(argv[1], "-h",2)==0))
  {
  return(erreur());
  }

iarg=1;
while( iarg< argc)
  {

    if (strncmp(argv[iarg], "-s", 2) ==0)
      {
	fprintf(stderr,
"Warning: option -s ignored; The main program of this example has no option -s.\n");
	iarg=iarg+2;
        continue; 

      }


    if (strncmp(argv[iarg], "-i", 2) ==0)
      {
	if (argc <= iarg)
	  {
	   return(erreur());
	  }
	iarg++;
	strcpy(nominput, argv[iarg]);
	iarg++;
	entree=VRAI;
	continue;
      }

    if (strncmp(argv[iarg], "-h",2) ==0)
      {
	erreur(); /* ce n'est pas une erreur mais c'est pour faire ecrire la syntaxe */
      return(OK);
      }



    if (strncmp(argv[iarg], "-",1) ==0)
      {
	return(erreur());
      }
  } /* fin iarg */

if (entree== FAUX)
  return(erreur()); /* pas d'option -i */


/* ------- Calling  nls2C ------------ */


/* First invokation of nls2C: */
if ( (code =nls2C(nominput)) != 0)
  {
  fprintf(stderr,"Fatal error in nls2C, code %d \n", code);
  exit(code);
  }
rss = recup0D("rss", 1);
printf("Residual sum of squares at the first loop: %g\n", rss);

weights= recup1D("weights",1,&n1);
nobst= recup0L("n.obst", 1);

for (b=1; b <= nobst; b++)
  {
/* The new estimation is realized by call to the function "renls2C": */
    /* At each loop, an observation is removed, the preceeding one
    is taken into account again */
    weights[b-1]=1;
    weights[b]=0;
    code=renls2C((double *)NULL, (double *)NULL, 
	    (double *)NULL, (double *)NULL,
            (double **)NULL,
	    (double *)NULL, weights, 0);

    if (code != (int)OK)
	  {
	    fprintf(stderr,
	"Wrong execution of the loop %d code = %d\n",
	b, code);
	    exit(code);
	  }

	rss = recup0D("rss", 1);
        printf("Residual sum of squares  at loop %d: %g\n", (b+1), rss);
  }


/* Destruction des structures */
/* delnls2(); */
return(0);
}

/* ------------------------------------------------------------------
Gestion des erreurs d'appel
-------------------------------------------------------------------- */
int erreur()
{

  fprintf(stderr,"Arguments: [ -s[plus] splusfilename ] -i input-file\n");
  return(ERRARG);
}
