/*----------------------------------------
description file: substrat.mod13785

% Example SUBSTRAT
resp f;
varind ind, x;
parresp X0, P0, S0, muMax, k, a, b, y1, y2, y;
pbisresp Tlat;
varint t;
valint x;
F X, P, S;
dF dX, dP, dS;
condinit X0, P0, S0;
aux mu,S1,ff,a1,a2;
subroutine;
begin
S1=S/(1+S);
mu=muMax*S1*exp(-((P/k+0.1)**y));
%mu=muMax*S1*(1-P/k);
a1=mu*X;
dX= if t>Tlat then a1 else 0 fi;
%dX=a1;
a2=(a*mu+b)*X*S1;
dP= if t>Tlat then a2 else 0 fi;
%dP=a2;
dS= if t>Tlat then -a1/y1-a2/y2 else 0 fi;
%dS=-a1/y1-a2/y2;
ff= if ind==1 then X[x] else
		        if ind==2 then P[x] else
                                       S[x]
                        fi
    fi;
f=ff;
end
----------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "nltypes.h"
#include "nlcodes.h"
#include "nlmacros.h"
#include "nlfonc.h"

calcf_()
{}

calcv_()
{}

short int calcphi_(nbt, nbg, nbl, nbc, t, g, x, Fsedo, dFsedo, f, df, le, ie)
      short int nbt, nbg, nbl, nbc;
      double *t, *g, **x, *f, **df, ***Fsedo, ***dFsedo;
      short int *le, *ie;
{
short int i;
double res;
double a[5], da[5][10];
ECRTRACE("calcphi");
for (i=0; i<nbl; i++)
  {
    res= ((x[i][0]) == ((double)1)) ? (Fsedo[i][0][0]) : (
      ((x[i][0]) == ((double)2)) ? (Fsedo[i][0][1]) : (
      Fsedo[i][0][2]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[2]= res;
    res= a[2];
    f[i]= res;
    res= ((x[i][0]) == ((double)1)) ? (dFsedo[i][0][0]) : (
      ((x[i][0]) == ((double)2)) ? (dFsedo[i][0][10]) : (
      dFsedo[i][0][20]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][0]= res;
    res= ((x[i][0]) == ((double)1)) ? (dFsedo[i][0][1]) : (
      ((x[i][0]) == ((double)2)) ? (dFsedo[i][0][11]) : (
      dFsedo[i][0][21]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][1]= res;
    res= ((x[i][0]) == ((double)1)) ? (dFsedo[i][0][2]) : (
      ((x[i][0]) == ((double)2)) ? (dFsedo[i][0][12]) : (
      dFsedo[i][0][22]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][2]= res;
    res= ((x[i][0]) == ((double)1)) ? (dFsedo[i][0][3]) : (
      ((x[i][0]) == ((double)2)) ? (dFsedo[i][0][13]) : (
      dFsedo[i][0][23]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][3]= res;
    res= ((x[i][0]) == ((double)1)) ? (dFsedo[i][0][4]) : (
      ((x[i][0]) == ((double)2)) ? (dFsedo[i][0][14]) : (
      dFsedo[i][0][24]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][4]= res;
    res= ((x[i][0]) == ((double)1)) ? (dFsedo[i][0][5]) : (
      ((x[i][0]) == ((double)2)) ? (dFsedo[i][0][15]) : (
      dFsedo[i][0][25]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][5]= res;
    res= ((x[i][0]) == ((double)1)) ? (dFsedo[i][0][6]) : (
      ((x[i][0]) == ((double)2)) ? (dFsedo[i][0][16]) : (
      dFsedo[i][0][26]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][6]= res;
    res= ((x[i][0]) == ((double)1)) ? (dFsedo[i][0][7]) : (
      ((x[i][0]) == ((double)2)) ? (dFsedo[i][0][17]) : (
      dFsedo[i][0][27]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][7]= res;
    res= ((x[i][0]) == ((double)1)) ? (dFsedo[i][0][8]) : (
      ((x[i][0]) == ((double)2)) ? (dFsedo[i][0][18]) : (
      dFsedo[i][0][28]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][8]= res;
    res= ((x[i][0]) == ((double)1)) ? (dFsedo[i][0][9]) : (
      ((x[i][0]) == ((double)2)) ? (dFsedo[i][0][19]) : (
      dFsedo[i][0][29]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[2][9]= res;
    res= da[2][0];
    df[i][0]= res;
    res= da[2][1];
    df[i][1]= res;
    res= da[2][2];
    df[i][2]= res;
    res= da[2][3];
    df[i][3]= res;
    res= da[2][4];
    df[i][4]= res;
    res= da[2][5];
    df[i][5]= res;
    res= da[2][6];
    df[i][6]= res;
    res= da[2][7];
    df[i][7]= res;
    res= da[2][8];
    df[i][8]= res;
    res= da[2][9];
    df[i][9]= res;
  }
return(OK);
}

short int calcodes_(neq, t, y, ydot)
      int *neq;
      double *t, *y, *ydot;
{
short int nbobs, idobs;
double res;
double a[5], da[5][10];
ECRTRACE("calcodes");
nbobs=neq[4];
idobs=neq[3];
res= mydiv(y[2], ((double)1) + (y[2]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
a[0]= res;
res= ((y[36]) * (a[0])) * ((double)myexp(-(mypow((mydiv(y[1], 
      y[37])) + ((double)1.00000000e-01), y[42]))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
a[1]= res;
res= (a[1]) * (y[0]);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
a[3]= res;
res= ((((y[38]) * (a[1])) + (y[39])) * (y[0])) * (a[0]);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
a[4]= res;
res= ((*t) > (y[43])) ? (a[3]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[0]= res;
res= ((*t) > (y[43])) ? (a[4]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[1]= res;
res= ((*t) > (y[43])) ? ((mydiv(-(a[3]), y[40])) - (mydiv(a[4], 
      y[41]))) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[2]= res;
res= mydiv(((y[23]) * (((double)1) + (y[2]))) - ((
      y[2]) * (y[23])), mypow(((double)1) + (y[2]), 
      (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[0][0]= res;
res= mydiv(((y[24]) * (((double)1) + (y[2]))) - ((
      y[2]) * (y[24])), mypow(((double)1) + (y[2]), 
      (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[0][1]= res;
res= mydiv(((y[25]) * (((double)1) + (y[2]))) - ((
      y[2]) * (y[25])), mypow(((double)1) + (y[2]), 
      (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[0][2]= res;
res= mydiv(((y[26]) * (((double)1) + (y[2]))) - ((
      y[2]) * (y[26])), mypow(((double)1) + (y[2]), 
      (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[0][3]= res;
res= mydiv(((y[27]) * (((double)1) + (y[2]))) - ((
      y[2]) * (y[27])), mypow(((double)1) + (y[2]), 
      (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[0][4]= res;
res= mydiv(((y[28]) * (((double)1) + (y[2]))) - ((
      y[2]) * (y[28])), mypow(((double)1) + (y[2]), 
      (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[0][5]= res;
res= mydiv(((y[29]) * (((double)1) + (y[2]))) - ((
      y[2]) * (y[29])), mypow(((double)1) + (y[2]), 
      (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[0][6]= res;
res= mydiv(((y[30]) * (((double)1) + (y[2]))) - ((
      y[2]) * (y[30])), mypow(((double)1) + (y[2]), 
      (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[0][7]= res;
res= mydiv(((y[31]) * (((double)1) + (y[2]))) - ((
      y[2]) * (y[31])), mypow(((double)1) + (y[2]), 
      (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[0][8]= res;
res= mydiv(((y[32]) * (((double)1) + (y[2]))) - ((
      y[2]) * (y[32])), mypow(((double)1) + (y[2]), 
      (double)2));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[0][9]= res;
res= (((y[36]) * (a[0])) * ((-((y[42]) * ((mypow((mydiv(y[1], 
      y[37])) + ((double)1.00000000e-01), (y[42]) - (
      (double)1))) * (mydiv((y[13]) * (y[37]), mypow(
      y[37], (double)2)))))) * ((double)myexp(-(mypow(
      (mydiv(y[1], y[37])) + ((double)1.00000000e-01), y[42])))))) + (
      ((y[36]) * (da[0][0])) * ((double)myexp(-(mypow((mydiv(
      y[1], y[37])) + ((double)1.00000000e-01), y[42])))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][0]= res;
res= (((y[36]) * (a[0])) * ((-((y[42]) * ((mypow((mydiv(y[1], 
      y[37])) + ((double)1.00000000e-01), (y[42]) - (
      (double)1))) * (mydiv((y[14]) * (y[37]), mypow(
      y[37], (double)2)))))) * ((double)myexp(-(mypow(
      (mydiv(y[1], y[37])) + ((double)1.00000000e-01), y[42])))))) + (
      ((y[36]) * (da[0][1])) * ((double)myexp(-(mypow((mydiv(
      y[1], y[37])) + ((double)1.00000000e-01), y[42])))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][1]= res;
res= (((y[36]) * (a[0])) * ((-((y[42]) * ((mypow((mydiv(y[1], 
      y[37])) + ((double)1.00000000e-01), (y[42]) - (
      (double)1))) * (mydiv((y[15]) * (y[37]), mypow(
      y[37], (double)2)))))) * ((double)myexp(-(mypow(
      (mydiv(y[1], y[37])) + ((double)1.00000000e-01), y[42])))))) + (
      ((y[36]) * (da[0][2])) * ((double)myexp(-(mypow((mydiv(
      y[1], y[37])) + ((double)1.00000000e-01), y[42])))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][2]= res;
res= (((y[36]) * (a[0])) * ((-((y[42]) * ((mypow((mydiv(y[1], 
      y[37])) + ((double)1.00000000e-01), (y[42]) - (
      (double)1))) * (mydiv((y[16]) * (y[37]), mypow(
      y[37], (double)2)))))) * ((double)myexp(-(mypow(
      (mydiv(y[1], y[37])) + ((double)1.00000000e-01), y[42])))))) + (
      (((y[36]) * (da[0][3])) + (a[0])) * ((double)myexp(-(
      mypow((mydiv(y[1], y[37])) + ((double)1.00000000e-01), 
      y[42])))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][3]= res;
res= (((y[36]) * (a[0])) * ((-((y[42]) * ((mypow((mydiv(y[1], 
      y[37])) + ((double)1.00000000e-01), (y[42]) - (
      (double)1))) * (mydiv(((y[17]) * (y[37])) - (
      y[1]), mypow(y[37], (double)2)))))) * ((double)myexp(
      -(mypow((mydiv(y[1], y[37])) + (
      (double)1.00000000e-01), y[42])))))) + (((y[36]) * (da[0][4])) * (
      (double)myexp(-(mypow((mydiv(y[1], y[37])) + (
      (double)1.00000000e-01), y[42])))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][4]= res;
res= (((y[36]) * (a[0])) * ((-((y[42]) * ((mypow((mydiv(y[1], 
      y[37])) + ((double)1.00000000e-01), (y[42]) - (
      (double)1))) * (mydiv((y[18]) * (y[37]), mypow(
      y[37], (double)2)))))) * ((double)myexp(-(mypow(
      (mydiv(y[1], y[37])) + ((double)1.00000000e-01), y[42])))))) + (
      ((y[36]) * (da[0][5])) * ((double)myexp(-(mypow((mydiv(
      y[1], y[37])) + ((double)1.00000000e-01), y[42])))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][5]= res;
res= (((y[36]) * (a[0])) * ((-((y[42]) * ((mypow((mydiv(y[1], 
      y[37])) + ((double)1.00000000e-01), (y[42]) - (
      (double)1))) * (mydiv((y[19]) * (y[37]), mypow(
      y[37], (double)2)))))) * ((double)myexp(-(mypow(
      (mydiv(y[1], y[37])) + ((double)1.00000000e-01), y[42])))))) + (
      ((y[36]) * (da[0][6])) * ((double)myexp(-(mypow((mydiv(
      y[1], y[37])) + ((double)1.00000000e-01), y[42])))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][6]= res;
res= (((y[36]) * (a[0])) * ((-((y[42]) * ((mypow((mydiv(y[1], 
      y[37])) + ((double)1.00000000e-01), (y[42]) - (
      (double)1))) * (mydiv((y[20]) * (y[37]), mypow(
      y[37], (double)2)))))) * ((double)myexp(-(mypow(
      (mydiv(y[1], y[37])) + ((double)1.00000000e-01), y[42])))))) + (
      ((y[36]) * (da[0][7])) * ((double)myexp(-(mypow((mydiv(
      y[1], y[37])) + ((double)1.00000000e-01), y[42])))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][7]= res;
res= (((y[36]) * (a[0])) * ((-((y[42]) * ((mypow((mydiv(y[1], 
      y[37])) + ((double)1.00000000e-01), (y[42]) - (
      (double)1))) * (mydiv((y[21]) * (y[37]), mypow(
      y[37], (double)2)))))) * ((double)myexp(-(mypow(
      (mydiv(y[1], y[37])) + ((double)1.00000000e-01), y[42])))))) + (
      ((y[36]) * (da[0][8])) * ((double)myexp(-(mypow((mydiv(
      y[1], y[37])) + ((double)1.00000000e-01), y[42])))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][8]= res;
res= (((y[36]) * (a[0])) * ((-(((y[42]) * ((mypow((mydiv(y[1], 
      y[37])) + ((double)1.00000000e-01), (y[42]) - (
      (double)1))) * (mydiv((y[22]) * (y[37]), mypow(
      y[37], (double)2))))) + ((mypow((mydiv(y[1], 
      y[37])) + ((double)1.00000000e-01), y[42])) * (myln((mydiv(
      y[1], y[37])) + ((double)1.00000000e-01)))))) * ((double)myexp(
      -(mypow((mydiv(y[1], y[37])) + (
      (double)1.00000000e-01), y[42])))))) + (((y[36]) * (da[0][9])) * (
      (double)myexp(-(mypow((mydiv(y[1], y[37])) + (
      (double)1.00000000e-01), y[42])))));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[1][9]= res;
res= ((a[1]) * (y[3])) + ((da[1][0]) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[3][0]= res;
res= ((a[1]) * (y[4])) + ((da[1][1]) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[3][1]= res;
res= ((a[1]) * (y[5])) + ((da[1][2]) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[3][2]= res;
res= ((a[1]) * (y[6])) + ((da[1][3]) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[3][3]= res;
res= ((a[1]) * (y[7])) + ((da[1][4]) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[3][4]= res;
res= ((a[1]) * (y[8])) + ((da[1][5]) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[3][5]= res;
res= ((a[1]) * (y[9])) + ((da[1][6]) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[3][6]= res;
res= ((a[1]) * (y[10])) + ((da[1][7]) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[3][7]= res;
res= ((a[1]) * (y[11])) + ((da[1][8]) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[3][8]= res;
res= ((a[1]) * (y[12])) + ((da[1][9]) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[3][9]= res;
res= (((((y[38]) * (a[1])) + (y[39])) * (y[0])) * (da[0][0])) + (
      (((((y[38]) * (a[1])) + (y[39])) * (y[3])) + (((y[38]) * (
      da[1][0])) * (y[0]))) * (a[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[4][0]= res;
res= (((((y[38]) * (a[1])) + (y[39])) * (y[0])) * (da[0][1])) + (
      (((((y[38]) * (a[1])) + (y[39])) * (y[4])) + (((y[38]) * (
      da[1][1])) * (y[0]))) * (a[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[4][1]= res;
res= (((((y[38]) * (a[1])) + (y[39])) * (y[0])) * (da[0][2])) + (
      (((((y[38]) * (a[1])) + (y[39])) * (y[5])) + (((y[38]) * (
      da[1][2])) * (y[0]))) * (a[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[4][2]= res;
res= (((((y[38]) * (a[1])) + (y[39])) * (y[0])) * (da[0][3])) + (
      (((((y[38]) * (a[1])) + (y[39])) * (y[6])) + (((y[38]) * (
      da[1][3])) * (y[0]))) * (a[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[4][3]= res;
res= (((((y[38]) * (a[1])) + (y[39])) * (y[0])) * (da[0][4])) + (
      (((((y[38]) * (a[1])) + (y[39])) * (y[7])) + (((y[38]) * (
      da[1][4])) * (y[0]))) * (a[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[4][4]= res;
res= (((((y[38]) * (a[1])) + (y[39])) * (y[0])) * (da[0][5])) + (
      (((((y[38]) * (a[1])) + (y[39])) * (y[8])) + ((((y[38]) * (
      da[1][5])) + (a[1])) * (y[0]))) * (a[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[4][5]= res;
res= (((((y[38]) * (a[1])) + (y[39])) * (y[0])) * (da[0][6])) + (
      (((((y[38]) * (a[1])) + (y[39])) * (y[9])) + ((((y[38]) * (
      da[1][6])) + ((double)1)) * (y[0]))) * (a[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[4][6]= res;
res= (((((y[38]) * (a[1])) + (y[39])) * (y[0])) * (da[0][7])) + (
      (((((y[38]) * (a[1])) + (y[39])) * (y[10])) + (((y[38]) * (
      da[1][7])) * (y[0]))) * (a[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[4][7]= res;
res= (((((y[38]) * (a[1])) + (y[39])) * (y[0])) * (da[0][8])) + (
      (((((y[38]) * (a[1])) + (y[39])) * (y[11])) + (((y[38]) * (
      da[1][8])) * (y[0]))) * (a[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[4][8]= res;
res= (((((y[38]) * (a[1])) + (y[39])) * (y[0])) * (da[0][9])) + (
      (((((y[38]) * (a[1])) + (y[39])) * (y[12])) + (((y[38]) * (
      da[1][9])) * (y[0]))) * (a[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
da[4][9]= res;
res= ((*t) > (y[43])) ? (da[3][0]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[3]= res;
res= ((*t) > (y[43])) ? (da[3][1]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[4]= res;
res= ((*t) > (y[43])) ? (da[3][2]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[5]= res;
res= ((*t) > (y[43])) ? (da[3][3]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[6]= res;
res= ((*t) > (y[43])) ? (da[3][4]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[7]= res;
res= ((*t) > (y[43])) ? (da[3][5]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[8]= res;
res= ((*t) > (y[43])) ? (da[3][6]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[9]= res;
res= ((*t) > (y[43])) ? (da[3][7]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[10]= res;
res= ((*t) > (y[43])) ? (da[3][8]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[11]= res;
res= ((*t) > (y[43])) ? (da[3][9]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[12]= res;
res= ((*t) > (y[43])) ? (da[4][0]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[13]= res;
res= ((*t) > (y[43])) ? (da[4][1]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[14]= res;
res= ((*t) > (y[43])) ? (da[4][2]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[15]= res;
res= ((*t) > (y[43])) ? (da[4][3]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[16]= res;
res= ((*t) > (y[43])) ? (da[4][4]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[17]= res;
res= ((*t) > (y[43])) ? (da[4][5]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[18]= res;
res= ((*t) > (y[43])) ? (da[4][6]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[19]= res;
res= ((*t) > (y[43])) ? (da[4][7]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[20]= res;
res= ((*t) > (y[43])) ? (da[4][8]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[21]= res;
res= ((*t) > (y[43])) ? (da[4][9]) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[22]= res;
res= ((*t) > (y[43])) ? ((mydiv((-(da[3][0])) * (y[40]), mypow(
      y[40], (double)2))) - (mydiv((da[4][0]) * (
      y[41]), mypow(y[41], (double)2)))) : (
      (double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[23]= res;
res= ((*t) > (y[43])) ? ((mydiv((-(da[3][1])) * (y[40]), mypow(
      y[40], (double)2))) - (mydiv((da[4][1]) * (
      y[41]), mypow(y[41], (double)2)))) : (
      (double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[24]= res;
res= ((*t) > (y[43])) ? ((mydiv((-(da[3][2])) * (y[40]), mypow(
      y[40], (double)2))) - (mydiv((da[4][2]) * (
      y[41]), mypow(y[41], (double)2)))) : (
      (double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[25]= res;
res= ((*t) > (y[43])) ? ((mydiv((-(da[3][3])) * (y[40]), mypow(
      y[40], (double)2))) - (mydiv((da[4][3]) * (
      y[41]), mypow(y[41], (double)2)))) : (
      (double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[26]= res;
res= ((*t) > (y[43])) ? ((mydiv((-(da[3][4])) * (y[40]), mypow(
      y[40], (double)2))) - (mydiv((da[4][4]) * (
      y[41]), mypow(y[41], (double)2)))) : (
      (double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[27]= res;
res= ((*t) > (y[43])) ? ((mydiv((-(da[3][5])) * (y[40]), mypow(
      y[40], (double)2))) - (mydiv((da[4][5]) * (
      y[41]), mypow(y[41], (double)2)))) : (
      (double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[28]= res;
res= ((*t) > (y[43])) ? ((mydiv((-(da[3][6])) * (y[40]), mypow(
      y[40], (double)2))) - (mydiv((da[4][6]) * (
      y[41]), mypow(y[41], (double)2)))) : (
      (double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[29]= res;
res= ((*t) > (y[43])) ? ((mydiv(((-(da[3][7])) * (y[40])) - (
      -(a[3])), mypow(y[40], (double)2))) - (mydiv(
      (da[4][7]) * (y[41]), mypow(y[41], 
      (double)2)))) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[30]= res;
res= ((*t) > (y[43])) ? ((mydiv((-(da[3][8])) * (y[40]), mypow(
      y[40], (double)2))) - (mydiv(((da[4][8]) * (
      y[41])) - (a[4]), mypow(y[41], 
      (double)2)))) : ((double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[31]= res;
res= ((*t) > (y[43])) ? ((mydiv((-(da[3][9])) * (y[40]), mypow(
      y[40], (double)2))) - (mydiv((da[4][9]) * (
      y[41]), mypow(y[41], (double)2)))) : (
      (double)0);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[32]= res;
return(OK);
}

calcjac_()
{}
