/*----------------------------------------
description file: tiller.exp.m213805

% Model simple exponential 
%       with response variances proportional 
%       to response expectations
resp DryWeight; 
varind DegreeDays; 
var v;
parresp a,b;
subroutine;
begin 
DryWeight= a*exp(b*DegreeDays);
v = DryWeight;
end 
----------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "nltypes.h"
#include "nlcodes.h"
#include "nlmacros.h"
#include "nlfonc.h"

short int calcf_(nbt, nbg, nbl, nbc, t, g, x, f, df, le, ie)
      short int nbt, nbg, nbl, nbc;
      double *t, *g, **x, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
ECRTRACE("calcf");
for (i=0; i<nbl; i++)
  {
    res= (t[0]) * ((double)myexp((t[1]) * (x[i][0])));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=F;
        return(ERRMATH);
      }
    f[i]= res;
    res= (double)myexp((t[1]) * (x[i][0]));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][0]= res;
    res= (t[0]) * ((x[i][0]) * ((double)myexp((t[1]) * (x[i][0]))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][1]= res;
  }
return(OK);
}

short int calcv_(nbt, nbb, nbg, nbl, nbc, t, b, g,
                f, df, x, v, dtv, dbv, le, ie)
      short int nbt, nbb, nbg, nbl, nbc;
      double *t, *b, *g, **x, *v, **dtv, **dbv, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
ECRTRACE("calcv");
for (i=0; i<nbl; i++)
  {
    res= f[i];
    v[i]= res;
    res= df[i][0];
    dtv[i][0]= res;
    res= df[i][1];
    dtv[i][1]= res;
  }
return(OK);
}

calcodes_()
{}

calcjac_()
{}

calcphi_()
{}
