/*----------------------------------------
description file: volterra.mod13846

%model Hosts-Parasites
resp f;
varind x, ind;
parresp H0, P0, r1,s1,r2,s2;
varint t;
valint x;
condinit H0, P0;
F H, P;
dF dH, dP;
aux a;
subroutine;
begin
dH = (r1-s1*P)*H;
dP = (r2-s2*(P/H))*P;
a = if ind==1 then H[x] else
                   P[x]
    fi;
f = a;
end
----------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "nltypes.h"
#include "nlcodes.h"
#include "nlmacros.h"
#include "nlfonc.h"

calcf_()
{}

calcv_()
{}

short int calcphi_(nbt, nbg, nbl, nbc, t, g, x, Fsedo, dFsedo, f, df, le, ie)
      short int nbt, nbg, nbl, nbc;
      double *t, *g, **x, *f, **df, ***Fsedo, ***dFsedo;
      short int *le, *ie;
{
short int i;
double res;
double a[1], da[1][6];
ECRTRACE("calcphi");
for (i=0; i<nbl; i++)
  {
    res= ((x[i][1]) == ((double)1)) ? (Fsedo[i][0][0]) : (
      Fsedo[i][0][1]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=A;
        return(ERRMATH);
      }
    a[0]= res;
    res= a[0];
    f[i]= res;
    res= ((x[i][1]) == ((double)1)) ? (dFsedo[i][0][0]) : (
      dFsedo[i][0][6]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][0]= res;
    res= ((x[i][1]) == ((double)1)) ? (dFsedo[i][0][1]) : (
      dFsedo[i][0][7]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][1]= res;
    res= ((x[i][1]) == ((double)1)) ? (dFsedo[i][0][2]) : (
      dFsedo[i][0][8]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][2]= res;
    res= ((x[i][1]) == ((double)1)) ? (dFsedo[i][0][3]) : (
      dFsedo[i][0][9]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][3]= res;
    res= ((x[i][1]) == ((double)1)) ? (dFsedo[i][0][4]) : (
      dFsedo[i][0][10]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][4]= res;
    res= ((x[i][1]) == ((double)1)) ? (dFsedo[i][0][5]) : (
      dFsedo[i][0][11]);
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DADT;
        return(ERRMATH);
      }
    da[0][5]= res;
    res= da[0][0];
    df[i][0]= res;
    res= da[0][1];
    df[i][1]= res;
    res= da[0][2];
    df[i][2]= res;
    res= da[0][3];
    df[i][3]= res;
    res= da[0][4];
    df[i][4]= res;
    res= da[0][5];
    df[i][5]= res;
  }
return(OK);
}

short int calcodes_(neq, t, y, ydot)
      int *neq;
      double *t, *y, *ydot;
{
short int nbobs, idobs;
double res;
double a[1], da[1][6];
ECRTRACE("calcodes");
nbobs=neq[4];
idobs=neq[3];
res= ((y[16]) - ((y[17]) * (y[1]))) * (y[0]);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[0]= res;
res= ((y[18]) - ((y[19]) * (mydiv(y[1], y[0])))) * (y[1]);
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[1]= res;
res= (((y[16]) - ((y[17]) * (y[1]))) * (y[2])) + ((-((y[17]) * (
      y[8]))) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[2]= res;
res= (((y[16]) - ((y[17]) * (y[1]))) * (y[3])) + ((-((y[17]) * (
      y[9]))) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[3]= res;
res= (((y[16]) - ((y[17]) * (y[1]))) * (y[4])) + (((
      (double)1) - ((y[17]) * (y[10]))) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[4]= res;
res= (((y[16]) - ((y[17]) * (y[1]))) * (y[5])) + ((-(((y[17]) * (
      y[11])) + (y[1]))) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[5]= res;
res= (((y[16]) - ((y[17]) * (y[1]))) * (y[6])) + ((-((y[17]) * (
      y[12]))) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[6]= res;
res= (((y[16]) - ((y[17]) * (y[1]))) * (y[7])) + ((-((y[17]) * (
      y[13]))) * (y[0]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[7]= res;
res= (((y[18]) - ((y[19]) * (mydiv(y[1], y[0])))) * (y[8])) + (
      (-((y[19]) * (mydiv(((y[8]) * (y[0])) - ((y[1]) * (y[2])), 
      mypow(y[0], (double)2))))) * (y[1]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[8]= res;
res= (((y[18]) - ((y[19]) * (mydiv(y[1], y[0])))) * (y[9])) + (
      (-((y[19]) * (mydiv(((y[9]) * (y[0])) - ((y[1]) * (y[3])), 
      mypow(y[0], (double)2))))) * (y[1]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[9]= res;
res= (((y[18]) - ((y[19]) * (mydiv(y[1], y[0])))) * (y[10])) + (
      (-((y[19]) * (mydiv(((y[10]) * (y[0])) - ((y[1]) * (y[4])), 
      mypow(y[0], (double)2))))) * (y[1]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[10]= res;
res= (((y[18]) - ((y[19]) * (mydiv(y[1], y[0])))) * (y[11])) + (
      (-((y[19]) * (mydiv(((y[11]) * (y[0])) - ((y[1]) * (y[5])), 
      mypow(y[0], (double)2))))) * (y[1]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[11]= res;
res= (((y[18]) - ((y[19]) * (mydiv(y[1], y[0])))) * (y[12])) + (
      (((double)1) - ((y[19]) * (mydiv(((y[12]) * (
      y[0])) - ((y[1]) * (y[6])), mypow(y[0], 
      (double)2))))) * (y[1]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[12]= res;
res= (((y[18]) - ((y[19]) * (mydiv(y[1], y[0])))) * (y[13])) + (
      (-(((y[19]) * (mydiv(((y[13]) * (y[0])) - ((y[1]) * (
      y[7])), mypow(y[0], (double)2)))) + (mydiv(
      y[1], y[0])))) * (y[1]));
if (finite(res)!=1)
  {
  neq[6]=ERRMATH;
  return(ERRMATH);
  }
ydot[13]= res;
return(OK);
}

calcjac_()
{}
