/*----------------------------------------
description file: weibull.mod13866


% Weibull model (1.7) p1 - p2 * exp( - p3 * x^p4)
resp y;
var v;
varind x;
parresp p1,p2,p3,p4;
subroutine;
begin
y= p1 - p2 * exp( - p3 * exp(log(x)*p4));
v=1;
end
----------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "nltypes.h"
#include "nlcodes.h"
#include "nlmacros.h"
#include "nlfonc.h"

short int calcf_(nbt, nbg, nbl, nbc, t, g, x, f, df, le, ie)
      short int nbt, nbg, nbl, nbc;
      double *t, *g, **x, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
ECRTRACE("calcf");
for (i=0; i<nbl; i++)
  {
    res= (t[0]) - ((t[1]) * ((double)myexp((-(t[2])) * ((double)myexp(
      (myln(x[i][0])) * (t[3]))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=F;
        return(ERRMATH);
      }
    f[i]= res;
    res= (double)1;
    df[i][0]= res;
    res= -((double)myexp((-(t[2])) * ((double)myexp((myln(
      x[i][0])) * (t[3])))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][1]= res;
    res= -((t[1]) * ((-((double)myexp((myln(x[i][0])) * (
      t[3])))) * ((double)myexp((-(t[2])) * ((double)myexp(
      (myln(x[i][0])) * (t[3])))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][2]= res;
    res= -((t[1]) * (((-(t[2])) * ((myln(x[i][0])) * ((double)myexp(
      (myln(x[i][0])) * (t[3]))))) * ((double)myexp((-(t[2])) * (
      (double)myexp((myln(x[i][0])) * (t[3])))))));
    if (finite(res)!=1)
      {
        *ie=i+1;
        *le=DFDT;
        return(ERRMATH);
      }
    df[i][3]= res;
  }
return(OK);
}

short int calcv_(nbt, nbb, nbg, nbl, nbc, t, b, g,
                f, df, x, v, dtv, dbv, le, ie)
      short int nbt, nbb, nbg, nbl, nbc;
      double *t, *b, *g, **x, *v, **dtv, **dbv, *f, **df;
      short int *le, *ie;
{
short int i;
double res;
ECRTRACE("calcv");
for (i=0; i<nbl; i++)
  {
    res= (double)1;
    v[i]= res;
    res= (double)0;
    dtv[i][0]= res;
    res= (double)0;
    dtv[i][1]= res;
    res= (double)0;
    dtv[i][2]= res;
    res= (double)0;
    dtv[i][3]= res;
  }
return(OK);
}

calcodes_()
{}

calcjac_()
{}

calcphi_()
{}
