
/* +++++++++++++++++++++++++++++++++++++++++++++++++++
les define et les includes 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#include "nls2C.h"


/* ---------------------------------------------------------------------
ecrErr: ecriture des messages d'erreur 
fic: l'unit d'impression
nomcall: nom du programme appelant
message: un message qui s'crit en plus de celui de la cie d'erreur
Code: code de l'erreur: cf nls2C.h
-------------------------------------------------------------------------*/
void ecrErr(FILE *fic, char * nomcall , char *message, int Code)

{
fprintf(fic, "\n\n%s: error %d; ", nomcall, Code);

  switch(Code)
    {
    case ERRINPUT :
      /* erreur de lecture */
      fprintf(fic, "error when reading.\n%s\n",  message);
      break;

    case ERRCALLOC :
      /* erreur d'alloc */
      fprintf(fic, "memory allocation error.\n%s\n",  message);
      break;
      
    case ERRARG :
      /* erreur d'argument */
      fprintf(fic, "argument error.\n%s\n",  message);
      break;

    case ERRRECUP :
      /* erreur dans les valeurs recuperees */
      fprintf(fic, "error when accessing results.\n%s\n",  message);
      break;

    case FINOF :
      /* fin de fichier rencontre dans les entres */
      fprintf(fic, "premature end of the input file.\n%s\n",  message);
      break;

      case ERRFOUND :
	/* une structure  rcuprer n'a pas t calcule */
	fprintf(fic, "structure not found or not calculated.\n%s\n",  message);
      break;

      case ERRINT :
 /* internal erreur=Erreur dans mes programmes */
	fprintf(fic, "internal error (error in the programme).\n%s\n",  message);
      break;
      
      case WARNULL:
 /* Toutes les valeurs d'une structure  rcuprer sont nulles */
	fprintf(fic, 
"all values are NULL (structure not calculated).\n%s\n",  message);
      break;

    default:
      /* c'est un message de nls2 */
      fprintf(fic, "error when executing nls2.\n%s\n",  message);
      break;

    } /* fin du switch */
}
/* ------ fin ecrErr --------------------------------------- */
