
/* +++++++++++++++++++++++++++++++++++++++++++++++++++
les define et les includes 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#include "nls2C.h"
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    UTILITAIRES D'ECRITURE
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
void ecritVect(FILE *fic, char *titre, TVect Vect)
{
int i;


    if (Vect.nbele > 0)
      {
	fprintf(fic, "\n %s:\n", titre);
	for (i=0; i< Vect.nbele; i++)
	  {
	    if (myisnan(Vect.donnees[i]))
	      fprintf(fic, "NaN ");
	    else
	      fprintf(fic, "%g ", Vect.donnees[i]);
	    if ( (i>0) && ((i+1) % 5) ==0)
	      fprintf(fic, "\n");
	  }
	fprintf(fic, "\n");

  }
}
/* ------- fin ecritVect --------------------------- */

void ecritVectShort(FILE *fic, char *titre, TVectShort Vect)
{
int i;


    if (Vect.nbele > 0)
      {
	fprintf(fic, "\n%s:\n", titre);
	for (i=0; i< Vect.nbele; i++)
	  {
	    fprintf(fic, "%d ", Vect.donnees[i]);
	    if ( (i>0) && ((i+1) % 5) ==0)
	      fprintf(fic, "\n");
	  }
	fprintf(fic, "\n");

  }
}
/* ------- fin ecritVectShort --------------------------- */


void ecritMat(FILE *fic, char *titre, TMat Mat)
{
int i, j;


    if (Mat.nblig > 0)
      {
	fprintf(fic, "\n%s:\n", titre);
	for (i=0; i< Mat.nblig; i++)
	  {
	    for (j=0; j < Mat.nbcol; j++)
	      {
		if (myisnan(Mat.donnees[i][j]))
		  fprintf(fic, "NaN ");
		else
		  fprintf(fic, "%g ", Mat.donnees[i][j]);
	      }
	      fprintf(fic, "\n");
	  }
	fprintf(fic, "\n");
      }
}
/* ------- fin ecritMat --------------------------- */


void ecritVectStr(FILE *fic, char *titre, TVectStr Vect)
{
int i;


    if (Vect.nbele > 0)
      {
	fprintf(fic, "\n%s:\n", titre);
	for (i=0; i< Vect.nbele; i++)
	  {
	    fprintf(fic, "%s ", Vect.donnees[i]);
	    if ( (i>0) &&  ((i+1) % 5) ==0)
	      fprintf(fic, "\n");
	  }
	fprintf(fic, "\n");

  }
}
/* ------- fin ecritVectStr --------------------------- */
/* ------------------------------------------------
Ecrire  tout ce qui concerne Donnees
, TDonnees Donnees)
---------------------------------------------------*/
void ecrDonnees(FILE *fic)
{
fprintf(fic, "\n\n*** Data ***\n");
fprintf(fic, "number of curves: %d\n", Donnees.NbCourbe);
fprintf(fic, "number of observations: %ld\n", Donnees.NbObsT);
fprintf(fic, "number of independent variables: %d\n",Donnees.NbX);
fprintf(fic, "response variable name : %s\n",Donnees.NomY);
ecritVectStr(fic, "independent variables names", Donnees.NomX);

ecritVect(fic, "y", Donnees.ValY);
ecritMat(fic, "x", Donnees.XObsT);
ecritVect(fic, "weights", Donnees.PoidsT);
ecritVectStr(fic, "curves",Donnees.NomCT);
 if (Donnees.IndiceN >0) {
   fprintf(fic, "the independent variable number %d contains the counts\n",
	   Donnees.IndiceN);
 }

} 
/*--------------  fin ecrDonnees  ---------------------------- */

/* ------------------------------------------------
Ecrire  tout ce qui concerne un CtxNum
---------------------------------------------------*/
void ecrCtxNum(FILE *fic)
{
int i;


fprintf(fic, "\n\n*** Numerical context ***  \n");
for (i=0; i< CtxPuss.NbEtapes; i++)
  {
fprintf(fic, "-- For step %d \n", (i+1)); 
fprintf(fic, "method: %s \n", 
	recup1C("method",1));
fprintf(fic, "effic: %d \n", CtxNum[i].Effic);
fprintf(fic, "nh: %d \n", CtxNum[i].NbZ);
 fprintf(fic, "W.type: %s \n", recup1C("w.type",1));
 fprintf(fic, "stat.crit.code: %s \n", recup1C("stat.crit.code",1));
fprintf(fic, "\n");
  }

} 
/*--------------  fin ecrCtxNum  ---------------------------- */



/* ------------------------------------------------
Ecrire  tout ce qui concerne Modele
---------------------------------------------------*/
void ecrModele(FILE *fic)
{

fprintf(fic, "\n\n*** Model *** \n");
fprintf(fic, "odes: %d\n", Modele.CasSedo);
fprintf(fic, "model-file name: %s\n", Modele.NomFichier);
 fprintf(fic, "variance type: %s\n", recup1C("vari.type",1));
fprintf(fic, "variance function: %d\n", Modele.YaCalcV);


ecritVect(fic, "gamf", Modele.GamF);
ecritVect(fic, "gamv", Modele.GamV);
ecritVectStr(fic, "theta names", Modele.NomTheta);
ecritVectStr(fic, "beta names", Modele.NomBeta);
ecritVectStr(fic, "gamf names", Modele.NomGamF);
ecritVectStr(fic, "gamv names", Modele.NomGamV);
/* Les contraintes */
if (Modele.CTheta0.Ctr== VRAI)
  {
    fprintf(fic, "Constraints on theta: ");
    ecritVect(fic, "inf", Modele.CTheta0.BInf);
    ecritVect(fic, "sup", Modele.CTheta0.BSup);
    ecritVect(fic, "eq", Modele.CTheta0.EgalN);
    ecritVectShort(fic, "eqp", Modele.CTheta0.EgalP);
  }

if (Modele.CBeta0.Ctr== VRAI)
  {
    fprintf(fic, "Constraints on beta: ");
    ecritVect(fic, "inf", Modele.CBeta0.BInf);
    ecritVect(fic, "sup", Modele.CBeta0.BSup);
    ecritVect(fic, "eq", Modele.CBeta0.EgalN);
    ecritVectShort(fic, "eqp", Modele.CBeta0.EgalP);
  }

} 
/*--------------  fin ecrModele  ---------------------------- */


/* ------------------------------------------------
Ecrire  tout ce qui concerne GNLControle
---------------------------------------------------*/
void ecrCrole(FILE *fic)
{
int i;
TLogic vu=FAUX;

fprintf(fic, "\n\n***Control options: ***\n");

/* Les options de printing */

fprintf(fic, "freq: %ld\n", GNLControle.FreqIp);
fprintf(fic, "Printing options:\n");
fprintf(fic, 
" iter: %d num.res: %d odes: %d fitted: %d est.eq: %d estim: %d deriv.fct: %d\n",
GNLControle.VouluIp.NbIter, GNLControle.VouluIp.ResNum,
GNLControle.VouluIp.Sedo, GNLControle.VouluIp.Ajustes,
GNLControle.VouluIp.EquN, GNLControle.VouluIp.Estim,
GNLControle.VouluIp.FctSensib);

/* Les options de warning */
fprintf(fic, "Warning options:\n");
if (GNLControle.TypeLgMess == VRAI)
  fprintf(fic, " long warning messages.\n");
fprintf(fic, " lg.trace: %d\n", GNLControle.LgTrace);
fprintf(fic, " anal.warn: %d integ.warn: %d meth.warn: %d num.warn %d all.warn: %d\n",
GNLControle.NbWAnaly,GNLControle.NbWInteg,GNLControle.NbWMethe,
GNLControle.NbWNumer,GNLControle.NbWTotal);


fprintf(fic, "Optional results:\n");
fprintf(fic, " as.var: %d correlation: %d b.varz.b: %d mu: %d residuals: %d\n",
GNLControle.Voulu.AsVar, GNLControle.Voulu.Corr,
GNLControle.Voulu.BVarZBP, GNLControle.Voulu.Mu,
GNLControle.Voulu.Residus);


fprintf(fic, "Iteration results saving options:\n");

for (i=0; i < MAXETAP; i++)
  {
    if ( GNLControle.EtapeIt[i] == VRAI)
      {
	if (vu==FAUX)
	  fprintf(fic, " EtapeIt: ");
	fprintf(fic, "%d ", (i+1));
	vu=VRAI;
      }
  }
if (vu==VRAI)
  fprintf(fic, "\n");
fprintf(fic, 
" iter: %d num.res: %d odes: %d fitted: %d est.eq: %d estim: %d deriv.fct: %d\n",
GNLControle.VouluIt.NbIter, GNLControle.VouluIt.ResNum,
GNLControle.VouluIt.Sedo, GNLControle.VouluIt.Ajustes,
GNLControle.VouluIt.EquN, GNLControle.VouluIt.Estim,
GNLControle.VouluIt.FctSensib);

}
/* ----------- fin ecrCrole --------------------------------*/



/* ------------------------------------------------
Ecrire  tout ce qui concerne CtxPuss
---------------------------------------------------*/
void ecrCtxPuss(FILE *fic)
{


fprintf(fic, "\n\n*** Statistical context: ***\n");
fprintf(fic, "n.steps: %d", CtxPuss.NbEtapes);

ecritVect(fic, "theta.start", CtxPuss.Theta0);
ecritVect(fic, "beta.start", CtxPuss.Beta0);

 fprintf(fic, "algorithm: %s\n", recup1C("algo",1));
fprintf(fic, "omega.c1: %g\n", CtxPuss.DirecC);
fprintf(fic, "lambda.start: %g \n", CtxPuss.Lambda0);
fprintf(fic, "lambda.c1: %g \n", CtxPuss.LambdaC1);
fprintf(fic, "lambda.c2: %g \n", CtxPuss.LambdaC2);
fprintf(fic, "max.stop: %g \n", CtxPuss.MaxCritArret);
fprintf(fic, "max.err.c2: %ld \n", CtxPuss.MaxDeb);
fprintf(fic, "max.err.c1: %ld \n", CtxPuss.MaxErr);
fprintf(fic, "max.iter: %ld \n", CtxPuss.MaxIter);
fprintf(fic, "max.lambda: %g \n", CtxPuss.MaxLambda);
fprintf(fic, "omega.c2: %g \n", CtxPuss.OmegaPas);

if (CtxPuss.TypeSigma > 0)
   fprintf(fic, "sigma2.type: %s \n", recup1C("sigma2.type",1));
fprintf(fic, "sigma2: %g \n", CtxPuss.Sigma);

if (CtxPuss.TypeMu >0)
   fprintf(fic, "mu.type: %s \n", recup1C("mu.type",1));

if (CtxPuss.Famille >0)
 fprintf(fic, "family: %s\n", recup1C("fami",1));

ecritVect(fic, "mu3", CtxPuss.Mu3);
ecritVect(fic, "mu4", CtxPuss.Mu4);

} 
/*--------------  fin ecrCtxPuss  ---------------------------- */



/* ------------------------------------------------
Ecrire  tout ce qui concerne CtxInteg
---------------------------------------------------*/
void ecrCtxI(FILE *fic)
{
int i;

if (Modele.CasSedo==FAUX)
  {
   fprintf(fic, "\n\n*** No integration context: model not described by a odes ***\n");
   return;
  }

fprintf(fic, "\n\n***Integration context: ***\n");
fprintf(fic, "n.theta.odes: %d ", GNLCtxInteg.NbThetaSedo);
fprintf(fic, "pr.odes: %d ", GNLCtxInteg.ImpInteg);

fprintf(fic, "jt: %d ", GNLCtxInteg.jt);
fprintf(fic, "itol: %d\n", GNLCtxInteg.itol);
if (GNLCtxInteg.iopt==VRAI)
  {
fprintf(fic, "iopt: ");
for (i=0; i<9 ; i++)
  fprintf(fic, "%d ", GNLCtxInteg.proiwork[i]);
fprintf(fic, "\nropt: ");
for (i=0; i<7 ; i++)
  fprintf(fic, "%g ", GNLCtxInteg.prorwork[i]);
  }
fprintf(fic, "initial values are parameters: %d \n", GNLCtxInteg.IndicCi);
fprintf(fic, "observations in odes equations: %d \n", GNLCtxInteg.IndicX);
ecritVect(fic, "atol", GNLCtxInteg.atol);
ecritVect(fic, "rtol", GNLCtxInteg.rtol);
ecritVect(fic, "start", GNLCtxInteg.T0T);
/* A VOIR l'ip de GNLCtxInteg.IndicTj, GNLCtxInteg.VectCi quand il y en a */
} 
/* -------- fin ecrCtxI -------------- */

