/* +++++++++++++++++++++++++++++++++++++++++++++++++++
les define et les includes 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#include <ctype.h>
#include "nls2C.h"

/*----------------FONCTIONS EXTERNES ------------*/

/* pour crire les messages d'erreur */
extern void ecrErr(FILE *fic, char * nomcall , char *message, int Code);


/* programmes de lecture appels */
extern int litDonnees(FILE *fic, TVectStr motscle, TVectShort nbmotscle,
		  TLogic *luX, TLogic *luY,
		      TVect *MONx, TVectStr *nameN,
		  TDonnees *Donnees,
		  char *mot);
extern int litFile(FILE *fic,
               TDonnees *Donnees, 
	       TModele *Modele,
		TFuncInt *NbIndicTj);
extern int litModele(FILE *fic, 
	       TVectStr motscle, TVectShort nbmotscle,
	      TModele *Modele,
		  char *mot);
extern int litCtxPuss(FILE *fic, 
	       TVectStr motscle, TVectShort nbmotscle,
		TLogic *lusigma, TLogic *lumu3, TLogic *lumu4,
	      TCtxPuss *CtxPuss,
		  char *mot);

extern int litCtxNum(FILE *fic, 
	       TVectStr motscle, TVectShort nbmotscle,
		     int *nown,
         TVectShort *Estim, TVectShort *TypeCritStat,
	     TVectShort *NbZ, TVectShort *Effic, TVectShort *Symm,
		  char *mot);

extern int litCtxI(FILE *fic, TVectStr motscle, TVectShort nbmotscle,
	       TLogic *luStart, TLogic *luNThetaOde, TLogic *luitol,
	          TVect *MONTj, TVect *MONVectCi,
		  char *mot);

extern int litCrole(FILE *fic, 
	       TVectStr motscle, TVectShort nbmotscle,
		  char *mot);

extern int suiteDonnees( TLogic luFile, TLogic luX, TLogic luY,
   TVect *MONx, TVectStr *nameN, TDonnees *Donnees); 

extern int suiteCtxPuss(
	       TLogic lusigma, TLogic lumu3, TLogic lumu4,
	TDonnees *Donnees, TModele *Modele,	 TCtxPuss *CtxPuss);
extern int suiteCtxNum(TShortInt NbEtapes ,
		int nown,
         TVectShort *Estim, TVectShort *TypeCritStat,
	     TVectShort *NbZ, TVectShort *Effic, TVectShort *Symm,
		TCtxNum CtxNum[]);
extern int suiteCtxI(TLogic lustart, TLogic luNThetaOde,  TLogic luitol,
		     TFuncInt NbIndicTj,
	      TVect *MONTj, TVect *MONVectCi,
		     TShortInt NbCourbe, TLongInt NbObsT);
extern int suiteCrole(TShortInt NbEtapes);

/* Programmes de nls2/src */
TShortInt CreerVect( TShortInt nbele, TVect *pvect);
TShortInt CreerVectLong( TShortInt nbele, TVectLong *pvect);
TShortInt CreerVectShort( TShortInt nbele, TVectShort *pvect);
TShortInt CreerVectStr( TShortInt nbele, TVectStr *pvect);

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                UTILITAIRES DE LECTURE
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* ------------------------------------------------
Lire le fichier d'entre 
---------------------------------------------------*/
int lecture (FILE *fic, TDonnees *Donnees, TModele *Modele,
		TCtxPuss *CtxPuss, TCtxNum CtxNum[])

{
/* Autres programmes internes */
int initMotscle( TVectStr *motscle,
		 TVectShort *nbmotscle);


char * isMotscle	(char *mot, TVectStr motscle, TVectShort nbmotscle);


/* Pour les messages d'erreur */
char message[MAXLGMESS];
int Code=OK;

/* Pour la lecture des commentaires */
char ligne[MAXLIG];

char type[MAXLGCHP], mot[MAXLGCHP];
int  i, nown, nsteppred;
TFuncInt NbIndicTj=0;
/* Vecteurs o sont stockes des valeurs qu'il faut mettre
   en bonne dimension, une fois que tout est lu */
TVect MONx, MONTj, MONVectCi;
TVectShort Estim, TypeCritStat, NbZ, Effic, Symm;

/* Pour vrifier que ce qui est obligatoire y est bien */
TLogic luX, luY, luFile, lustart, luNThetaOde, luitol, 
  lumu3, lumu4, lusigma;
TVectStr motscle;
TVectShort nbmotscle;
 TVectStr nameN;

 CreerVectStr((TShortInt)1, &(nameN));
 nameN.nbele=0;
 /* On force nbele  0, il deviendra 1 si on remplit nameN dans litDonnees */

  /* Initialisations */
 /* CREER_T1(nameN,MAXCH, char); */

 initMotscle(&motscle, &nbmotscle);

 luX=FAUX; luY=FAUX; luFile=FAUX;   lustart=FAUX;  luNThetaOde=FAUX;
 lumu3=FAUX; lumu4=FAUX; lusigma=FAUX;
 luitol=FAUX;
 nsteppred=0;
 nown=0;
 Estim.nbele =0;
 TypeCritStat.nbele =0;
  NbZ.nbele =0;
  Effic.nbele =0;
  Symm.nbele =0;


fscanf(fic,"%20s", mot);
if (feof(fic))
  {
    ecrErr(stderr,"lecture","Nothing of the input file\n", ERRINPUT);
    return(ERRINPUT);
  }


/* On convertit la 'case' */
for (i=0; i< strlen(mot); i++)
  mot[i]=tolower(mot[i]);

/* Boucle de lecture */
while ( !feof(fic) )
  {
    /* Traitement des cas particuliers */
    if (strncmp(mot,"#",1)==0)
      {
	/* Commentaire jusqu'a la fin de ligne */
	fgets(ligne, MAXLIG, fic);
	fscanf(fic,"%20s", mot);
	continue; /* retour au debut de la boucle de lecture */
      }


    if (strncmp(mot,"file",4)==0)
      {
	if (luFile == VRAI)
	  {
	   ecrErr(stderr,"lecture",
"'file' read several times on the input file.\n",
		  ERRINPUT);
	    return(ERRINPUT);
	  }
	luFile=VRAI;

	Code =litFile(fic, Donnees,  Modele, &NbIndicTj);
	/* litFile ne renvoie que ERRINPUT ou OK */
	if (Code ==OK)
	  {
	    fscanf(fic,"%20s", mot);
	    continue; /* retour au debut de la boucle de lecture */
	  }
	else
	  {
	    sprintf(message, "Error when reading the model-file %s \n",
		    Modele->NomFichier);
	    ecrErr(stderr,"lecture",message,  Code);
	    return(Code);
	  }
      } /* fin if (strcmp(mot,"file")==0) */
    
    /* Quand on est ici, le mot-cl n'est pas 'file' ni un commentaire */
    strcpy(type, isMotscle (mot, motscle, nbmotscle));

    if (strcmp(type,"donnees")==0) 
      {
	Code= litDonnees(fic, motscle,  nbmotscle,
			    &luX, &luY,
			 &MONx,  &nameN,
			    Donnees,
			    mot);
	if (Code ==OK)
	  continue; /* retour au debut de la boucle de lecture */
	if (Code== FINOF)
	  break; /* sortie de la boucle de lecture */
	return(Code);
      } /* fin if (strcmp(type,"donnees")==0) */


    if (strcmp(type,"modele")==0) 
      {
	/* les mots du modele, a l'exception de file
	   qui aura trait a part: cf ci-dessus */
        Code= litModele(fic,  motscle, nbmotscle,
	      Modele, mot);
	if (Code ==OK)
	  continue; /* retour au debut de la boucle de lecture */
	if (Code== FINOF)
	  break; /* sortie de la boucle de lecture */
	return(Code);
      } /* fin if (strcmp(type,"modele")==0) */

    if (strcmp(type,"ctxpuss")==0) 
      {
	/* Traiter le ctxpuss */
	Code= litCtxPuss(fic, 
	        motscle, nbmotscle,
	       &lusigma, &lumu3, &lumu4,
	       CtxPuss,
		mot);

	if (Code ==OK)
	  continue; /* retour au debut de la boucle de lecture */
	if (Code== FINOF)
	  break; /* sortie de la boucle de lecture */
	return(Code);
      } /* fin if (strcmp(type,"ctxpuss") */
    
    if (strcmp(type,"ctxnum")==0) 
      {
	/* Traiter les ctxnum */
	Code= litCtxNum(fic, 
			motscle, nbmotscle,
			&nown,
			&Estim, &TypeCritStat,
			&NbZ, &Effic, &Symm,
			mot);
	if (Code ==OK)
	  continue; /* retour au debut de la boucle de lecture */
	if (Code== FINOF)
	  break; /* sortie de la boucle de lecture */
	return(Code);
      } /* fin if (strcmp(type,"ctxnum") */


    if (strcmp(type,"ctxi")==0) 
      {
	/* Traiter le ctxi */

	Code= litCtxI(fic,motscle, nbmotscle,
			 &lustart, &luNThetaOde, &luitol,
			 &MONTj, &MONVectCi,
			 mot);
	if (Code ==OK)
	  continue; /* retour au debut de la boucle de lecture */
	if (Code== FINOF)
	  break; /* sortie de la boucle de lecture */
	return(Code);
      } /* fin if (strcmp(type,"ctxi")==0) */
  
    if (strcmp(type,"crole")==0) 
      {
	/* Traiter le GNLControle */
	Code= litCrole(fic, motscle, nbmotscle,	mot);
	if (Code ==OK)
	  continue;
	if ( Code== FINOF)
	  break; 
	return(Code);
      } /* fin if (strcmp(type,"crole") */



    /* On est pass nulle part */
    fprintf(stderr, "Unknown word on the input-file: %s\nStop reading.\n", mot);
    return(ERRINPUT);
  } /* fin de la boucle de lecture */

/* -------- Les controles et remplissage de ce qui ne peut tre rempli
            que quand tout est lu ------------------------------ */
if ( (Code=suiteDonnees(luFile, luX, luY, &MONx, &nameN, Donnees)) !=OK)
  return(ERRINPUT);

if ( (Code= suiteCtxPuss( lusigma, lumu3, lumu4,
	Donnees, Modele, CtxPuss) ) !=OK)
  return(ERRINPUT);
    
if ( (Code=  suiteCtxNum(CtxPuss->NbEtapes ,
		 nown,
         &Estim, &TypeCritStat, &NbZ, &Effic, &Symm,
		CtxNum)) !=OK)
  return(ERRINPUT);

if ( (Code=  suiteCrole(CtxPuss->NbEtapes)) !=OK)
  return(ERRINPUT);

if (Modele->CasSedo == VRAI)
  {
    if ( (Code= suiteCtxI(lustart, luNThetaOde, luitol,
			NbIndicTj,  &MONTj, &MONVectCi, 
			  Donnees->NbCourbe,
                          Donnees->NbObsT)) !=OK)
  return(ERRINPUT);

  } /* fin (Modele->CasSedo */


/* Les valeurs par defaut : quand des resultats par iter,
   par defaut, ce sont ceux de la derniere tape */
if ( ( (GNLControle.VouluIt.Ajustes ==VRAI) ||
       (GNLControle.VouluIt.Sedo  ==VRAI) ||
       (GNLControle.VouluIt.EquN ==VRAI) ||
       (GNLControle.VouluIt.Estim ==VRAI) ||
       (GNLControle.VouluIt.FctSensib ==VRAI) ||
       (GNLControle.VouluIt.NbIter ==VRAI) ||
       (GNLControle.VouluIt.ResNum ==VRAI) ) &&
     (GNLControle.EtapeIt[0] == FAUX))
  {
  GNLControle.EtapeIt[CtxPuss->NbEtapes-1] = VRAI;
  }


return(Code);
}
/* --------------- fin lecture ----------------------------*/



/* ------------------------------------------------
initialise le tableau des mots-cle
   ------------------------------------------------ */
int initMotscle( TVectStr *motscle, TVectShort *nbmotscle)
{

short i;

/* indice > du dernier de chaque catgorie */
APPEL(CreerVectShort((TShortInt)6 , nbmotscle));
 nbmotscle->donnees[0] = 12; /*  nbmodele */
 nbmotscle->donnees[1] = nbmotscle->donnees[0]  + 6; /* nbdonnees */
 nbmotscle->donnees[2] = nbmotscle->donnees[1] + 11 ; /* nbctxi */
 nbmotscle->donnees[3] = nbmotscle->donnees[2] + 20 ; /* ctxpuss */
 nbmotscle->donnees[4] = nbmotscle->donnees[3] + 5 ; /* ctxnum */
 nbmotscle->donnees[5] = nbmotscle->donnees[4] + 30 ; /* ctrole */

APPEL(CreerVectStr((TShortInt)nbmotscle->donnees[5] , motscle));

i=0;
/* mots-cle concernant le modele */ 
strcpy(motscle->donnees[i++], "file" );
strcpy(motscle->donnees[i++], "gamf");
strcpy(motscle->donnees[i++], "gamv");
strcpy(motscle->donnees[i++], "vari.type");
strcpy(motscle->donnees[i++], "eq.theta");
strcpy(motscle->donnees[i++], "inf.theta");
strcpy(motscle->donnees[i++], "sup.theta");
strcpy(motscle->donnees[i++], "eqp.theta");
strcpy(motscle->donnees[i++], "eq.beta");
strcpy(motscle->donnees[i++], "inf.beta");
strcpy(motscle->donnees[i++], "sup.beta");
strcpy(motscle->donnees[i++], "eqp.beta");


  /* mots-cle concernant les donnes */
strcpy(motscle->donnees[i++], "x");
strcpy(motscle->donnees[i++], "y");
strcpy(motscle->donnees[i++], "weights");
strcpy(motscle->donnees[i++], "curves");
strcpy(motscle->donnees[i++], "n.curves");
strcpy(motscle->donnees[i++], "nameN");


/* mots-cle concernant le ctxi */
strcpy(motscle->donnees[i++], "start");
strcpy(motscle->donnees[i++], "n.theta.odes");
strcpy(motscle->donnees[i++], "integ.values");
strcpy(motscle->donnees[i++], "pr.odes");
strcpy(motscle->donnees[i++], "cond.start");
strcpy(motscle->donnees[i++], "iopt");
strcpy(motscle->donnees[i++], "ropt");
strcpy(motscle->donnees[i++], "itol");
strcpy(motscle->donnees[i++], "rtol"); 
strcpy(motscle->donnees[i++], "atol"); 
strcpy(motscle->donnees[i++], "jt");
/* jt: => methode de calcul du jacobian (pas dans le HTML: A VOIR) */



/* mots-cle concernant le ctxpuss */
strcpy(motscle->donnees[i++], "theta.start");
strcpy(motscle->donnees[i++], "beta.start");
strcpy(motscle->donnees[i++], "algorithm");
strcpy(motscle->donnees[i++], "family");
strcpy(motscle->donnees[i++], "n.steps");
strcpy(motscle->donnees[i++], "sigma2.type");
strcpy(motscle->donnees[i++], "sigma2");
strcpy(motscle->donnees[i++], "mu.type");
strcpy(motscle->donnees[i++], "mu3");
strcpy(motscle->donnees[i++], "mu4");
strcpy(motscle->donnees[i++], "max.err.c1");
strcpy(motscle->donnees[i++], "max.err.c2");
strcpy(motscle->donnees[i++], "max.iters");
strcpy(motscle->donnees[i++], "omega.c1");
strcpy(motscle->donnees[i++], "omega.c2");
strcpy(motscle->donnees[i++], "lambda.start");
strcpy(motscle->donnees[i++], "lambda.c1");
strcpy(motscle->donnees[i++], "lambda.c2");
strcpy(motscle->donnees[i++], "max.lambda");
strcpy(motscle->donnees[i++], "max.stop.crit");

/* mots-cle concernant les ctxnum */
strcpy(motscle->donnees[i++], "method");
strcpy(motscle->donnees[i++], "nh");
strcpy(motscle->donnees[i++], "effic");
strcpy(motscle->donnees[i++], "w.type");
strcpy(motscle->donnees[i++], "fit.type");

/* mots-cle concernant le control */
strcpy(motscle->donnees[i++], "freq");
strcpy(motscle->donnees[i++], "out");
strcpy(motscle->donnees[i++], "iter");
strcpy(motscle->donnees[i++], "fitted");
strcpy(motscle->donnees[i++], "est.eq");
strcpy(motscle->donnees[i++], "estim");
strcpy(motscle->donnees[i++], "deriv.fct");
strcpy(motscle->donnees[i++], "num.res");
strcpy(motscle->donnees[i++], "odes");


strcpy(motscle->donnees[i++], "it.steps");
strcpy(motscle->donnees[i++], "it.iter");
strcpy(motscle->donnees[i++], "it.fitted");
strcpy(motscle->donnees[i++], "it.est.eq");
strcpy(motscle->donnees[i++], "it.estim");
strcpy(motscle->donnees[i++], "it.deriv.fct");
strcpy(motscle->donnees[i++], "it.num.res");
strcpy(motscle->donnees[i++], "it.odes");

strcpy(motscle->donnees[i++], "as.var");
strcpy(motscle->donnees[i++], "correlation");
strcpy(motscle->donnees[i++], "b.varz.b");
strcpy(motscle->donnees[i++], "mu");
strcpy(motscle->donnees[i++], "residuals");
strcpy(motscle->donnees[i++], "w");

strcpy(motscle->donnees[i++], "anal.warn");
strcpy(motscle->donnees[i++], "integ.warn");
strcpy(motscle->donnees[i++], "meth.warn");
strcpy(motscle->donnees[i++], "num.warn");
strcpy(motscle->donnees[i++], "all.warn");
strcpy(motscle->donnees[i++], "lg.trace");
strcpy(motscle->donnees[i++], "warn");


return(OK);

} 
		 
/* --------------- fin initMotscle  ----------------------------*/
/* ------------------------------------------------
Determine si 'mot' est un 'motcle' et si oui,
de quel type: 
renvoie "modele", "donnees", "ctxpuss", "ctxnum",
"print" "warn", "save", "iter", "ctxi"
"aucun"
   ------------------------------------------------ */
char * isMotscle (char *mot, TVectStr motscle, TVectShort nbmotscle)
{
int nmot,i;

    /* Est-ce que c'est un mot-cle ? */
    if (strncmp(mot,"#",1)==0)
      return("comment");

    for (nmot=0; nmot < motscle.nbele; nmot++)
      {
	if (strcmp(mot,motscle.donnees[nmot]) ==0)
	  {
	    /* c'est un mot-cle */
	    i=0;
	    if (nmot < nbmotscle.donnees[i++])
	      return("modele");
	    if (nmot < nbmotscle.donnees[i++])
	      return("donnees");
	    if (nmot < nbmotscle.donnees[i++])
	      return("ctxi");
	    if (nmot < nbmotscle.donnees[i++])
	      return("ctxpuss");
	    if (nmot < nbmotscle.donnees[i++])
	      return("ctxnum");
	    if (nmot < nbmotscle.donnees[i])
	      return("crole");

	  } /* fin if (strncmp(mot */
      } /* fin for (nmot=0 */

    /* on est pass nulle part */
return("aucun");
}
/* --------------- fin isMotscle ----------------------------*/




/* ------------------------------------------------
Tester si une chaine de car minuscules est un nombre
Accepte les nan si nanok=VRAI
---------------------------------------------------*/
TLogic isNumber(char * chaine, TLogic nanok)
{
int i, nbrec=0;
char c;



/* Tester si nan */
if (strncmp(chaine, "nan",3)==0)
  {
    if (nanok==VRAI)
      return(VRAI);
    else
      return(FAUX);
  }

for (i=0; i< strlen(chaine); i++)
  {
    c=chaine[i];
    if ( !isdigit((int)c)  && 
	 (c !='u')  && (c !='l')  && (c !='e') &&
	 (c !='+') && (c !='-') &&
	 (c !='.'))
      {
	return(FAUX);
      }
    else
      {
	/* c'est qqche d'un nombre : est-ce un digit ? */

	if ( isdigit((int)c) )
	  {
	  nbrec++;
	  }
      } /* fin if ( !isdigit((int)c) && !isxdigit((int)c) &&.. */
  } /* fin for i */


if (nbrec ==0)
  return(FAUX); /* aucun chiffre */
else
  return(VRAI);

} 
/* --------- fin isNumber ----------------------------- */


/* ------------------------------------------------
Recreer un vecteur de char 
---------------------------------------------------*/
TShortInt ReCreerVectStr(TShortInt  n0, TVectStr *vect)
{
int i;

  vect->donnees = (char **) realloc ((char *)vect->donnees, 
				     n0*sizeof(char *)); 
  if (vect->donnees == NULL) 
    { 
    fprintf(stdout, "Memory allocation problem\n"); 
    exit(ERRALLOC); 
    } 
 for (i=vect->nbele; i<n0; i++)
   {
     CREER_T1(vect->donnees[i], MAXCH, char);
    }
     
 vect->nbele = n0;
return(OK);
}
/* -------- Fin ReCreerVectStr -----------------------------*/

/* ------------------------------------------------------------
Contrle du nbre de valeurs lues quand on le connait  a priori:
   il ne faut pas qu'il y ait plus de valeurs que la taille alloue
----------------------------------------------------------------*/
int controlmoinsnbP(int nbP, int iallouee, char *mot)
{
char message[MAXLGMESS];

    if ((nbP>0) && ( (iallouee+1) > nbP))
      {
	sprintf(message,
"End of list of values expected after '%s': %d values read, %d expected.\n",
mot, (iallouee+1), nbP); 
	ecrErr(stderr,"controlmoinsnbP", message, ERRINPUT);
	return(ERRINPUT);
      } /* fin if ((nbP>0) && (iallouee  */
return(OK);
}
/* -------- fin controlmoinsnbP -------------------------------- */


/* ------------------------------------------------------------
Contrle du nbre de valeurs lues quand on le connait  a priori
      il faut qu'il y ait exactement le nbre de valeurs attendu 
iallouee pointe sur l'indice dans le vecteur o on doit mettre le mot
Comme on appelle controlegalnbP quand le mot n'est plus du type
attendu ou quand feof.
 iallouee est gal  1+l'indice du dernier dans le vecteur
ou, si feof, l'indice du dernier dans le vecteur
----------------------------------------------------------------*/
int controlegalnbP(FILE *fic, int nbP, int iallouee, char *mot)
{
char message[MAXLGMESS];


    if (nbP>0)
      {
	if ( feof(fic) && ( (iallouee+1) != nbP))
	     {
	      sprintf(message,
"End of file  unexpected: %d values, %d expected.\n", (iallouee+1), nbP); 
	      ecrErr(stderr,"controlegalnbP", message, ERRINPUT);
	      return(ERRINPUT);
	     }
	if (!feof(fic) && (iallouee != nbP))
	  {
	    sprintf(message,
"End of list of values before or after '%s': %d values, %d expected.\n",
mot,iallouee, nbP); 
	    ecrErr(stderr,"controlegalnbP", message, ERRINPUT);
	    return(ERRINPUT);
	  }
      } /* fin if ((nbP>0)  */
return(OK);
}
/* -------- fin controlegalnbP -------------------------- */
/* --------------------------------------------------------------
Vrifie que le mot correspond a un 'logic'
et le transforme en "0" ou "1"
--------------------------------------------------------------- */
int trLogic(char *mot, TLogic *fini)
{
int  bool;
char message[MAXLGMESS];
int Code=OK;


    if (isNumber(mot, FAUX) ==FAUX)
      { /* c'est pas un nombre */
	/* C'est pas un nombre, mais true ou false ou vrai ou faux */
	switch (tolower(mot[0]))
	  {
	  case 't':
	  case 'v':
	  case 'o':
	  case 'y':
	    strcpy(mot,"1");
	    break;
	  case 'f':
	  case 'n':
	    strcpy(mot,"0");
	    break;
	  default:
	    *fini=VRAI;
	    return(Code);
	  } /* fin switch (tolower(mot[0])) */
      } /* fin c'est pas un nbre */
    else
      {
	/* c'est un nombre */
	bool=atoi(mot);
	if ((bool !=0) && (bool !=1))
	  {
	   sprintf(message,
"Logical value expected instead of %s.\n",
mot);
	 ecrErr(stderr,"trLogic", message, ERRINPUT);
	 return(ERRINPUT);
	  } /* fin if ((bool !=0) && (bool !=1)) */
      } /* fin c'est un nombre */


return(Code);

}
/* ---------------- fin trLogic ------------------------------- */

/* ----------------------------------------------------------
Effectuer tout ce qui est commun aux Lit*  l'intrieur de la
boucle de lecture
En entre, 'mot' est le dernier mot lu,  et en sortie
'motsuiv' est le suivant s'il existe.
Renvoie 'fini': VRAI si le mot lu n'est pas du type attendu
ou bien, le 'mot' en entre est du type attendu
mais quand on essaie de lire le suivant, on rencontre la fin de fichier
-------------------------------------------------------------*/
int communLitVect(FILE *fic,
		  TVectStr motscle, TVectShort nbmotscle,
		  char type, int iallouee, int nbP,
		  TLogic *fini,
		  char *argumot, char*motsuiv)
{
int i;
char message[MAXLGMESS], ligne[MAXLIG], mot[MAXLGMESS];
int Code=OK;

*fini=FAUX;
strcpy(mot, argumot);


while (*fini==FAUX)
  {
    if (feof(fic))
      {
	*fini=VRAI;
      }

    if (strncmp(mot,"#",1)==0)
      {
	/* Commentaire jusqu'a la fin de ligne */
	fgets(ligne, MAXLIG, fic);
	fscanf(fic,"%20s", mot);
      }
    else
      break;

  } /* fin while (fini==FAUX) */


if (*fini==FAUX)
  {
   /* On convertit la 'case' */
   for (i=0; i< strlen(mot); i++)
     mot[i]=tolower(mot[i]);
   strcpy(argumot, mot);


switch(type)
  {
  case 'c':
   if (strcmp(isMotscle(mot, motscle, nbmotscle), "aucun")!=0)
     {
       /* on a fini le vecteur caractre */
       *fini=VRAI;
     }
   break; /* sortie du switch */
  case 'd':
    if (isNumber(mot, VRAI) ==FAUX)
      {
	*fini=VRAI; /* fin du numerique, les nan etant considrs comme tel */
     }
   break; /* sortie du switch */
  case 's':
  case 'i':
    if (isNumber(mot, FAUX) ==FAUX)
      {
	*fini=VRAI; /* fin du numerique, les nan n'tant pas considrs comme tel */
     }
   break; /* sortie du switch */
  case 'b': /* type logic */
    Code=trLogic(mot, fini);
   strcpy(argumot, mot);
    break; /* sortie du switch */

      
  default:
    sprintf(message,
"Internal error, type %c not valid.\n", type);
    ecrErr(stderr,"communLitVect", message, ERRINT);
    return(ERRINT);

  } /* fin switch(type) */
  } /* fin fini=faux */


/* Si le mot est du type attendu, fini=FAUX */
if (*fini==FAUX)
  {


/* On contrle le nbre de valeurs quand on le connait :
   il ne faut pas qu'il y ait plus de valeurs que la taille alloue */
 if ((Code=controlmoinsnbP(nbP, iallouee, mot)) !=OK)
      return(Code);

 fscanf(fic,"%s", motsuiv);


    if (feof(fic))
	{
	  *fini=VRAI;
	}

  } /* fin if (*fini==FAUX) */
else
  {

    /* Le 'mot' en entre n'est pas du type attendu */
    strcpy(motsuiv, mot);
  } /* fin fini=VRAI */

if (*fini ==VRAI)
  {
    /* On contrle le nbre de valeurs quand on le connait :
      il faut qu'il y ait exactement le nbre de valeurs attendu */
    if ((Code=controlegalnbP(fic, nbP, iallouee, mot)) !=OK)
      return(Code);
  }


 if (feof(fic))
   {
     return(FINOF);
   }
 else
   return(OK);

}
/* -------------- fin communLitVect -------------------------*/

/* --------------------------------------------------------------
LitVectP:
Lecture d'un Vect double dont on ignore la longueur si nbP <=0.
Si *nbP< 0, on ignore a priori, le nbre de valeurs  lire et alors,
en sortie, on renvoie le nbre  de valeurs lues
On est positionn au dbut du vecteur  lire, i.e aprs le mot-cl
qui l'introduit.
La fin du vecteur est determine par la prochaine chaine de car
qui n'est pas un nombre.
Renvoie celle-ci dans mot.
------------------------------------------------------------- */

int LitVectP(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     int *nbP,
                char *mot, TVect *Val)
{
/* Pour les messages d'erreur */
char message[MAXLGMESS];

int iallouee=0;
int lgallouee=LGALLOC; /* On alloue par tranche de LGALLOC */
int Code=OK;
TLogic fini=FAUX;
char ligne[MAXLIG], motsuiv[MAXLGCHP];


while (fini==FAUX)
  {

    if (feof(fic))
      {
	   /* on n'a rien lu */
	   sprintf(message,
"End of the input-file unexpected after %s.\n", mot);
	   ecrErr(stderr,"LitVectP", message, ERRINPUT);
	   return(ERRINPUT);
      }
    fscanf(fic,"%s", mot);

    if (strncmp(mot,"#",1)==0)
      {
	/* Commentaire jusqu'a la fin de ligne */
	fgets(ligne, MAXLIG, fic);
      }
    else
      break;

  } /* fin while (fini==FAUX) */

if (*nbP>0)
  lgallouee=*nbP;
CreerVect((TShortInt)lgallouee, Val);

while (fini==FAUX)
  {
    /* Tout ce qui est commun  tous les LitVect */
    Code=communLitVect(fic, motscle, nbmotscle, 'd', iallouee, *nbP, &fini, mot, motsuiv);


    if ( (Code !=OK) && (Code != FINOF))
      return(Code);
    if ((fini==FAUX) || feof(fic))
      {
	/* On met le mot dans le vecteur */
	if (iallouee >= lgallouee)
	  {
	    lgallouee=lgallouee+LGALLOC;
	    RECREER_T1(Val->donnees, lgallouee, TDouble);
	  }
  

/* conversion des donnees manquantes car isnan,
defini dans macros.h, ne marche que sur
les valeurs auxquelles on affecte DBL_MAX */
/* DBL_MAX est defini dans float.h */
   if (strncmp(mot, "nan",3)==0)
     Val->donnees[iallouee]=DBL_MAX ;
   else
     Val->donnees[iallouee]= (TDouble)atof(mot);

   /*       printf("vectp[%d]=%g\n", iallouee, Val->donnees[iallouee]);  */

    iallouee++;   
      } /* fin pas fini */
    if ((fini==FAUX) && (Code != FINOF))
            strcpy(mot, motsuiv);
  } /* fin while */

    /* On ajuste la longueur alloue  celle effectivement utilise */
 if (*nbP <= 0)
   {
    Val->nbele=  iallouee;
    RECREER_T1(Val->donnees, iallouee, double);
   }
 /* On renvoie la longueur effective */
 *nbP= iallouee;
    
    return(Code);
}
/* ----------------- fin de LitVectP  ------------------------- */

/* -------------------------------------------------------------

Lecture d'un VectStr
Si *nbP< 0, on ignore a priori, le nbre de valeurs  lire et alors,
en sortie, on renvoie le nbre  de valeurs lues
 Pour les chaines de car, on lit jusqu'a eof,   ou chaine =un mot-cle 
------------------------------------------------------------- */
int LitVectPStr(FILE *fic,
		TVectStr motscle, TVectShort nbmotscle,
		int *nbP,
                char *mot, TVectStr *VectStr)
{
/* Pour les messages d'erreur */
char message[MAXLGMESS];

int iallouee=0;
int lgallouee=LGALLOC; /* On alloue par tranche */
int Code=OK;
TLogic fini=FAUX;
char ligne[MAXLIG], motsuiv[MAXLGCHP];

while (fini==FAUX)
  {
    if (feof(fic))
  {
	   /* on n'a rien lu */
	   sprintf(message,
"End of the input-file unexpected after %s.\n", mot);
	   ecrErr(stderr,"LitVectPStr", message, ERRINPUT);
	   return(ERRINPUT);
  }
fscanf(fic,"%s", mot);
    if (strncmp(mot,"#",1)==0)
      {
	/* Commentaire jusqu'a la fin de ligne */
	fgets(ligne, MAXLIG, fic);
      }
    else
      break;
  } /* fin while (fini==FAUX) */

if (*nbP>0)
  lgallouee=*nbP;

 CreerVectStr((TShortInt)lgallouee, VectStr);

while (fini==FAUX)
  {
    /* Tout ce qui est commun  tous les LitVect */
    Code=communLitVect(fic, motscle, nbmotscle, 'c', iallouee, *nbP, &fini,mot, motsuiv);


    if ( (Code !=OK) && (Code != FINOF))
      return(Code);
    if ((fini==FAUX) || feof(fic))
      {
	/* On met le mot dans le vecteur */
   if (iallouee >= lgallouee)
     {
       lgallouee=lgallouee+LGALLOC;
       ReCreerVectStr(lgallouee, VectStr) ; 

     }
  
     strcpy(VectStr->donnees[iallouee], mot);

    #ifdef DEBUG 
       printf("chaine[%d]=%s\n", iallouee, VectStr->donnees[iallouee]); 
       #endif
    iallouee++;   
  } /* fin pas fini */
    if ((fini==FAUX) && (Code != FINOF))
      strcpy(mot, motsuiv);
  } /* fin while */

    /* On ajuste la longueur alloue  celle effectivement utilise */

 if (*nbP <= 0)
   {
     ReCreerVectStr(iallouee, VectStr);
   }
 /* On renvoie la longueur effective */
 *nbP= iallouee;
    
      

return(Code);

}

/* ----------------- fin de LitVectPStr ------------------------- */



/* --------------------------------------------------------------
LitVectPS:
Lecture d'un Vect short dont on ignore la longueur si nbP <=0.
Si *nbP< 0, on ignore a priori, le nbre de valeurs  lire et alors,
en sortie, on renvoie le nbre  de valeurs lues
On est positionn au dbut du vecteur  lire, i.e aprs le mot-cl
qui l'introduit.
La fin du vecteur est determine par la prochaine chaine de car
qui n'est pas un nombre.
Renvoie celle-ci dans mot.
------------------------------------------------------------- */

int LitVectPS(FILE *fic, 
	      TVectStr motscle, TVectShort nbmotscle,
	      int *nbP,
                char *mot, TVectShort *Val)
{
/* Pour les messages d'erreur */
char message[MAXLGMESS];
int iallouee=0;
int lgallouee=LGALLOC; /* On alloue par tranche de LGALLOC */
int Code=OK;
TLogic fini=FAUX;
char ligne[MAXLIG], motsuiv[MAXLGCHP];

while (fini==FAUX)
  {
    if (feof(fic))
  {
	   /* on n'a rien lu */
	   sprintf(message,
"End of the input-file unexpected after %s.\n", mot);
	   ecrErr(stderr,"LitVectPS", message, ERRINPUT);
	   return(ERRINPUT);
  }
fscanf(fic,"%s", mot);
    if (strncmp(mot,"#",1)==0)
      {
	/* Commentaire jusqu'a la fin de ligne */
	fgets(ligne, MAXLIG, fic);
      }
    else
      break;

  } /* fin while (fini==FAUX) */

if (*nbP>0)
  lgallouee=*nbP;
CreerVectShort((TShortInt)lgallouee, Val);

while (fini==FAUX)
  {
    /* Tout ce qui est commun  tous les LitVect */
    Code=communLitVect(fic, motscle, nbmotscle, 's', iallouee, *nbP, &fini,mot, motsuiv);
    if ( (Code !=OK) && (Code != FINOF))
      return(Code);
    if ((fini==FAUX) || feof(fic))
      {
	/* On met le mot dans le vecteur */
   if (iallouee >= lgallouee)
     {
       lgallouee=lgallouee+LGALLOC;
       RECREER_T1(Val->donnees, lgallouee, TShortInt);
     }
     Val->donnees[iallouee]= (TShortInt)atoi(mot);

    #ifdef DEBUG 
       printf("vectps[%d]=%d\n", iallouee, Val->donnees[iallouee]); 
       #endif
    iallouee++;   
      } /* fin pas fini */
    if ((fini==FAUX) && (Code != FINOF))
      strcpy(mot, motsuiv);
  } /* fin while */

    /* On ajuste la longueur alloue  celle effectivement utilise */
 if (*nbP <= 0)
   {
    Val->nbele=  iallouee;
    RECREER_T1(Val->donnees, iallouee, TShortInt);
   }
 /* On renvoie la longueur effective */
 *nbP= iallouee;
    
      

    return(Code);
}
/* ----------------- fin de LitVectPS  ------------------------- */





/* --------------------------------------------------------------
LitVectPL:
Lecture d'un Vect long dont on ignore la longueur si nbP <=0.
Si *nbP< 0, on ignore a priori, le nbre de valeurs  lire et alors,
en sortie, on renvoie le nbre  de valeurs lues
On est positionn au dbut du vecteur  lire, i.e aprs le mot-cl
qui l'introduit.
La fin du vecteur est determine par la prochaine chaine de car
qui n'est pas un nombre.
Renvoie celle-ci dans mot.
------------------------------------------------------------- */

int LitVectPL(FILE *fic,
		  TVectStr motscle, TVectShort nbmotscle,
	        int *nbP,char *mot, TVectLong *Val)
{
/* Pour les messages d'erreur */
char message[MAXLGMESS];

int iallouee=0;
int lgallouee=LGALLOC; /* On alloue par tranche de LGALLOC */
int Code=OK;
TLogic fini=FAUX;
char ligne[MAXLIG], motsuiv[MAXLGCHP];

while (fini==FAUX)
  {
    if (feof(fic))
  {
	   /* on n'a rien lu */
	   sprintf(message,
"End of the input-file unexpected after %s.\n", mot);
	   ecrErr(stderr,"LitVectPL", message, ERRINPUT);
	   return(ERRINPUT);
  }
fscanf(fic,"%s", mot);
    if (strncmp(mot,"#",1)==0)
      {
	/* Commentaire jusqu'a la fin de ligne */
	fgets(ligne, MAXLIG, fic);
      }
    else
      break;

  } /* fin while (fini==FAUX) */


if (*nbP>0)
  lgallouee=*nbP;
CreerVectLong((TShortInt)lgallouee, Val);

while (fini==FAUX)
  {
    /* Tout ce qui est commun  tous les LitVect */
    Code=communLitVect(fic, motscle, nbmotscle, 'l', iallouee, *nbP, &fini,mot, motsuiv);
    if ( (Code !=OK) && (Code != FINOF))
      return(Code);
    if ((fini==FAUX) || feof(fic))
      {
	/* On met le mot dans le vecteur */
   if (iallouee >= lgallouee)
     {
       lgallouee=lgallouee+LGALLOC;
       RECREER_T1(Val->donnees, lgallouee, TLongInt);
     }
     Val->donnees[iallouee]= (TLongInt)atoi(mot);

    #ifdef DEBUG 
       printf("vectpl[%d]=%d\n", iallouee, Val->donnees[iallouee]); 
       #endif
    iallouee++;   
      } /* fin pas fini */
    if ((fini==FAUX) && (Code != FINOF))
      strcpy(mot, motsuiv);
  } /* fin while */

    /* On ajuste la longueur alloue  celle effectivement utilise */
 if (*nbP <= 0)
   {
    Val->nbele=  iallouee;
    RECREER_T1(Val->donnees, iallouee, TLongInt);
   }
 /* On renvoie la longueur effective */
 *nbP= iallouee;
    
      
    return(Code);

}
/* ----------------- fin de LitVectPL  ------------------------- */


/* --------------------------------------------------------------
LitDouble:
Lecture d'un nbre TDouble
------------------------------------------------------------- */

int LitDouble(FILE *fic,  TVectStr motscle, TVectShort nbmotscle,
	   TDouble *nbP,char *mot)
{

/* Pour les messages d'erreur */
char message[MAXLGMESS];
int Code=OK;
int iallouee=0;
TLogic fini=FAUX;
char ligne[MAXLIG], motsuiv[MAXLGCHP];

while (fini==FAUX)
  {
if (feof(fic))
  {
	   /* on n'a rien lu */
	   sprintf(message,
"End of the input-file unexpected after %s.\n", mot);
	   ecrErr(stderr,"LitDouble", message, ERRINPUT);
	   return(ERRINPUT);
  }
fscanf(fic,"%s", mot);
    if (strncmp(mot,"#",1)==0)
      {
	/* Commentaire jusqu'a la fin de ligne */
	fgets(ligne, MAXLIG, fic);
      }
    else
      break;

  } /* fin while (fini==FAUX) */


    /* Tout ce qui est commun  tous les LitVect */
    Code=communLitVect(fic, motscle, nbmotscle, 'i', iallouee, 1, &fini, mot, motsuiv);
    if ( (Code !=OK) && (Code != FINOF))
      return(Code);
    if ((fini==FAUX) || feof(fic))
      {
	/* On met le mot dans nbP */
	*nbP=(TDouble) atof(mot);
  #ifdef DEBUG
    printf("double=%g\n", *nbP);
  #endif
          } /* fin pas fini */
    if ((fini==FAUX) && (Code != FINOF))
      strcpy(mot, motsuiv);
    
      

    return(Code);
}
/* --------------- fin de LitDouble --------------------------------*/


/* --------------------------------------------------------------
LitInt:
Lecture d'un nbre int
------------------------------------------------------------- */

int LitInt(FILE *fic,  TVectStr motscle, TVectShort nbmotscle,
	   int *nbP,char *mot)
{

/* Pour les messages d'erreur */
char message[MAXLGMESS];
int Code=OK;
int iallouee=0;
TLogic fini=FAUX;
char ligne[MAXLIG], motsuiv[MAXLGCHP];

while (fini==FAUX)
  {
if (feof(fic))
  {
	   /* on n'a rien lu */
	   sprintf(message,
"End of the input-file unexpected after %s.\n", mot);
	   ecrErr(stderr,"LitInt", message, ERRINPUT);
	   return(ERRINPUT);
  }
fscanf(fic,"%s", mot);
    if (strncmp(mot,"#",1)==0)
      {
	/* Commentaire jusqu'a la fin de ligne */
	fgets(ligne, MAXLIG, fic);
      }
    else
      break;

  } /* fin while (fini==FAUX) */


    /* Tout ce qui est commun  tous les LitVect */
    Code=communLitVect(fic, motscle, nbmotscle, 'i', iallouee, 1, &fini, mot, motsuiv);
    if ( (Code !=OK) && (Code != FINOF))
      return(Code);
    if ((fini==FAUX) || feof(fic))
      {
	/* On met le mot dans nbP */
  *nbP=atoi(mot);
  #ifdef DEBUG
    printf("int=%d\n", *nbP);
  #endif
          } /* fin pas fini */
    if ((fini==FAUX) && (Code != FINOF))
      strcpy(mot, motsuiv);
    
      

    return(Code);
}
/* --------------- fin de LitInt --------------------------------*/


/* --------------------------------------------------------------
LitShort:
Lecture d'un nbre TShortInt
------------------------------------------------------------- */

int LitShort(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     TShortInt *nbP, char *mot)
{
/* Pour les messages d'erreur */
char message[MAXLGMESS];
int Code=OK;
int iallouee=0;
TLogic fini=FAUX;
char ligne[MAXLIG], motsuiv[MAXLGCHP];

while (fini==FAUX)
  {
if (feof(fic))
  {
	   /* on n'a rien lu */
	   sprintf(message,
"End of the input-file unexpected after %s.\n", mot);
	   ecrErr(stderr,"LitShort", message, ERRINPUT);
	   return(ERRINPUT);
  }
fscanf(fic,"%s", mot);
    if (strncmp(mot,"#",1)==0)
      {
	/* Commentaire jusqu'a la fin de ligne */
	fgets(ligne, MAXLIG, fic);
      }
    else
      break;

  } /* fin while (fini==FAUX) */

    /* Tout ce qui est commun  tous les LitVect */
    Code=communLitVect(fic, motscle, nbmotscle, 's', iallouee, 1,&fini, mot, motsuiv);
    if ( (Code !=OK) && (Code != FINOF))
      return(Code);
      /*      if (fini==FAUX) */
    if ((fini==FAUX) || feof(fic))
      {
	/* On met le mot dans nbP */
  *nbP=(TShortInt)atoi(mot);
  #ifdef DEBUG
    printf("short=%d fini=%d Code=%d\n", *nbP, fini, Code);
  #endif
          } /* fin pas fini */
    if ((fini==FAUX) && (Code != FINOF))
      strcpy(mot, motsuiv);
    
      
    return(Code);
}
/* --------------- fin de LitShort --------------------------------*/

/* --------------------------------------------------------------
LitLong:
Lecture d'un nbre TLongInt
------------------------------------------------------------- */

int LitLong(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     TLongInt *nbP, char *mot)
{
/* Pour les messages d'erreur */
char message[MAXLGMESS];
int Code=OK;
int iallouee=0;
TLogic fini=FAUX;
char ligne[MAXLIG], motsuiv[MAXLGCHP];

while (fini==FAUX)
  {
if (feof(fic))
  {
	   /* on n'a rien lu */
	   sprintf(message,
"End of the input-file unexpected after %s.\n", mot);
	   ecrErr(stderr,"LitLong", message, ERRINPUT);
	   return(ERRINPUT);
  }
fscanf(fic,"%s", mot);
    if (strncmp(mot,"#",1)==0)
      {
	/* Commentaire jusqu'a la fin de ligne */
	fgets(ligne, MAXLIG, fic);
      }
    else
      break;

  } /* fin while (fini==FAUX) */

    /* Tout ce qui est commun  tous les LitVect */
    Code=communLitVect(fic, motscle, nbmotscle, 's', iallouee, 1, &fini,mot, motsuiv);
    if ( (Code !=OK) && (Code != FINOF))
      return(Code);
    if ((fini==FAUX) || feof(fic))
      {
	/* On met le mot dans nbP */
  *nbP=(TLongInt)atoi(mot);
  #ifdef DEBUG
    printf("long=%d\n", *nbP);
  #endif
          } /* fin pas fini */
    if ((fini==FAUX) && (Code != FINOF))
      strcpy(mot, motsuiv);
    
      

    return(Code);
}
/* --------------- fin de LitLong --------------------------------*/


/* --------------------------------------------------------------
LitLogic:
Lecture d'un nbre TLogic
------------------------------------------------------------- */

int LitLogic(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     TLogic *nbP,  char *mot)
{
/* Pour les messages d'erreur */
char message[MAXLGMESS];
int Code=OK;
int iallouee=0;
TLogic fini=FAUX;
char ligne[MAXLIG], motsuiv[MAXLGCHP];

while (fini==FAUX)
  {
if (feof(fic))
  {
	   /* on n'a rien lu */
	   sprintf(message,
"End of the input-file unexpected after %s.\n", mot);
	   ecrErr(stderr,"LitLogic", message, ERRINPUT);
	   return(ERRINPUT);
  }
fscanf(fic,"%s", mot);
    if (strncmp(mot,"#",1)==0)
      {
	/* Commentaire jusqu'a la fin de ligne */
	fgets(ligne, MAXLIG, fic);
      }
    else
      break;

  } /* fin while (fini==FAUX) */

    /* Tout ce qui est commun  tous les LitVect */
    Code=communLitVect(fic, motscle, nbmotscle, 'b', iallouee, 1,&fini, mot, motsuiv);
    if ( (Code !=OK) && (Code != FINOF))
      return(Code);
    if ((fini==FAUX) || feof(fic))
      {
	/* On met le mot dans nbP */
  *nbP=(TLogic)atoi(mot);


      } /* fin pas fini */
if ((fini==FAUX) && (Code != FINOF))
      strcpy(mot, motsuiv);
    
      

    return(Code);
}

/* --------------- fin de LitLogic --------------------------------*/




/* --------------------------------------------------------------
LitStr:
Lecture d'une chaine de car dans chaine.
En entre, 'mot' est le mot courant avant la lecture.
Le mot suivant 'chaine' est renvoy dans mot
------------------------------------------------------------- */

int LitStr(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     char *chaine, char *mot)
{
/* Pour les messages d'erreur */
char message[MAXLGMESS];
int Code=OK;
int iallouee=0;
TLogic fini=FAUX;
char ligne[MAXLIG], motsuiv[MAXLGCHP];

while (fini==FAUX)
  {
if (feof(fic))
  {
	   /* on n'a rien lu */
	   sprintf(message,
"End of the input-file unexpected after %s.\n", mot);
	   ecrErr(stderr,"LitStr", message, ERRINPUT);
	   return(ERRINPUT);
  }

fscanf(fic,"%s", mot);
    if (strncmp(mot,"#",1)==0)
      {
	/* Commentaire jusqu'a la fin de ligne */
	fgets(ligne, MAXLIG, fic);

      }
    else
      break;

  } /* fin while (fini==FAUX) */


    /* Tout ce qui est commun  tous les LitVect */
    Code=communLitVect(fic, motscle, nbmotscle, 'c', iallouee, 1,&fini, mot, motsuiv);
    if ( (Code !=OK) && (Code != FINOF))
      return(Code);
	/* On met le mot dans chaine */
	strcpy(chaine, mot);

    if ((fini==FAUX) && (Code != FINOF))
      strcpy(mot, motsuiv);
    
      
    return(Code);
}
/* --------------- fin de LitStr --------------------------------*/

