/* +++++++++++++++++++++++++++++++++++++++++++++++++++
les define et les includes 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#include "nls2C.h"
/* pour crire les messages d'erreur */
extern void ecrErr(FILE *fic, char * nomcall , char *message, int Code);
/* Autres pgmmes appels */
int LitVectPS(FILE *fic, 
	      TVectStr motscle, TVectShort nbmotscle,
	      int *nbP,
                char *mot, TVectShort *Val);

int LitShort(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     TShortInt *nbP, char *mot);


extern int LitLong(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     TLongInt *nbP, char *mot);

extern int LitLogic(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     TLogic *nbP, char *mot);
extern int LitStr(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     char *chaine, char *mot);

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                UTILITAIRES DE LECTURE DU CONTENU de GNLControle
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* ------------------------------------------------
Lire un item logique
------------------------------------------------ */
int litItemLogic(FILE *fic,
		 TVectStr motscle, TVectShort nbmotscle,  
		 TLogic *lu,
		 char *mot)
{
char message[MAXLGMESS];
int Code=OK;


    Code = LitLogic(fic, motscle, nbmotscle,  lu, mot);

    if ( (Code != FINOF) && (Code != OK))
    {
      sprintf(message, 
"Error while reading '%s'\n", mot);
    ecrErr(stderr,"litItemLogic", message, ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
}
/* --------- fin litItemLogic --------------------------- */

/* ------------------------------------------------
Grer tout ce qui suit un 'motcle' concernant GNLControle
Renvoyer la 1iere chaine de car suivante non reconnue dans mot
---------------------------------------------------*/
int litCrole(FILE *fic, 
	       TVectStr motscle, TVectShort nbmotscle,
		  char *mot)
{
char message[MAXLGMESS], *NomSortImp;
int n, i,Code=OK;
TVectShort aux;
char * MONtype;


/* Les impressions */
if (strncmp(mot,"out", 3 ) ==0)
  {
    CREER_T1(NomSortImp , MAXCH, char);
    Code = LitStr(fic, motscle, nbmotscle,  NomSortImp, mot);

    if ( (Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litCrole",
	   "Error while reading 'out'\n", ERRINPUT);
    return(ERRINPUT);
    }
    if (strncmp(NomSortImp,"no",2)==0)
      GNLControle.SortImp=NULL;
    else
      {
	if ( (GNLControle.SortImp= fopen(NomSortImp,"w")) == NULL)
	  {
	    sprintf(message,
"\nError when opening the 'out' file: %s\n", NomSortImp);
	    ecrErr(stderr,"litCrole", message, ERRINPUT);
	    return(ERRINPUT);
	  }
      }
    return(Code);
  }

if (strncmp(mot,"freq", 3 ) ==0)
  {
    Code = LitLong(fic, motscle, nbmotscle,  &GNLControle.FreqIp, mot);
    if ( (Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litCrole",
	   "Error while reading 'freq'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  }

 

if (strncmp(mot,"iter", 3 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.VouluIp.NbIter, mot));
  }


if (strncmp(mot,"fitted", 3 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.VouluIp.Ajustes, mot));
  }

if (strncmp(mot,"est.eq",4)==0)
    {
   return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.VouluIp.EquN, mot));
    }

if (strncmp(mot,"estim", 4 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.VouluIp.Estim, mot));
  }
if (strncmp(mot,"deriv.fct", 3 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.VouluIp.FctSensib, mot));
  }
if (strncmp(mot,"num.res", 3 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.VouluIp.ResNum, mot));
  }
if (strncmp(mot,"odes", 3 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.VouluIp.Sedo, mot));
  }


/* Les resultats intermdiaires */
if (strncmp(mot, "it.steps", 5) ==0)
  {
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code=LitVectPS(fic, motscle, nbmotscle,  &n, mot, &(aux));
    if ( (Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litCrole",
	   "Error while reading 'it.steps'\n", ERRINPUT);
    return(ERRINPUT);
    }
      for (i=0; i<n; i++)
	{
	  if ((aux.donnees[i] <1) ||(aux.donnees[i] > MAXETAP))
	    {
	      sprintf(message, 
"Bad value for 'it.steps': %hd not possible; should be between 1 and %hd\n",
		       aux.donnees[i], MAXETAP);
	      ecrErr(stderr,"litCrole", message, ERRINPUT);
	      return(ERRINPUT);
	    }
	  GNLControle.EtapeIt[aux.donnees[i]-1] = VRAI;
	} /* fin i */


#ifdef DEBUG
      for (i=0; i< MAXETAP; i++)
	printf("it.steps[%d]=%hd\n", i,  GNLControle.EtapeIt[i]);
      #endif
    return(Code);
  }



if (strncmp(mot, "it.iter", 5 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.VouluIt.NbIter, mot));
  }


if (strncmp(mot,"it.fitted", 5 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.VouluIt.Ajustes, mot));
  }

if (strcmp(mot, "it.est.eq")==0)
    {
   return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.VouluIt.EquN, mot));
    }

if (strcmp(mot, "it.estim" ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.VouluIt.Estim, mot));
  }
if (strncmp(mot, "it.deriv.fct", 5 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.VouluIt.FctSensib, mot));
  }
if (strncmp(mot, "it.num.res", 5 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.VouluIt.ResNum, mot));
  }
if (strncmp(mot, "it.odes", 5 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.VouluIt.Sedo, mot));
  }

/* Les calculs supplmentaires */

if (strncmp(mot,"as.var", 5 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.Voulu.AsVar, mot));
  }
if (strncmp(mot,"corr", 4 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.Voulu.Corr, mot));
  }
if (strncmp(mot,"b.varz.b",4)==0)
    {
   return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.Voulu.BVarZBP, mot));
    }

if (strncmp(mot,"mu", 2 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.Voulu.Mu, mot));
  }

if (strncmp(mot,"residuals", 5 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.Voulu.Residus, mot));
  }


/* Les warnings */

  if (strncmp(mot,"anal.warn", 5)==0)
    {
     return(LitShort(fic, motscle, nbmotscle, &(GNLControle.NbWAnaly),   mot));
    }
  if (strncmp(mot,"integ.warn", 5)==0)
   {
     return(LitShort(fic, motscle, nbmotscle, &(GNLControle.NbWInteg),   mot));
   }

  if (strncmp(mot,"meth.warn", 5)==0)
    {
      return(LitShort(fic, motscle, nbmotscle, &(GNLControle.NbWMethe),   mot));
   }
  if (strncmp(mot,"num.warn", 5)==0)
    {
      return(LitShort(fic, motscle, nbmotscle, &(GNLControle.NbWNumer),   mot));
   }
  if (strncmp(mot,"all.warn", 5)==0)
    {
      return(LitShort(fic, motscle, nbmotscle, &(GNLControle.NbWTotal),   mot));
   }
  if (strncmp(mot,"lg.trace", 4)==0)
    {
      return(LitShort(fic, motscle, nbmotscle, &(GNLControle.LgTrace),   mot));
   }
  if (strncmp(mot,"warn",4)==0)
    {

    CREER_T1(MONtype , MAXCH, char);

    Code=LitStr(fic, motscle, nbmotscle, MONtype, mot);

    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCrole",
	   "Error while reading 'warn'\n", ERRINPUT);
    return(ERRINPUT);
    }
    switch(MONtype[0])
      {
      case 'n':
	GNLControle.SortWE= (FILE *)NULL;
	break;
      case 'l':
      case 'L':
	GNLControle.TypeLgMess=LONG;
	break;
      case 's':
      case 'S':
      case 'c':
      case 'C':
	GNLControle.TypeLgMess= COURT;
	break;
      default:
	sprintf(message,
"Invalid value '%s' for 'warn': should be among 'no', 'l', 's'.\n",
		MONtype);
	ecrErr(stderr,"litCrole",
	   "Error while reading 'warn'\n", ERRINPUT);
	return(ERRINPUT);
      } /* fin switch */
    return(Code);
    } /* fin warn */

  /* a mettre apres 'warn' */

if (strncmp(mot,"w", 1 ) ==0)
  {
    return(litItemLogic(
fic, motscle, nbmotscle,  &GNLControle.Voulu.ValW, mot));
  }

      

/* On est pass nulle part */
/* Erreur dans ce programme */
sprintf(message,"Internal error: %s not valid.\n", mot);
ecrErr(stderr,"litCrole",message, ERRINT);
return(ERRINT);
}


/* --------------- fin litCrole ----------------------------*/


/* --------------------------------------------------------------
suiteCrole: finit de vrifier et remplir GNLControle, une fois
que tout est lu
--------------------------------------------------------------- */
int suiteCrole(TShortInt NbEtapes)
{

char message[MAXLGMESS];
int i;
int Code=OK;

for (i=0; i<MAXETAP; i++)
  {
    if ( (i > (NbEtapes-1))  && (GNLControle.EtapeIt[i]==VRAI))
	 {
	   sprintf(message,
"You have asked the intermediate results of the step %d but %d steps only.\n",
(i+1), NbEtapes);
	   ecrErr(stderr,"suiteCrole",message, ERRINPUT);
	   return(ERRINPUT);
	 }
  } /* fin 	for (i=0; i<MAXETAP; i++) */

/* On fixe Voulu.ResNum = VRAI */
GNLControle.Voulu.ResNum = VRAI ;

return(Code);
}   


/* --------------- fin suiteCrole ----------------------------*/
