/* +++++++++++++++++++++++++++++++++++++++++++++++++++
les define et les includes 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#include "nls2C.h"

/* pour crire les messages d'erreur */
extern void ecrErr(FILE *fic, char * nomcall , char *message, int Code);
/* autres */
extern int LitInt(FILE *fic,  TVectStr motscle, TVectShort nbmotscle,
	   int *nbP,char *mot);
extern int LitShort(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     TShortInt *nbP, char *mot);
extern int LitLogic(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     TLogic *nbP,  char *mot);

extern int LitVectPL(FILE *fic,
		  TVectStr motscle, TVectShort nbmotscle,
	        int *nbP,char *mot, TVectLong *Val);
extern int LitVectP(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     int *nbP,
                char *mot, TVect *Val);
/* autres */
extern void initlsoda_(void) ;
/* Programmes de nls2/src */
TShortInt CreerVectShort( TShortInt nbele, TVectShort *pvect);

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                UTILITAIRES DE LECTURE DU CONTENU du GNLCtxI
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */




/* ------------------------------------------------
Grer tout ce qui suit un 'motcle' concernant Donnees
Renvoyer la 1iere chaine de car suivante non reconnue dans mot
MONTj, VectCi: vecteurs qu'il faudra mettre en bonne dim
---------------------------------------------------*/
int litCtxI(FILE *fic, 
	       TVectStr motscle, TVectShort nbmotscle,
	       TLogic *luStart, TLogic *luNThetaOde, TLogic *luitol,
	          TVect *MONTj, TVect *MONVectCi,
		  char *mot)
{
char message[MAXLGMESS];

int Code=OK;
int i, n=-1;
TVectLong iopt;
TVect rwork;

if (strncmp(mot,"jt",2) ==0)
  {
    Code=LitInt(fic, motscle, nbmotscle,  &(GNLCtxInteg.jt), mot);
    if ( (Code != FINOF) && (Code != OK) )
    {
    ecrErr(stderr,"litCtxI",
	   "Error while reading 'jt'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  }

if (strncmp(mot,"pr.odes",2) ==0)
  {
    Code=LitLogic(fic, motscle, nbmotscle,   &(GNLCtxInteg.ImpInteg), mot);
    if ( (Code != FINOF) && (Code != OK) )
    {
    ecrErr(stderr,"litCtxI",
	   "Error while reading 'pr.odes'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  }

if (strncmp(mot,"itol",3) ==0)
  {
    *luitol=VRAI;
    Code=LitInt(fic, motscle, nbmotscle,   &(GNLCtxInteg.itol), mot);
    if ( (Code != FINOF) && (Code != OK) )
    {
    ecrErr(stderr,"litCtxI",
	   "Error while reading 'itol'\n", ERRINPUT);
    return(ERRINPUT);
    }
    if ((GNLCtxInteg.itol <= 0) || (GNLCtxInteg.itol > 4))
      {
	sprintf(message,
"The value of 'itol' is wrong: %d instead of an integer between 1 and 4. \n",
		GNLCtxInteg.itol );
	return(ERRINPUT);
      }
    return(Code);
  }


if (strncmp(mot,"iopt",3) ==0)
  {
    n=9; /* nbre de valeurs a lire */
    Code = LitVectPL(fic, motscle, nbmotscle,  &n , mot, &(iopt));
    if ( (Code != FINOF) && (Code != OK) )
    {
    ecrErr(stderr,"litCtxI",
	   "Error while reading 'iopt'\n", ERRINPUT);
    return(ERRINPUT);
    }
     GNLCtxInteg.iopt = 1;
     for(i=0;i<9;i++)
       GNLCtxInteg.proiwork[i]= (int)iopt.donnees[i];
    return(Code);
  }


if (strncmp(mot,"ropt" ,3) ==0)
  {
    n=7; /* nbre de valeurs a lire */
    Code = LitVectP(fic, motscle, nbmotscle,  &n , mot, &(rwork));
    if ( (Code != FINOF) && (Code != OK) )
    {
    ecrErr(stderr,"litCtxI",
	   "Error while reading 'ropt'\n", ERRINPUT);
    return(ERRINPUT);
    }
     GNLCtxInteg.iopt = 1;
     for(i=0;i<7;i++)
       GNLCtxInteg.prorwork[i]= (double)rwork.donnees[i];
    return(Code);
  }

  
if (strncmp(mot,"atol" ,3) ==0)
  {
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code = LitVectP(fic, motscle, nbmotscle,  &n , mot, &(GNLCtxInteg.atol));
    if ( (Code != FINOF) && (Code != OK) )
    {
    ecrErr(stderr,"litCtxI",
	   "Error while reading 'atol'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  }



if (strncmp(mot,"rtol" ,3) ==0)
  {
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code = LitVectP(fic, motscle, nbmotscle,  &n , mot, &(GNLCtxInteg.rtol));
    if ( (Code != FINOF) && (Code != OK) )
    {
    ecrErr(stderr,"litCtxI",
	   "Error while reading 'rtol'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  }

if (strncmp(mot,"start" ,3) ==0)
  {
    *luStart=VRAI;
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code = LitVectP(fic, motscle, nbmotscle,  &n , mot, &(GNLCtxInteg.T0T));
    if ( (Code != FINOF) && (Code != OK) )
    {
    ecrErr(stderr,"litCtxI",
	   "Error while reading 'start'\n", ERRINPUT);
    return(ERRINPUT);
    }
    if (GNLCtxInteg.T0T.nbele ==1)
        GNLCtxInteg.T0Egal =1;
    else
      GNLCtxInteg.T0Egal =0;
    return(Code);
  }

if (strncmp(mot,"integ.values" ,3) ==0)
  {
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code = LitVectP(fic, motscle, nbmotscle,  &n , mot, MONTj);
    if ( (Code != FINOF) && (Code != OK) )
    {
    ecrErr(stderr,"litCtxI",
	   "Error while reading 'integ.values'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  }


if (strncmp(mot,"cond.start",5) ==0)
  {
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code = LitVectP(fic, motscle, nbmotscle,  &n , mot, MONVectCi);
    if ( (Code != FINOF) && (Code != OK) )
    {
    ecrErr(stderr,"litCtxI",
	   "Error while reading 'cond.start'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  }




if (strncmp(mot,"n.theta.odes",11 ) ==0)
  {
    *luNThetaOde=VRAI;
    Code = LitShort(fic, motscle, nbmotscle, &(GNLCtxInteg.NbThetaSedo),  mot);
    if ( (Code != FINOF) && (Code != OK) )
    {
    ecrErr(stderr,"litCtxI",
	   "Error while reading 'n.theta.ode'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  }


/* On est pass nulle part */
/* Erreur dans ce programme */
ecrErr(stderr,"litCtxI","", ERRINT);
return(ERRINT);
}


/* --------------- fin litCtxI ----------------------------*/

/* --------------------------------------------------------------
suiteCtxI: finit de vrifier et remplir GNLCtxInteg, une fois
que tout est lu
--------------------------------------------------------------- */
int suiteCtxI(TLogic lustart, TLogic luNThetaOde,  TLogic luitol,
	      TFuncInt NbIndicTj,
	      TVect *MONTj, TVect *MONVectCi, 
	      TShortInt NbCourbe, TLongInt NbObsT)
{
char message[MAXLGMESS];
int  i,j,l , longsys;
int Code=OK;


    if (lustart==FAUX)
      {
	ecrErr(stderr,"suiteCtxI",
"The integration context must contain a 'start' component\
 (the values of the initial times)\n", ERRINPUT);
	Code=ERRINPUT;
      }
    if (luNThetaOde==FAUX)
      {
	ecrErr(stderr,"suiteCtxI",
"The integration context must contain a 'n.theta.odes' component\
 (the initial values of the time)\n", ERRINPUT);
	Code=ERRINPUT;
      }
   

if ((GNLCtxInteg.T0T.nbele !=1 ) && 
    (GNLCtxInteg.T0T.nbele != NbCourbe) && 
    (GNLCtxInteg.T0T.nbele != NbObsT))
  {
    sprintf(message,
"The dimension of the 'start' component is wrong:\n\
It must be equal to 1 or the number of curves (%d) or \
the number of observations (%ld).\n",
NbCourbe, NbObsT);
    ecrErr(stderr,"suiteCtxI", message, ERRINPUT);
    Code=ERRINPUT;
      }

if (Code !=OK)
  return(Code);



if ((NbIndicTj >0) &&   (NbIndicTj != GNLCtxInteg.NbJ))
  {
    sprintf(message,
"Error of compatibility: 'IndicTj' (see analDer) must have %d elements and not %d \n",
	    GNLCtxInteg.NbJ, NbIndicTj);
    ecrErr(stderr, "suiteCtxI", message, ERRINPUT);
    return(ERRINPUT);
    }

if (NbIndicTj ==0)
  {
  CreerVectShort((TShortInt)(1), &(GNLCtxInteg.IndicTj));
  GNLCtxInteg.IndicTj.donnees[0]=0;
  if (MONTj->nbele == 0)
    { 
     ecrErr(stderr, "suiteCtxI", 
"Error of compatibility: integration values are missing\n", ERRINPUT);
     return(ERRINPUT);
    }

  if (MONTj->nbele != ((GNLCtxInteg.NbJ) * NbCourbe))
    {
      sprintf(message,
"Error of dimension: There must have %d integration values and not %d.\n",
 ((GNLCtxInteg.NbJ) * (NbCourbe)), MONTj->nbele);
   ecrErr(stderr, "suiteCtxI", message, ERRINPUT);
    return(ERRINPUT);
    }

  GNLCtxInteg.Tj = (TMat *) calloc( NbCourbe, sizeof(TMat));

  for ( i=0; i < NbCourbe ; i++)
    {
    GNLCtxInteg.Tj[i].nblig=1;
    GNLCtxInteg.Tj[i].nbcol=GNLCtxInteg.NbJ;
    GNLCtxInteg.Tj[i].donnees=( TDouble ** )calloc( 1 , sizeof( TDouble));
    GNLCtxInteg.Tj[i].donnees[0]=( TDouble *)calloc(GNLCtxInteg.NbJ,sizeof(TDouble));
    }
  l=0;
  for ( i=0; i < NbCourbe ; i++)
    {
    for ( j = 0 ; j < GNLCtxInteg.NbJ; j++)
      {
      GNLCtxInteg.Tj[i].donnees[0][j]= MONTj->donnees[l];
      l=l+1;
      }
    }
  } /* fin du pas d'IndicTj */

if (GNLCtxInteg.IndicCi == 0)
  {
    if (MONVectCi->nbele ==0)
      {
	ecrErr(stderr,"suiteCtxI",
"Initial conditions of the sedo are missing\n", ERRINPUT);
	return(ERRINPUT);
      }

  if (MONVectCi->nbele != ((GNLCtxInteg.NbEq) * (NbCourbe)))
    {
      sprintf(message,
 "There must have %d initial conditions for the sedo and not %d.\n",
((GNLCtxInteg.NbEq) * (NbCourbe)), MONVectCi->nbele);
     ecrErr(stderr,"suiteCtxI",message, ERRINPUT); 
    return(ERRINPUT);
    }

  GNLCtxInteg.VectCi = ( TVect *) calloc( NbCourbe, sizeof( TVect));
  for ( i = 0; i < NbCourbe ; i++ )
    {
    GNLCtxInteg.VectCi[i].nbele=GNLCtxInteg.NbEq;
    GNLCtxInteg.VectCi[i].donnees=( TDouble *) calloc(GNLCtxInteg.NbEq, sizeof(TDouble));
    }

  l=0;
  for ( i = 0; i < NbCourbe ; i++ )
    {
    for ( j=0; j < GNLCtxInteg.NbEq ; j++)
      {
      GNLCtxInteg.VectCi[i].donnees[j]=MONVectCi->donnees[l];
      l=l+1;
      }
    }
  longsys=GNLCtxInteg.NbEq+(GNLCtxInteg.NbEq*GNLCtxInteg.NbThetaSedo);
  } /* fin IndicCi == 0 */
else
  {
  /* cas ou IndicCi !=0 */
  longsys=GNLCtxInteg.NbEq+ GNLCtxInteg.NbEq*(GNLCtxInteg.NbEq+GNLCtxInteg.NbThetaSedo);
  }

 if (luitol == 1)
  {
  if ( GNLCtxInteg.atol.nbele ==0)
    {
    ecrErr(stderr,"suiteCtxI", 
"Error: 'atol' is required when there is 'itol'.\n", ERRINPUT);
    return(ERRINPUT);
    }
  if (GNLCtxInteg.rtol.nbele ==0)
    {
    ecrErr(stderr,"suiteCtxI", 
"Error: 'rtol' is required when there is 'itol'.\n", ERRINPUT);
    return(ERRINPUT);
    }

  
  switch( GNLCtxInteg.itol)
    {
    case 1 :
      if (GNLCtxInteg.atol.nbele != 1)
        {
	  sprintf(message,
"When itol=1, 'atol' must have only 1 element and not %d.\n",
		  GNLCtxInteg.atol.nbele);
        ecrErr(stderr,"suiteCtxI", message, ERRINPUT);
	return(ERRINPUT);
        }
      if (GNLCtxInteg.rtol.nbele != 1)
        {
	sprintf(message,  
"When itol=1, 'rtol' must have only 1 element and not %d.\n",
		  GNLCtxInteg.rtol.nbele);
        ecrErr(stderr,"suiteCtxI", message, ERRINPUT);
	return(ERRINPUT);
        }
      break;
    
    case 2 :
      if (GNLCtxInteg.atol.nbele != longsys)
        {
	 sprintf(message,  
"When itol=2, 'atol' must have %d elements and not %d.\n", 
		 longsys, GNLCtxInteg.atol.nbele);
                ecrErr(stderr,"suiteCtxI", message, ERRINPUT);
	return(ERRINPUT);
        }

      if (GNLCtxInteg.rtol.nbele != longsys)
        {
	  sprintf(message,
"When itol=2, 'rtol' must have 1 element and not %d.\n", 
		  GNLCtxInteg.rtol.nbele);
	return(ERRINPUT);  
        }
      break;

    case 3 :
      if (GNLCtxInteg.atol.nbele != 1)
        {
	 sprintf(message, 
"When itol=3, 'atol' must have only 1 element and not %d.\n", 
		GNLCtxInteg.atol.nbele);
 	return(ERRINPUT);  
        }
    
      if (GNLCtxInteg.rtol.nbele != 1)
        {
	sprintf(message,   
"When itol=3, 'rtol' must have only %d elements and not %d.\n", 
		longsys, GNLCtxInteg.rtol.nbele);
	return(ERRINPUT); 
        }
      break;

    case 4 :
      if (GNLCtxInteg.atol.nbele != 1)
        {
	 sprintf(message, 
"When itol=4, 'atol' must have %d elements and not %d.\n", 
		 longsys, GNLCtxInteg.atol.nbele);
	return(ERRINPUT); 
        }
      if (GNLCtxInteg.rtol.nbele != 1)
        {
	 sprintf(message, 
"When itol=4, 'rtol'  must have %d elements and not %d.\n", 
		 longsys, GNLCtxInteg.rtol.nbele );
	return(ERRINPUT); 
        }
      break;
    } /* fin du switch itol */
  } /* fin du luitol=1 */
 
  /* Appel du programme Fortran */
initlsoda_() ;


return(OK);
}
/* ---------------- fin suiteCtxI -----------------------------------*/

