/* +++++++++++++++++++++++++++++++++++++++++++++++++++
les define et les includes 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

#include "nls2C.h"
/* pour crire les messages d'erreur */
extern void ecrErr(FILE *fic, char * nomcall , char *message, int Code);

/* autres */
extern int LitVectPS(FILE *fic, 
	      TVectStr motscle, TVectShort nbmotscle,
	      int *nbP,
                char *mot, TVectShort *Val);

extern int LitVectPStr(FILE *fic,
		TVectStr motscle, TVectShort nbmotscle,
		int *nbP,
                char *mot, TVectStr *VectStr);
extern int trLogic(char *mot, TLogic *fini);
/* Programmes de nls2/src */
TShortInt CreerVectShort( TShortInt nbele, TVectShort *pvect);


/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    UTILITAIRES DE LECTURE DU CONTENU de CtxPuss
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */


/* ------------------------------------------------
Grer tout ce qui suit un 'motcle' concernant CtxNum
On renvoie tout dans des vecteurs.
C'est quand tout sera lu qu'on affectera les CtxNum
aprs avoir vrifi que le nbre d'etapes correspond
aux nbres de valeurs lues.
Renvoyer la 1iere chaine de car suivante non reconnue dans mot
---------------------------------------------------*/
int litCtxNum(FILE *fic, 
	       TVectStr motscle, TVectShort nbmotscle,
	      int *nown,
         TVectShort *Estim, TVectShort *TypeCritStat,
	     TVectShort *NbZ, TVectShort *Effic, TVectShort *Symm,
		  char *mot)
{

char message[MAXLGMESS];
int Code=OK;
int etape, n=-1;
TVectStr MONtype;
TLogic fini=FAUX;

int i;
int nTypeEstim=14,  nTypeCritStat=8, nTypeSymm=3;
char *TypeEstim[14], *TypeTypeCritStat[8], *TypeSymm[3];
for (i=0; i< nTypeEstim; i++)
  TypeEstim[i] = (char *) calloc( MAXLGMESS, sizeof (char));
for (i=0; i< nTypeCritStat; i++)
  TypeTypeCritStat[i] = (char *) calloc( MAXLGMESS, sizeof (char));
for (i=0; i< nTypeSymm; i++)
  TypeSymm[i] = (char *) calloc( MAXLGMESS, sizeof (char));

TypeTypeCritStat[0]="logv";
TypeTypeCritStat[1]="stopcrit";
TypeTypeCritStat[2]="nwsst";
TypeTypeCritStat[3]="vwss";
TypeTypeCritStat[4]="ivwss ";
TypeTypeCritStat[5]="nwssb";
TypeTypeCritStat[6]="sigma2";
TypeTypeCritStat[7]="myown";


TypeSymm[0]="sym";
TypeSymm[1]="symbloc";
TypeSymm[2]="nonsym";


TypeEstim[0]="mltb";
TypeEstim[1]="mlstb";
 TypeEstim[2]="err"; /* c'est une valeur qui a t te */
TypeEstim[3]="mlt";
TypeEstim[4]="wlst";
TypeEstim[5]="olst";
TypeEstim[6]="mlst";
TypeEstim[7]="vitwls";
TypeEstim[8]="olsb";
TypeEstim[9]="mlsb";
 TypeEstim[10]="qltb";
 TypeEstim[11]="qlt";
 TypeEstim[12]="qlb";
TypeEstim[13]="myown";


if (strncmp(mot, "method",3)==0)
  {
    n=-1; 
    Code=LitVectPStr(fic, motscle, nbmotscle,  &n, mot, &(MONtype));

    if ( (Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litCtxNum",
	   "Error while reading 'method'\n", ERRINPUT);
    return(ERRINPUT);
    }
    if (n >3)
      {
	sprintf(message,
"%d values read for 'method': should be at most 3 values.\n",
n);
	ecrErr(stderr,"litCtxNum",message , ERRINPUT);
	return(ERRINPUT);
      }
  *nown=0;
  CreerVectShort((TShortInt)n, Estim);
    for (etape=0; etape <n; etape++)
      {

	Estim->donnees[etape]=0;
  for (i=0; i<nTypeEstim; i++)
    {
    if (strcmp(MONtype.donnees[etape],TypeEstim[i])==0)
      {
      Estim->donnees[etape]=(i+1);
      break;
      }
    }
  if ( (Estim->donnees[etape]==0) ||
       (Estim->donnees[etape]==3))
    {
      /* L'estimateur 'err' n'est pas autoris */
      sprintf(message, "Unknown type of 'method': %s\n",
	MONtype.donnees[etape]);
      ecrErr(stderr,"litCtxNum", message, ERRINPUT);
    return(ERRINPUT);
   }
/* Compter le nbre d'etapes  mthode personnelle */

    if (Estim->donnees[etape]== LEMIEN)
	*nown=*nown+1;
    CtxPuss.NbEtapes=n;


      } /* fin etape */
    return(OK);
  } /* fin method */



if (strncmp(mot, "fit.type",3)==0)
  {
    n=-1; 
    Code=LitVectPStr(fic, motscle, nbmotscle,  &n, mot, &(MONtype));
    if ( (Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litCtxNum",
	   "Error while reading 'fit.type'\n", ERRINPUT);
    return(ERRINPUT);
    }
    if (n >3)
      {
	sprintf(message,
"%d values read for 'fit.type': should be at most 3 values.\n",
n);
	ecrErr(stderr,"litCtxNum",message , ERRINPUT);
	return(ERRINPUT);
      }
    CreerVectShort((TShortInt)n, TypeCritStat);

    for (etape=0; etape <n; etape++)
      {
	TypeCritStat->donnees[etape]=0;
  for (i=0; i<nTypeCritStat; i++)
    {
    if (strcmp(MONtype.donnees[etape],TypeTypeCritStat[i])==0)
      {
      TypeCritStat->donnees[etape]=(i+1);
      break;
      }
    }
  if (TypeCritStat->donnees[etape]==0)
    {
      sprintf(message, "Unknown type of 'fit.type': %s\n",
	MONtype.donnees[etape]);
      ecrErr(stderr,"litCtxNum", message, ERRINPUT);
    return(ERRINPUT);
   }
  if (TypeCritStat->donnees[etape]==8)
    {
    TypeCritStat->donnees[etape]= LEMIEN;
    }



      } /* fin etape */
    return(OK);
  } /* fin fit.type */



if (strncmp(mot, "w.type",3)==0)
  {
    n=-1; 
    Code=LitVectPStr(fic, motscle, nbmotscle,  &n, mot, &(MONtype));
    if ( (Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litCtxNum",
	   "Error while reading 'w.type'\n", ERRINPUT);
    return(ERRINPUT);
    }
    if (n >3)
      {
	sprintf(message,
"%d values read for 'w.type': should be at most 3 values.\n",
n);
	ecrErr(stderr,"litCtxNum",message , ERRINPUT);
	return(ERRINPUT);
      }
    CreerVectShort((TShortInt)n, Symm);

    for (etape=0; etape <n; etape++)
      {
	Symm->donnees[etape]=0;
  for (i=0; i<nTypeSymm; i++)
    {
    if (strcmp(MONtype.donnees[etape],TypeSymm[i])==0)
      {
      Symm->donnees[etape]=(i+1);
      break;
      }
    }
  if (Symm->donnees[etape]==0)
    {
      sprintf(message, "Unknown type of 'w.type': %s\n",
	MONtype.donnees[etape]);
      ecrErr(stderr,"litCtxNum", message, ERRINPUT);
    return(ERRINPUT);
   }
      } /* fin etape */
    return(OK);
  } /* fin w.type */



if (strncmp(mot, "effic",3)==0)
  {
    n=-1; 
    Code=LitVectPStr(fic, motscle, nbmotscle,  &n, mot, &(MONtype));
    if ( (Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litCtxNum",
	   "Error while reading 'effic'\n", ERRINPUT);
    return(ERRINPUT);
    }
    if (n >3)
      {
	sprintf(message,
"%d values read for 'effic': should be at most 3 values.\n",
n);
	ecrErr(stderr,"litCtxNum",message , ERRINPUT);
	return(ERRINPUT);
      }
    CreerVectShort((TShortInt)n, Effic);

    for (etape=0; etape <n; etape++)
      {
	Code=trLogic(MONtype.donnees[etape], &fini);
	if ( (Code !=OK) || (fini == VRAI))
	  {
	   sprintf(message, "Unknown type of 'effic': %s\n",
		   MONtype.donnees[etape]);
	   ecrErr(stderr,"litCtxNum", message, ERRINPUT); 
	   return(ERRINPUT);
	  }
	Effic->donnees[etape]=atoi(MONtype.donnees[etape]);
      } /* fin etape */
    return(OK);
  } /* fin effic */


if (strncmp(mot, "nh",2)==0)
  {
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code=LitVectPS(fic, motscle, nbmotscle,  &n, mot, NbZ);
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litCtxNum",
	   "Error while reading 'nh'.\n", ERRINPUT);
    return(ERRINPUT);
    }

    if (n >3)
      {
	sprintf(message,
"%d values read for 'nh': should be at most 3 values.\n",
n);
	ecrErr(stderr,"litCtxNum",message , ERRINPUT);
	return(ERRINPUT);
      }
    return(OK);
  } /* fin nh */

/* On est pass nulle part */
/* Erreur dans ce programme */
sprintf(message,"Internal error: %s not valid.\n", mot);
ecrErr(stderr,"litCtxNum",message, ERRINT);
return(ERRINT);
}


/* --------------- fin litCtxNum ----------------------------*/


/* --------------------------------------------------------------
suiteCtxNum: finit de vrifier et remplir CtxNum, une fois
que tout est lu
--------------------------------------------------------------- */
int suiteCtxNum(TShortInt NbEtapes ,
		int nown,
         TVectShort *Estim, TVectShort *TypeCritStat,
	     TVectShort *NbZ, TVectShort *Effic, TVectShort *Symm,
		TCtxNum CtxNum[])
{

char message[MAXLGMESS];
int etape;

if (NbEtapes > 1) 
{
  if (Estim->nbele ==0)
    {
     sprintf(message,"There are several steps (%d) and 'method' is missing.\n",
	    NbEtapes);
     ecrErr(stderr,"suiteCtxNum",message, ERRINPUT);
    return(ERRINPUT);
  }
  if (Estim->nbele != NbEtapes)
  {
    sprintf(message,"The number of steps (%d) should be equal to the number\
 of methods (%d).\n", NbEtapes, Estim->nbele);
    ecrErr(stderr,"suiteCtxNum",message, ERRINPUT);
    return(ERRINPUT);
  }
} /* fin if (NbEtapes > 1) */

  /* Mettre Estim dans les CtxNum */
for (etape=0; etape < Estim->nbele; etape++)
  {
    CtxNum[etape].Estim=Estim->donnees[etape];
  }

/* Traiter les etapes  mthode personnelle */
if  (nown ==0)
  {
    if ((TypeCritStat->nbele != 0) ||
      (NbZ->nbele  != 0) ||
      (Effic->nbele != 0) ||
      (Symm->nbele != 0))
      {
	sprintf(message,"There is no personal method: you cannot define\n\
 'fit.type' nor 'nh' nor 'effic' nor 'symm'.\n");
	ecrErr(stderr,"suiteCtxNum",message, ERRINPUT);
	return(ERRINPUT);
      }
  }
else
  {
    /* nown >0 */
    if ((nown != TypeCritStat->nbele) ||
    (nown != NbZ->nbele) || (nown != Effic->nbele) ||
    (nown != Symm->nbele))
      {
	sprintf(message,
"The number of personal methods (%d) does not fit\n\
 the number of 'fit.type' (%d) or of 'nh' (%d) or of 'effic' (%d)\
 or of 'symm' (%d).\n",
nown, TypeCritStat->nbele, NbZ->nbele,
Effic->nbele, Symm->nbele);
	ecrErr(stderr,"suiteCtxNum",message, ERRINPUT);
	return(ERRINPUT);
      }
    /* Mettre dans les CtxNum  */
    for (etape=0; etape < nown; etape++)
      {
	CtxNum[etape].TypeCritStat=TypeCritStat->donnees[etape];
	CtxNum[etape].NbZ=NbZ->donnees[etape];
	CtxNum[etape].Effic=Effic->donnees[etape];
	CtxNum[etape].Symm=Symm->donnees[etape];
      }
  
  } /* fin  nown >0 */

return(OK);
}
/* ------------- fin suiteCtxNum ------------------------------------*/
