

/* +++++++++++++++++++++++++++++++++++++++++++++++++++
les define et les includes 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#include "nls2C.h"
/* pour crire les messages d'erreur */
extern void ecrErr(FILE *fic, char * nomcall , char *message, int Code);
/* autres */
extern int LitStr(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     char *chaine, char *mot);
extern int LitVectP(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     int *nbP,
                char *mot, TVect *Val);
extern int LitLong(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     TLongInt *nbP, char *mot);
extern int LitDouble(FILE *fic,  TVectStr motscle, TVectShort nbmotscle,
	   TDouble *nbP,char *mot);
extern int LitShort(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     TShortInt *nbP, char *mot);

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    UTILITAIRES DE LECTURE DU CONTENU de CtxPuss
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */


/* ------------------------------------------------
Grer tout ce qui suit un 'motcle' concernant CtxPuss
Renvoyer la 1iere chaine de car suivante non reconnue dans mot
---------------------------------------------------*/
int litCtxPuss(FILE *fic, 
	       TVectStr motscle, TVectShort nbmotscle,
	       TLogic *lusigma, TLogic *lumu3, TLogic *lumu4,
	      TCtxPuss *CtxPuss,
		  char *mot)
{

char message[MAXLGMESS];
int Code=OK;
int n=-1;

int i,  nTypeMu=4, nAlgo=2, nFamille=5, nTypeSigma=5 ;
 char  *TypeMu[4],  *TypeSigma[5], *Algo[2] , *Famille[5];
char * MONtype;

 Famille[0] = "gaussian";
 Famille[1] = "poisson";
 Famille[2] = "binomial";
 Famille[3] = "bernoulli";
 Famille[4] = "multinomial";


Algo[0]="gn";
Algo[1]="gm";

TypeSigma[0]="known";
TypeSigma[1]="varrep";
TypeSigma[2]="varresid";
TypeSigma[3]="ignored";
TypeSigma[4]="varintra";

TypeMu[0]="known";
TypeMu[1]="mugauss";
TypeMu[2]="mures";
TypeMu[3]="muresrep";

    CREER_T1(MONtype , MAXCH, char);


/* Ce qui est cod */
if (strncmp(mot, "mu.type",4)==0)
  {
    Code=LitStr(fic, motscle, nbmotscle, MONtype, mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'mu.type'\n", ERRINPUT);
    return(ERRINPUT);
    }
  CtxPuss->TypeMu=0;
  for (i=0; i<nTypeMu; i++)
    {
    if (strcmp(MONtype ,TypeMu[i])==0)
      {
      CtxPuss->TypeMu=(i+1);
      return(Code);
      }
    }
      sprintf(message, "Unknown type for 'mu.type': %s\n",
	MONtype );
      ecrErr(stderr,"litCtxPuss", message, ERRINPUT);
    return(ERRINPUT);
  
} /* fin mu.type */


  /* teste de la longueur de Type pour pas confondre les debuts de chaines
     identiques */  
if ( (strncmp(mot, "sigma2.type",8)==0) &&
     (strlen(mot) > 7))
  {

    Code=LitStr(fic, motscle, nbmotscle, MONtype, mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'sigma2.type'\n", ERRINPUT);
    return(ERRINPUT);
    }

  CtxPuss->TypeSigma=0;
  for (i=0; i<nTypeSigma; i++)
    {
    if (strcmp(MONtype ,TypeSigma[i])==0)
      {
      CtxPuss->TypeSigma=(i+1);
      return(Code);
      }
    }

      sprintf(message, "Unknown type for 'sigma2.type': %s\n",
	MONtype );
      ecrErr(stderr,"litCtxPuss", message, ERRINPUT);
    return(ERRINPUT);

} /* fin sigma2.type */


if  (strncmp(mot, "algo",4)==0)
  {
    Code=LitStr(fic, motscle, nbmotscle,   MONtype, mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'algorithm'\n", ERRINPUT);
    return(ERRINPUT);
    }
  CtxPuss->Algo=0;
  for (i=0; i<nAlgo; i++)
    {
    if (strcmp(MONtype ,Algo[i])==0)
      {
      CtxPuss->Algo=(i+1);
      return(Code);
      }
    }
      sprintf(message, "Unknown type for 'algorithm': %s\n",
	MONtype );
      ecrErr(stderr,"litCtxPuss", message, ERRINPUT);
    return(ERRINPUT);

} /* fin algo */


if  (strncmp(mot, "fami",4)==0)
  {
    Code=LitStr(fic, motscle, nbmotscle,   MONtype, mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'family'\n", ERRINPUT);
    return(ERRINPUT);
    }
  CtxPuss->Famille=0;
  for (i=0; i<nFamille; i++)
    {
    if (strcmp(MONtype ,Famille[i])==0)
      {
      CtxPuss->Famille=(i+1);
      return(Code);
      }
    }
      sprintf(message, "Unknown type for 'family': %s\n",
	MONtype );
      ecrErr(stderr,"litCtxPuss", message, ERRINPUT);
    return(ERRINPUT);


} /* fin family */

/* Ce qui est short */

if (strncmp(mot,"n.steps",3 ) ==0)
  {
    Code = LitShort(fic, motscle, nbmotscle, &(CtxPuss->NbEtapes),   mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'n.steps'\n", ERRINPUT);
    return(ERRINPUT);
    }
    if ((CtxPuss->NbEtapes<=0) || (CtxPuss->NbEtapes>3))
      {
	sprintf(message,
"'n.steps' should be between 1 and 3: %d not valid.\n",
CtxPuss->NbEtapes);
	ecrErr(stderr,"litCtxPuss",message,  ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin n.steps */


/* Ce qui est long */
if (strncmp(mot,"max.err.c1",10 ) ==0)
  {
    Code = LitLong(fic, motscle, nbmotscle,  &(CtxPuss->MaxErr), mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'max.err.c1'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin max.err.c1 */

if (strncmp(mot,"max.err.c2",10 ) ==0)
  {
    Code = LitLong(fic, motscle, nbmotscle,  &(CtxPuss->MaxDeb), mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'max.err.c2'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin max.err.c2 */

if (strncmp(mot,"max.iter",5 ) ==0)
  {
    Code = LitLong(fic, motscle, nbmotscle,  &(CtxPuss->MaxIter), mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'max.iter'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin max.iter */

/* Ce qui est double */
  /* teste de la longueur de Type pour pas confondre les debuts de chaines
     identiques */  
if ( (strncmp(mot, "sigma2",3)==0) &&
     (strlen(mot) < 7))
  {
    *lusigma=VRAI;
    Code = LitDouble(fic, motscle, nbmotscle,  &(CtxPuss->Sigma), mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'sigma2'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin sigma2 */


if (strncmp(mot,"omega.c1",8 ) ==0)
  {
    Code = LitDouble(fic, motscle, nbmotscle,  &(CtxPuss->DirecC), mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'omega.c1'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin omega.c1 */


if (strncmp(mot,"omega.c2",8 ) ==0)
  {
    Code = LitDouble(fic, motscle, nbmotscle,  &(CtxPuss->OmegaPas), mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'omega.c2'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin omega.c2 */



if (strncmp(mot,"lambda.start",8 ) ==0)
  {
    Code = LitDouble(fic, motscle, nbmotscle,  &(CtxPuss->Lambda0), mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'lambda.start'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin lambda.start */


if (strncmp(mot,"lambda.c1",9 ) ==0)
  {
    Code = LitDouble(fic, motscle, nbmotscle,  &(CtxPuss->LambdaC1), mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'lambda.c1'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin lambda.c1 */


if (strncmp(mot,"lambda.c2",9 ) ==0)
  {
    Code = LitDouble(fic, motscle, nbmotscle,  &(CtxPuss->LambdaC2), mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'lambda.c2'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin lambda.c2 */


if (strncmp(mot,"max.stop",5 ) ==0)
  {
    Code = LitDouble(fic, motscle, nbmotscle,  &(CtxPuss->MaxCritArret), mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'max.stop'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin max.stop */



if (strncmp(mot,"max.lambda",5 ) ==0)
  {
    Code = LitDouble(fic, motscle, nbmotscle,  &(CtxPuss->MaxLambda), mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'max.lambda'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin max.lambda */

/* ce qui est vect */
if (strncmp(mot,"theta.start",7)==0)
  {
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code = LitVectP(fic, motscle, nbmotscle,  &n , mot, &(CtxPuss->Theta0));


    if ((Code !=FINOF) && ( Code != OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'theta.start'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin theta.start */

if (strncmp(mot,"beta.start",7)==0)
  {
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code = LitVectP(fic, motscle, nbmotscle,  &n , mot,&(CtxPuss->Beta0));
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'beta.start'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin beta.start */

if (strncmp(mot,"mu3",3)==0)
  {
    *lumu3=VRAI;
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code = LitVectP(fic, motscle, nbmotscle,  &n , mot, &(CtxPuss->Mu3));
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'mu3'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin mu3 */


if (strncmp(mot,"mu4",3)==0)
  {
    *lumu4=VRAI;
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code = LitVectP(fic, motscle, nbmotscle,  &n ,mot, &(CtxPuss->Mu4));
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litCtxPuss",
	   "Error while reading 'mu4'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  } /* fin mu4 */


/* On est pass nulle part */
/* Erreur dans ce programme */
sprintf(message,"Internal error: %s not valid.\n", mot);
ecrErr(stderr,"litCtxPuss",message, ERRINT);
return(ERRINT);
}


/* --------------- fin litCtxPuss ----------------------------*/


/* --------------------------------------------------------------
suiteCtxPuss: finit de vrifier et remplir CtxPuss, une fois
que tout est lu
--------------------------------------------------------------- */
int suiteCtxPuss(
	       TLogic lusigma, TLogic lumu3, TLogic lumu4,
	TDonnees *Donnees, TModele *Modele,	 TCtxPuss *CtxPuss)
{

char message[MAXLGMESS];
int Code=OK;
int nmult=0;


nmult=Modele->NomTheta.nbele * Donnees->NbCourbe;
if (CtxPuss->Theta0.nbele != nmult)
{
  sprintf(message,
"%d values read for 'theta.start' while %d expected.\n",
CtxPuss->Theta0.nbele, nmult);
  ecrErr(stderr,"suiteCtxPuss",message,ERRINPUT);
      return(ERRINPUT);
  }



nmult=Modele->NomBeta.nbele * Donnees->NbCourbe;
if (CtxPuss->Beta0.nbele != nmult)
{
  sprintf(message,
"%d values read for 'beta.start' while %d expected.\n",
CtxPuss->Beta0.nbele, nmult);
  ecrErr(stderr,"suiteCtxPuss",message,ERRINPUT);
      return(ERRINPUT);
  }

 

if ((CtxPuss->TypeSigma==CONNU) && (lusigma==FAUX))
  {
    ecrErr(stderr,"suiteCtxPuss",
"'sigma2' missing while 'sigma2.type' is set to 'known'.\n",
 ERRINPUT);
    return(ERRINPUT);
  }
if ((CtxPuss->TypeMu==CONNU) &&
    ((lumu3==FAUX) || (lumu4==FAUX)))
  {
    ecrErr(stderr,"suiteCtxPuss",
"'mu3' ou 'mu4' missing while 'mu.type' is set to 'known'.\n",
 ERRINPUT);
    return(ERRINPUT);
  }
return(Code);
}

/* ------------- fin suiteCtxPuss ------------------------------------*/


