/* +++++++++++++++++++++++++++++++++++++++++++++++++++
les define et les includes 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#include "nls2C.h"
/* pour crire les messages d'erreur */
extern void ecrErr(FILE *fic, char * nomcall , char *message, int Code);
/* Autres pgmmes appels */
extern int LitVectPStr(FILE *fic,
		TVectStr motscle, TVectShort nbmotscle,
		int *nbP,
                char *mot, TVectStr *VectStr);
extern int LitVectP(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     int *nbP,
                char *mot, TVect *Val);

extern TShortInt CreerMatC( TShortInt nblig, TShortInt nbcol, TMat *pmat);
extern TShortInt CreerVectStr( TShortInt nbele, TVectStr *pvect);

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                UTILITAIRES DE LECTURE DU CONTENU de Donnees
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/* ------------------------------------------------
Determiner le nbre de courbes diffrentes
NomCT suppos tri en entre
---------------------------------------------------*/
TShortInt NbreCourbes(TVectStr  * NomCT)
{
TChar **nomct;
TShortInt NbCourbe = 1 ;
int i;

        nomct = NomCT->donnees;
        for ( i = 1 ; i <  NomCT->nbele; i ++)
	  {
	  if (strcmp (nomct[i],nomct[i-1]) != 0)
	    {
/* ...................On change de courbe ................................ */
	      NbCourbe = NbCourbe + 1  ;

	    }
	  }
return(NbCourbe);
}
/*------------ fin NbreCourbes ------------------------ */

/* ------------------------------------------------
Grer tout ce qui suit un 'motcle' concernant Donnees
Renvoyer la 1iere chaine de car suivante non reconnue dans mot
---------------------------------------------------*/
int litDonnees(FILE *fic, 
	       TVectStr motscle, TVectShort nbmotscle,
		  TLogic *luX, TLogic *luY,
	       TVect *MONx, TVectStr *nameN,
		  TDonnees *Donnees,
		  char *mot)
{
  /* MONx :  Pour lire les x sous forme de vecteur
	       avant de le transformer en matrice */
char message[MAXLGMESS];
int Code=OK;
int n=-1;
char * MONtype;
    CREER_T1(MONtype , MAXCH, char);


if (strncmp(mot,"x",1) ==0)
  {
    *luX=VRAI;
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code=LitVectP(fic, motscle, nbmotscle,  &n, mot, MONx);
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litDonnees",
	   "Error while reading x\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  }
if (strncmp(mot,"y" ,1) ==0)
  {
    *luY=VRAI;
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code = LitVectP(fic, motscle, nbmotscle,  &n, mot, &(Donnees->ValY));
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litDonnees",
	   "Error while reading y\n", ERRINPUT);
    return(ERRINPUT);
    }
    Donnees->NbObsT=(TLongInt)n;
    return(Code);
  }

if (strncmp(mot,"weights" ,3) ==0)
  {
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code = LitVectP(fic, motscle, nbmotscle,  &n , mot, &(Donnees->PoidsT));
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litDonnees",
	   "Error while reading weights\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  }


if (strncmp(mot,"curves",3) ==0)
  {
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    /* Pour les chaines de car, on lit jusqu'a eof, 
       ou chaine en min =un mot-cle */
    Code= LitVectPStr(fic, motscle, nbmotscle,  &n, mot , &(Donnees->NomCT));
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litDonnees",
	   "Error while reading curves\n", ERRINPUT);
    return(ERRINPUT);
    }
     Donnees->NbCourbe= NbreCourbes(&(Donnees->NomCT));
    return(Code);
  } /* fin if (strncmp(mot,"curve",3) ==0) */

if  (strncmp(mot, "nameN",5)==0)
  {
    Code=LitStr(fic, motscle, nbmotscle,   MONtype, mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litDonnees",
	   "Error while reading 'nameN'\n", ERRINPUT);
    return(ERRINPUT);
    }
    strcpy(nameN->donnees[0], MONtype);
    nameN->nbele =1; 
    return(Code);
  } /* fin if (strncmp(mot,"nameN",5)==0) */

/* On est pass nulle part */
/* Erreur dans ce programme */
sprintf(message,"Internal error: %s not valid.\n", mot);
ecrErr(stderr,"litDonnees",message, ERRINT);
return(ERRINT);
}


/* --------------- fin litDonnees ----------------------------*/

/* --------------------------------------------------------------
suiteDonnees: finit de vrifier et remplir Donnees, une fois
que tout est lu
--------------------------------------------------------------- */
int suiteDonnees(TLogic luFile, TLogic luX, TLogic luY,
		 TVect *MONx, TVectStr *nameN, TDonnees *Donnees)
{

char message[MAXLGMESS];
int i,j,l;
int Code=OK;
 

if (luX==FAUX)
  {
    ecrErr(stderr,"suiteDonnees","'x' missing.", ERRINPUT);
    return(ERRINPUT);
  }
if (luFile==FAUX)
  {
    ecrErr(stderr,"suiteDonnees","'file'  missing.", ERRINPUT);
    return(ERRINPUT);
  }
if (luY==FAUX)
  {
    ecrErr(stderr,"suiteDonnees","'y'  missing.", ERRINPUT);
    return(ERRINPUT);
  }

Donnees->IndiceN = 0;

 if (nameN->nbele >0) {
   /* Verifier que le nom de la variable est parmi les va. explicatives
      et dterminer son indice */
   for (i=0 ; i < Donnees->NbX; i++) {
     if (strcmp(nameN->donnees[0], Donnees->NomX.donnees[i])==0) {
       Donnees->IndiceN = (i+1);
       break;
     }
   }
   if (Donnees->IndiceN == 0) {
     sprintf(message,
	     "The value of 'nameN' is %s but there are no independant variables so called.",
	     nameN);
    ecrErr(stderr,"suiteDonnees", message, ERRINPUT);
    Code=ERRINPUT;
  }
 }


if ((MONx->nbele / Donnees->NbX) != Donnees->NbObsT)
  {
    sprintf(message,
"%d values read for the 'x' but there are %d independant variables, %ld observations.",
	   MONx->nbele,  Donnees->NbX, Donnees->NbObsT);
    ecrErr(stderr,"suiteDonnees", message, ERRINPUT);
    Code=ERRINPUT;
  }
if ((Donnees->PoidsT.nbele >0) && (Donnees->PoidsT.nbele != Donnees->NbObsT))
  {
    sprintf(message,
"%d values read for the 'weights' but there are %ld observations.",
	   Donnees->PoidsT.nbele, Donnees->NbObsT);
    ecrErr(stderr,"suiteDonnees", message, ERRINPUT);
    Code=ERRINPUT;
  }
if ((Donnees->NomCT.nbele >0) && (Donnees->NomCT.nbele != Donnees->NbObsT))
  {
    sprintf(message,
"%d values read for the 'curves' but there are  %ld observations.",
	   Donnees->NomCT.nbele, Donnees->NbObsT);
    ecrErr(stderr,"suiteDonnees", message, ERRINPUT);
    Code=ERRINPUT;
  }

if (Code== OK)
  {

    /* ------------- Finir de remplir les entrees de nls2 -------------*/

    /* Mettre les x sous forme de matrice NbObsT * NbX */
    /* affecter les noms d'observations: leurs indices */
    CreerMatC((TShortInt)Donnees->NbObsT, 
	      (TShortInt)Donnees->NbX, 
	      &(Donnees->XObsT));
    CreerVectStr((TShortInt)Donnees->NbObsT, &(Donnees->NomObsT));

    l=0;
    for (i=0; i< Donnees->NbObsT; i++)
      {
	sprintf(Donnees->NomObsT.donnees[i],
		"i%-6d", i);
      for (j=0; j<Donnees->NbX; j++)
        {
        Donnees->XObsT.donnees[i][j] = MONx->donnees[l++];
        #ifdef DEBUG
          printf("X[%d][%d]=%g\n",i,j, Donnees->XObsT.donnees[i][j]);
	  #endif
       }
     }
  } /* fin CODE=OK */
return(Code);
}
/* ------------- fin suiteDonnees ------------------------------------*/

