/* +++++++++++++++++++++++++++++++++++++++++++++++++++
les define et les includes 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#include <string.h>
#include "nls2C.h"
/* pour crire les messages d'erreur */
extern void ecrErr(FILE *fic, char * nomcall , char *message, int Code);

extern TShortInt CreerVectShort(TShortInt nbele, TVectShort *pvect);
extern TShortInt CreerVectStr(TShortInt nbele, TVectStr *pvect);
extern void DetruVectStr(TVectStr *pvect);


/* pgmmes de ce module */

int nbList2C(char *NomModele,
         TShortInt *NbTheta, TShortInt *NbBeta,  
	      TShortInt *NbGamF, TShortInt *NbGamV, TShortInt *NbX,
         TShortInt *NbJ, TShortInt *NbEq, TShortInt *NbDF,
	     TLogic *YaCalcV, TLogic *CasSedo, TLogic *IndicCi);

void nameList2C(char *NomModele,
              TShortInt NbTheta, TShortInt NbBeta, TShortInt NbGamF, TShortInt NbGamV,
              TShortInt NbX, TShortInt NbJ,TShortInt NbEq, TShortInt NbDF,
              char **NomTheta, char **NomBeta,
        	 char **NomGamF,char **NomGamV,
              char **NomX, char *NomY, 
              char **NomValInt, char **NomLesF,char **NomLesDF,
		 int *Code);

int mots2C(FILE *fic, TShortInt Nb, char **Noms);

int cptemots2C(FILE *fic, TShortInt  *Nb);



/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            UTILITAIRES DE LECTURE DU FICHIER FORMEL DU MODELE
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */


/* ------------------------------------------------
Traite le mot-cle 'file'
Remplit NbX, NomX, NomY de Donnees
Remplit NbEq, NbJ, IndicCi, IndicX, NomValInt de GNLCtxInteg
Remplit NomFichier, NomTheta, NomBeta, NomGamF, NomGamV,
        YaCalcV, CasSedo de Modele
   ------------------------------------------------ */
int litFile(FILE *fic,
               TDonnees *Donnees, 
	       TModele *Modele,
	       TFuncInt *NbIndicTj)

  {

TShortInt NbTheta,  NbBeta,  NbGamF,  NbGamV,  NbDF;
 TShortInt NbX;
int Code;
int i,j;

TVectStr  NomLesF, NomLesDF;
TVectStr  NomValInt;
char *ficmod;


/* Lire le nom du fichier formel */
Modele->NomFichier= (char *) calloc ((unsigned int)255, sizeof (char));
ficmod = (char *) calloc ((unsigned int)255, sizeof (char));
fscanf(fic,"%255s", ficmod);
if (feof(fic))
  {
    ecrErr(stderr, "litFile", "Nothing read after the word 'file'.",
	   ERRINPUT);
    return(ERRINPUT);
  } /* fin if (feof(fic)) */
strcpy((Modele->NomFichier), ficmod);
printf("Model-description file:  %s\n", Modele->NomFichier);


/* Decode le fichier formel */
 NbTheta=0; NbBeta=0; NbGamF=0; NbGamV=0;
 NbDF=0; NbX=0; 

GNLCtxInteg.NbJ=0; 
GNLCtxInteg.NbEq=0; 
 GNLCtxInteg.IndicCi=FAUX;


Code = nbList2C(ficmod, &NbTheta, &NbBeta, 
	   &NbGamF, &NbGamV,
	   &NbX,
	   &(GNLCtxInteg.NbJ),  &(GNLCtxInteg.NbEq), &NbDF, 
	   &(Modele->YaCalcV), &(Modele->CasSedo),
	   &(GNLCtxInteg.IndicCi));


if (Code != 0)
  {
    ecrErr(stderr,"litfile",
"Error in the program 'nbList2C'\n", ERRINPUT);
  return(ERRINPUT);
  }
 Donnees->NbX= NbX;

CreerVectStr(NbTheta, &(Modele->NomTheta));
CreerVectStr(NbBeta, &(Modele->NomBeta));
CreerVectStr(NbGamF, &(Modele->NomGamF));
CreerVectStr(NbGamV, &(Modele->NomGamV));
CreerVectStr(Donnees->NbX, &(Donnees->NomX));
CreerVectStr(GNLCtxInteg.NbJ, &NomValInt);
CreerVectStr(GNLCtxInteg.NbEq, &NomLesF);
CreerVectStr(NbDF, &NomLesDF);

Donnees->NomY= (char *) calloc ((unsigned int)MAXLGCHP, sizeof (char));

nameList2C(ficmod,
             NbTheta, NbBeta, NbGamF,NbGamV, NbX,
             GNLCtxInteg.NbJ, GNLCtxInteg.NbEq, NbDF,
	     (Modele->NomTheta.donnees), (Modele->NomBeta.donnees),
	     (Modele->NomGamF.donnees), (Modele->NomGamV.donnees), 
	     (Donnees->NomX.donnees), (Donnees->NomY),
	     (NomValInt.donnees), (NomLesF.donnees), (NomLesDF.donnees),
              &Code);


if (Code != OK)
  {
    ecrErr(stderr,"litFile",
"Error in the program 'nameList2C'\n", ERRINPUT);
  return(ERRINPUT);
  }

GNLCtxInteg.IndicX =0;
if (Modele->CasSedo==1)
  {

/* IndicTj= indices dans NomX des valInt  */
CreerVectShort((TShortInt)GNLCtxInteg.NbJ, &(GNLCtxInteg.IndicTj));
*NbIndicTj=0;

for (i=0; i< GNLCtxInteg.NbJ; i++)
{
  for (j=0; j < Donnees->NbX; j++)
    {
    if (strcmp(NomValInt.donnees[i], Donnees->NomX.donnees[j])==0)
      {
         GNLCtxInteg.IndicX=1;
      GNLCtxInteg.IndicTj.donnees[*NbIndicTj]=j+1;
      *NbIndicTj= *NbIndicTj+1; /* ne pas mettre ++ */
      break; /* pas la peine d'aller voir les autres nomx */
      }
    } /* fin j */
} /* fin i */
  } /* fin CasSedo */

DetruVectStr(&NomValInt);
DetruVectStr(&NomLesF);
DetruVectStr(&NomLesDF);

return(OK);
  }
/* --------- fin  litFile ------------------------*/


/*--------------- Identification fonction ----------
| Nom de la fonction    : nbList2C            |
| Role                  : compter les elements des |
|  listes du fichier de description du modele      |
| Parametres d'entree   :                          |
| Parametres de sortie  :                          |
--------------------------------------------------*/

/*--------------- Appels croises -------------------
| Fonctions appelees   :                           |
| Fonctions appelantes :                           |
|   analFile                      |
--------------------------------------------------*/


/*--------------- Definition fonction ------------*/

/*--------------- Fin identification fonction ----*/

int nbList2C(char *NomModele,
         TShortInt *NbTheta, TShortInt *NbBeta,  
        TShortInt *NbGamF, TShortInt *NbGamV, TShortInt *NbX,
         TShortInt *NbJ, TShortInt *NbEq, TShortInt *NbDF,
	     TLogic *YaCalcV, TLogic *CasSedo, TLogic *IndicCi)

/* arguments d'entree:
char *NomModele;

 arguments de sortie :
int *NbTheta, *NbBeta,  *NbGamF, *NbGamV, *NbX, *NbJ, *NbEq, *NbDF;
TLogic *YaCalcV, *CasSedo, *IndicCi;
*/

/*--------------- Fin identification fonction ----*/

{


char  motlu[MAXMOT], ch[MAXLIG];
FILE *fic;
int Code=OK;

if  ( (fic= fopen(NomModele,"r")) == NULL)
  {
  fprintf(stderr,
"\nError when opening the model description file %s \n", NomModele);
  Code=ERR;
  return(Code);
  }

while( fscanf(fic,"%s", motlu) != EOF)
  {
    if (strncmp(motlu, "%",1) ==0)
      {
      fgets(ch, MAXLIG, fic);
      continue;
      }


    if (strncmp(motlu,"varind", 6)==0)
      {
      if (cptemots2C(fic, NbX) != OK) 
       return(Code);
      continue;
      }

    if (strncmp(motlu,"parresp", 7)==0)
      {
      if (cptemots2C(fic, NbTheta) != OK)
       return(Code);
      continue;
      }

    if (strncmp(motlu,"parvar", 6)==0)
      {
      if (cptemots2C(fic, NbBeta) != OK) 
       return(Code);
      continue;
      }


    if (strncmp(motlu,"pbisresp", 8)==0)
      {
	if (cptemots2C(fic, NbGamF) != OK)  
		return(Code); 
      continue;
      }

    if (strncmp(motlu,"pbisvar", 7)==0)
      {
      if (cptemots2C(fic, NbGamV) != OK) 
       return(Code);
      continue;
      }
    if (strncmp(motlu,"varint", 6)==0)
      {
      *CasSedo=1;
      continue;
      }

    if (strncmp(motlu,"var", 3)==0)
      {
      /* variance */
      *YaCalcV=1;
      continue;
      }

    if (strncmp(motlu,"valint", 6)==0)
      {
      if (cptemots2C(fic, NbJ) != OK) 
       return(Code);
      continue;
      }
    if (strncmp(motlu,"F", 1)==0)
      {
      if (cptemots2C(fic, NbEq) != OK)
       return(Code);
      continue;
      }
    if (strncmp(motlu,"dF", 2)==0)
      {
      if (cptemots2C(fic, NbDF) != OK)
       return(Code);
      continue;
      }
    if (strncmp(motlu,"condinit", 8)==0)
      {
      *IndicCi=1;
      continue;
      }


  } /* fin du while fscanf */
fclose(fic);

return(Code);
}

/* ------------- fin nbList2C ----------------------------- */

/*--------------- Identification fonction ----------
| Nom de la fonction    : cptemots2C
| Role                  : compter les elements d'une |
|  liste du fichier de description du modele      |
| Parametres d'entree   :                          |
| Parametres de sortie  :                          |
--------------------------------------------------*/

/*--------------- Appels croises -------------------
| Fonctions appelees   :                           |
| Fonctions appelantes :                           |
|  nbList2C
--------------------------------------------------*/


/*--------------- Definition fonction ------------*/

/*--------------- Fin identification fonction ----*/

int
cptemots2C(FILE *fic, TShortInt *Nb)

/* arguments d'entree :
FILE *fic;

 arguments de sortie:
TShortInt *Nb;
*/


/*--------------- Fin identification fonction ----*/

{

char chaine[MAXLIG], chlu[MAXLIG];


strcpy(chaine,"");
do
  {
  if( fscanf(fic,"%s",chlu) == EOF)
    {
    fprintf(stderr,
"\n Error: a key-word not followed by at least one value \n");
    return(ERR);
    }
  strcat(chaine,chlu);
  }  while(strstr(chlu,";")==NULL);


/* les blancs sont otes de la liste */
strtok(chaine,",;");
*Nb=1;
while(strtok(NULL, ",;") !=NULL)
  {
  *Nb = *Nb + 1;
  }
return(OK);
}

/* ------------- fin cptemots2C ----------------------------- */


/*--------------- Identification fonction ----------
| Nom de la fonction    : nameLits2C             |
| Role                  : renvoyer les noms des    |
|  listes du fichier de description du modele      |
| Parametres d'entree   :                          |
| Parametres de sortie  :                          |
--------------------------------------------------*/

/*--------------- Appels croises -------------------
| Fonctions appelees   :                           |
| Fonctions appelantes :                           |
|     litFile
--------------------------------------------------*/


/*--------------- Definition fonction ------------*/

/*--------------- Fin identification fonction ----*/

void nameList2C(char *NomModele,
              TShortInt NbTheta, TShortInt NbBeta, TShortInt NbGamF, TShortInt NbGamV,
              TShortInt NbX, TShortInt NbJ,TShortInt NbEq, TShortInt NbDF,
              char **NomTheta, char **NomBeta,
        	 char **NomGamF,char **NomGamV,
              char **NomX, char *NomY, 
              char **NomValInt, char **NomLesF,char **NomLesDF,
		 int *Code)

/*--------------- Fin identification fonction ----*/

{
/* arguments d'entree :
char **ficmod;
long *NbTheta, *NbBeta, *NbGamF, *NbGamV,*NbX, *NbJ, *NbEq, *NbDF;
 arguments de sortie :
char ***NomTheta, ***NomBeta, ***NomGamF, ***NomGamV, ***NomX,  **NomY;
char ***NomValInt, ***NomLesF, ***NomLesDF;
long *Code;
*/

char  ch[MAXLIG];
char motlu[MAXMOT], nom[MAXMOT];

FILE *fic;

if ((fic= fopen(NomModele,"r")) == NULL)
  {
  fprintf(stderr,
"\nError when opening the model description file %s \n", NomModele);
  *Code=ERR;
  return;
  }

while(  fscanf(fic,"%s", motlu) != EOF)
  {


    if (strncmp(motlu, "%",1) ==0)
      {
      fgets(ch, MAXLIG, fic);
      continue;
      }

    if (strncmp(motlu,"resp", 4)==0)
      {
      if(fscanf(fic,"%s", nom)==EOF)
        {
        fprintf(stderr,
"\n Error: the key-word `resp' not followed by a value \n");
        *Code=ERR;
        return;
       }
      strcpy(NomY, (char *)strtok(nom,";"));
      continue;
      }


    if (strncmp(motlu,"varind", 6)==0)
      {
      if (mots2C(fic, NbX, NomX) != OK)
	return;
      continue;
      }

    if (strncmp(motlu,"parresp", 7)==0)
      {
      if (mots2C(fic, NbTheta, NomTheta) != OK)
       return;
      continue;
      }

    if (strncmp(motlu,"parvar", 6)==0)
      {
      if (mots2C(fic, NbBeta, NomBeta) != OK)
       return;
      continue;
      }

    if (strncmp(motlu,"pbisresp", 8)==0)
      {
      if (mots2C(fic, NbGamF, NomGamF) != OK)
       return;
      continue;
      }
    if (strncmp(motlu,"pbisvar", 7)==0)
      {
      if (mots2C(fic, NbGamV, NomGamV) != OK)
       return;
      continue;
      }
    if (strncmp(motlu,"valint", 6)==0)
      {
      if (mots2C(fic, NbJ,NomValInt) != OK)
       return;
      continue;
      }

    if (strncmp(motlu,"F", 1)==0)
      {
      if (mots2C(fic, NbEq,  NomLesF) != OK)
       return;
      continue;
      }
    if (strncmp(motlu,"dF", 2)==0)
      {
      if (mots2C(fic, NbDF, NomLesDF) != OK)
       return;
      continue;
      }
    if (strncmp(motlu,"subroutine", 10)==0)
      {
      break;
      }

  } /* fin du while fscanf */

fclose(fic);
return;
}

/* ------------- fin nameLits2C ----------------------------- */


/*--------------- Identification fonction ----------
| Nom de la fonction    : mots2C
| Role                  : renvoyer les elements d'une |
|  liste du fichier de description du modele      |
| Parametres d'entree   :                          |
| Parametres de sortie  :                          |
--------------------------------------------------*/

/*--------------- Appels croises -------------------
| Fonctions appelees   :                           |
| Fonctions appelantes :                           |
|  la fonction C: nameLits2C
--------------------------------------------------*/


/*--------------- Definition fonction ------------*/

/*--------------- Fin identification fonction ----*/

int
mots2C(FILE *fic, TShortInt Nb, char **Noms)

/* arguments d'entree 
FILE *fic;
int Nb;

 arguments de sortie
char **Noms;
*/

/*--------------- Fin identification fonction ----*/

{

char chaine[MAXLIG], chlu[MAXLIG];
int i;

strcpy(chaine,"");
do
  {
  if( fscanf(fic,"%s",chlu) == EOF)
    {
    fprintf(stderr,
"\n Error: a key-word not followed by at least one value \n");
    return(ERR);
    }
  strcat(chaine,chlu);
  }  while(strstr(chlu,";")==NULL);

/* dans chaine, les blancs sont otes de la liste */
strcpy(Noms[0], strtok(chaine,",;"));

for (i=1; i<Nb; i++)
  {
  strcpy(chlu, strtok(NULL, ",;"));
  strcpy(Noms[i], chlu);
  }
return(OK);
}

/* ------------- fin mots2C ----------------------------- */
