/* +++++++++++++++++++++++++++++++++++++++++++++++++++
les define et les includes 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#include "nls2C.h"
/* pour crire les messages d'erreur */
extern void ecrErr(FILE *fic, char * nomcall , char *message, int Code);
/* autres */
extern int LitVectP(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     int *nbP,
                char *mot, TVect *Val);
extern int LitVectPS(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     int *nbP,
                char *mot, TVectShort *Val);
extern int LitStr(FILE *fic,
	     TVectStr motscle, TVectShort nbmotscle,
	     char *chaine, char *mot);


/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    UTILITAIRES DE LECTURE DU CONTENU de Modele
a l'exception de 'file' qui est lu par litFile
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */


/* ------------------------------------------------
Grer tout ce qui suit un 'motcle' concernant Modele
Renvoyer la 1iere chaine de car suivante non reconnue dans mot
Remplit dans Modele: CBeta0,  CTheta0, GamF, GamV, Vari
---------------------------------------------------*/
int litModele(FILE *fic, 
	       TVectStr motscle, TVectShort nbmotscle,
	      TModele *Modele,
		  char *mot)
{

char message[MAXLGMESS];
int Code=OK;
int n=-1;
int i, nTypeVari=8;
char *TypeVari[8];
TChar *MONtype;


/* Initialisations */
TypeVari[0]="cst";
TypeVari[1]="sw";
TypeVari[2]="vst";
TypeVari[3]="vb";
TypeVari[4]="vsb";
TypeVari[5]="vstb";
TypeVari[6]="vtb";
TypeVari[7]="vi";

if (strncmp(mot, "vari.type",4)==0)
  {
    CREER_T1(MONtype , MAXCH, char);
    Code=LitStr(fic, motscle, nbmotscle, MONtype, mot);
    if ((Code != FINOF) && (Code !=OK))
    {
    ecrErr(stderr,"litModele",
	   "Error while reading 'vari.type'\n", ERRINPUT);
    return(ERRINPUT);
    }
  Modele->Vari=0;

  for (i=0; i<nTypeVari; i++)
    {
    if (strcmp(MONtype,TypeVari[i])==0)
      {
      Modele->Vari=(i+1);
      break;
      }
    }
  if (Modele->Vari==0)
    {
      sprintf(message, "Unknown type of model variance, 'vari.type', %s\n",
	MONtype);
      ecrErr(stderr,"litModele", message, ERRINPUT);
    return(ERRINPUT);
   }
#ifdef DEBUG
printf("litModele: vari.type %s => %d\n", MONtype,Modele->Vari );
printf("mot=%s\n", mot);
#endif

  return(Code);
} /* fin vari.type */



if (strncmp(mot,"gamf",4) ==0)
  {
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code=LitVectP(fic, motscle, nbmotscle,  &n, mot, &(Modele->GamF));
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litModele",
	   "Error while reading 'gamf'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
}  /* fin if ((strncmp(mot),"gamf" */


if (strncmp(mot,"gamv",4) ==0)
  {
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code=LitVectP(fic, motscle, nbmotscle,  &n, mot, &(Modele->GamV));
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litModele",
	   "Error while reading 'gamv'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
} /* fin if (strncmp(mot,"gamv", */

/* Les contraintes sur Theta */

if (strncmp(mot,"eq.theta",4) ==0)
  {
    Modele->CTheta0.Ctr=VRAI;
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code=LitVectP(fic, motscle, nbmotscle,  &n, mot, &(Modele->CTheta0.EgalN));
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litModele",
	   "Error while reading 'eq.theta'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
} /* fin if (strncmp(mot,"eq.theta" */


if (strncmp(mot,"eqp.theta",4) ==0)
  {
    Modele->CTheta0.Ctr=VRAI;
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code=LitVectPS(fic, motscle, nbmotscle,  &n, mot, &(Modele->CTheta0.EgalP));
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litModele",
	   "Error while reading 'eqp.theta'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
} /* fin if (strncmp(mot,"eqp.theta" */

if (strncmp(mot, "inf.theta",6)==0)
  {
  Modele->CTheta0.Ctr=VRAI;
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code=LitVectP(fic, motscle, nbmotscle,  &n, mot, &(Modele->CTheta0.BInf));
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litModele",
	   "Error while reading 'inf.theta'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
} /* fin if (strncmp(mot, "inf.theta",6)==0) */

if (strncmp(mot, "sup.theta",6)==0)
  {
  Modele->CTheta0.Ctr=VRAI;
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code=LitVectP(fic, motscle, nbmotscle,  &n, mot, &(Modele->CTheta0.BSup));
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litModele",
	   "Error while reading 'sup.theta'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
} /* fin if (strncmp(mot, "sup.theta",6)==0) */


/* Les contraintes sur Beta */

if (strncmp(mot,"eq.beta",4) ==0)
  {
    Modele->CBeta0.Ctr=VRAI;
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code=LitVectP(fic, motscle, nbmotscle,  &n, mot, &(Modele->CBeta0.EgalN));
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litModele",
	   "Error while reading 'eq.beta'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
} /* fin if (strncmp(mot,"eq.beta" */


if (strncmp(mot,"eqp.beta",4) ==0)
  {
    Modele->CBeta0.Ctr=VRAI;
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code=LitVectPS(fic, motscle, nbmotscle,  &n, mot, &(Modele->CBeta0.EgalP));
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litModele",
	   "Error while reading 'eqp.beta'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
} /* fin if (strncmp(mot,"eqp.beta" */

if (strncmp(mot, "inf.beta",6)==0)
  {
  Modele->CBeta0.Ctr=VRAI;
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code=LitVectP(fic, motscle, nbmotscle,  &n, mot, &(Modele->CBeta0.BInf));
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litModele",
	   "Error while reading 'inf.beta'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
} /* fin if (strncmp(mot, "inf.beta",6)==0) */

if (strncmp(mot, "sup.beta",6)==0)
  {
  Modele->CBeta0.Ctr=VRAI;
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code=LitVectP(fic, motscle, nbmotscle,  &n, mot, &(Modele->CBeta0.BSup));
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litModele",
	   "Error while reading 'sup.beta'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
} /* fin if (strncmp(mot, "sup.beta",6)==0) */




if (strncmp(mot,"gamf",4) ==0)
  {
    n=-1; /* on ignore a priori le nbre de valeurs a lire */
    Code=LitVectP(fic, motscle, nbmotscle,  &n, mot, &(Modele->GamF));
    if ((Code != FINOF) && (Code != OK))
    {
    ecrErr(stderr,"litModele",
	   "Error while reading 'gamf'\n", ERRINPUT);
    return(ERRINPUT);
    }
    return(Code);
  }


/* On est pass nulle part */
/* Erreur dans ce programme */
sprintf(message,"Internal error: %s not valid.\n", mot);
ecrErr(stderr,"litModele",message, ERRINT);
return(ERRINT);
}


/* --------------- fin litModele ----------------------------*/
