/* +++++++++++++++++++++++++++++++++++++++++++++++++++
les define et les includes 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#include "nls2C.h"
#define PERLINE 5 /* nbre de nbres par ligne */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                UTILITAIRES D'ECRITURE
 10 = nbre de chiffres before the point 
 5  = nbre de chiffres after  the point 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/*--------------- Identification fonction ----------
| Nom de la fonction    :  pr2D                  |
| Role                  :  Ecriture des valeurs    |
|   d'une matrice de type double
|   en format %g, PERLINE valeurs par ligne              |
--------------------------------------------------*/


/*--------------- Appels croises -------------------
| Fonctions appelees   : aucune                    |
| Modules appelants    :                           |
|       le main                                    |
--------------------------------------------------*/


/*--------------- Definition fonction ------------*/
void pr2D(FILE *unite, double **matin, int nblig, int nbcol)
/*--------------- Fin identification fonction ----*/

{

/* ........ variables internes : .......................................... */
TShortInt i,j;

if ((nblig <= 0) || (nbcol <=0 ))
  {
  fprintf(unite, "empty structure\n");
  return;
  }


for (i = 0; i < nblig; i++)
  {
    for(j = 0; j < nbcol; j++)
      {
	fprintf(unite,"%10.5g ", matin[i][j]);
	if ((j+1) % PERLINE == 0) fprintf(unite,"\n");
      }
    if ((j %5) !=0)
        fprintf(unite,"\n");
  }
fprintf(unite,"\n");
return;
}


/*--------------- Identification fonction ----------
| Nom de la fonction    :  pr3D                  |
| Role                  :  Ecriture des valeurs    |
|   d'une matrice 3-dim de type double
|   en format %g, PERLINE valeurs par ligne              |
--------------------------------------------------*/


/*--------------- Appels croises -------------------
| Fonctions appelees   : aucune                    |
| Modules appelants    :                           |
|       le main                                    |
--------------------------------------------------*/


/*--------------- Definition fonction ------------*/
void pr3D(FILE *unite, double ***matin, int nblig, int nbcol, int n3)
/*--------------- Fin identification fonction ----*/

{

/* ........ variables internes : .......................................... */
TShortInt i;

if ((nblig <= 0) || (nbcol <=0 ) || (n3 <= 0))
  {
  fprintf(unite, "empty structure\n");
  return;
  }

	for (i=0; i< nblig; i++)
	  {
	    pr2D(unite, matin[i], nbcol, n3);
	  }
fprintf(unite,"\n");
return;
}



/*--------------- Identification fonction ----------
| Nom de la fonction    : pr2S              |
| Role                  :  Ecriture des valeurs    |
|   d'une matrice de type short,               |
|   en format %d, PERLINE valeurs par ligne              |
--------------------------------------------------*/


/*--------------- Appels croises -------------------
| Fonctions appelees   : aucune                    |
| Modules appelants    :                           |
|       main                                       |
--------------------------------------------------*/


/*--------------- Definition fonction ------------*/
void pr2S(FILE *unite, short **matin, int nblig, int nbcol)

/*--------------- Fin identification fonction ----*/

{

/* ........ variables internes : .......................................... */
TShortInt i,j;

if ((nblig <= 0) || (nbcol <=0 ))
  {
  fprintf(unite, "empty structure\n");
  return;
  }


for (i = 0; i < nblig; i++)
  {
  for(j = 0; j < nbcol; j++)
    {
    fprintf(unite,"%10d ", matin[i][j]);
    if ((j+1) % PERLINE == 0) fprintf(unite,"\n");
    }
  if ((j%5) !=0)
    fprintf(unite,"\n");
  }
fprintf(unite,"\n");
return;
}


/*--------------- Identification fonction ----------
| Nom de la fonction    : pr1D               |
| Role                  :  Ecriture des valeurs    |
|   d'un vecteur de type double,                    |
|   en format %g, PERLINE valeurs par ligne              |
--------------------------------------------------*/


/*--------------- Appels croises -------------------
| Fonctions appelees   : aucune                    |
| Modules appelants    :                           |
|       main                                       |
--------------------------------------------------*/

/*--------------- Definition fonction ------------*/
void pr1D(FILE *unite, double *vectin, int nbele)

/*--------------- Fin identification fonction ----*/

{
int i;
if (nbele <= 0)
  {
  fprintf(unite, "empty structure\n");
  return;
  }


for (i = 0; i < nbele; i++)
  {
  fprintf(unite, "%10.5g ", vectin[i]);
  if ((i+1) % PERLINE == 0) fprintf(unite,"\n");
  }
fprintf(unite,"\n");
return;
}



/*--------------- Identification fonction ----------
| Nom de la fonction    : pr1L               |
| Role                  :  Ecriture des valeurs    |
|   d'un vecteur de type long,                     |
|   en format %ld, PERLINE valeurs par ligne             |
--------------------------------------------------*/


/*--------------- Appels croises -------------------
| Fonctions appelees   : aucune                    |
| Modules appelants    :                           |
|       main                                       |
--------------------------------------------------*/

/*--------------- Definition fonction ------------*/
void pr1L(FILE *unite, long *vectin, int nbele)
/*--------------- Fin identification fonction ----*/

{
int i;
if (nbele <= 0)
  {
  fprintf(unite, "empty structure\n");
  return;
  }


for (i = 0; i < nbele; i++)
  {
  fprintf(unite, "%10ld ", vectin[i]);
  if ((i+1) % PERLINE == 0) fprintf(unite,"\n");
  }
fprintf(unite,"\n");
return;
}



/*--------------- Identification fonction ----------
| Nom de la fonction    : pr1S               |
| Role                  :  Ecriture des valeurs    |
|   d'un vecteur de type short,                    |
|   en format %hd, PERLINE valeurs par ligne             |
--------------------------------------------------*/


/*--------------- Appels croises -------------------
| Fonctions appelees   : aucune                    |
| Modules appelants    :                           |
|       main                                       |
--------------------------------------------------*/

/*--------------- Definition fonction ------------*/
void pr1S(FILE *unite, short *vectin, int nbele)

/*--------------- Fin identification fonction ----*/

{

/* ........ variables internes : .......................................... */
TShortInt i;
if (nbele <= 0)
  {
  fprintf(unite, "empty structure\n");
  return;
  }


for (i = 0; i < nbele; i++)
  {
  fprintf(unite, "%10hd ", vectin[i]);
  if ((i+1) % PERLINE == 0) fprintf(unite,"\n");
  }
fprintf(unite,"\n");
return;
}

