/* ----------------------------------------------------------------------
Ecriture sur fichier de l'instruction qui permet
de creer une structure Splus de type nls2.object
 partir  des valeurs stockes dans les structures
(toutes sont dcl en global) de nls2
Il suffit  l'utilisateur de faire "source(nom-du-fichier-cr)", sous Splus,
pour crer une structure Splus de type nls2.object.
------------------------------------------------------------------------- */

/* +++++++++++++++++++++++++++++++++++++++++++++++++++
les define et les includes 
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#include <string.h>
#include "nls2C.h"
#define precision 12 /* le nbre de chiffres significatifs sur le fichier cr */
/* pour crire les messages d'erreur */
extern void ecrErr(FILE *fic, char * nomcall , char *message, int Code);

/* Fonctions  de ce module qui sont appeles avant leur definition */
int ctxintegsplus(char *nom, FILE *fic, TDonnees *Donnees);
int ctxpusssplus(char *nom, FILE *fic, TCtxPuss *CtxPuss);
int donneessplus(char *nom, FILE *fic, TDonnees *Donnees);
int divsplus( FILE *fic, char *debut, TCtxNum *CtxNum);
int estimsplus(FILE *fic, char *debut, char *nom,
	       TParam *Param, TVectStr NomParam);
void itlabsplus( FILE *fic,  int ietap);
int itsplus( FILE *fic, char *debut, int ietap);
TLogic iszeromatd(TMat *mat);
TLogic iszerovectd(TVect *vect);
int modelesplus(char *nom, FILE *fic, TModele *Modele);
int MONmots(FILE *fic, TShortInt Nb, TVectStr *Noms);

int resnumsplus( FILE *fic, char *debut,
	       TResNum *ResNum, TShortInt i);
int resstatsplus(FILE *fic, char *debut,
	       TResStat *ResStat,
		TVectStr NomThetaMult, TVectStr NomBetaMult);
int sedosplus( FILE *fic, char *debut,
	       TResStat *ResStat);
int spluslabsedo( TVectStr *NomLesF, TVectStr *NomLesDF,
		 TVectStr *NomValInt);
void splusmatd(FILE *fic, TMat *mat, char *debut, char *nom,
	       char *lablig, char *labcol);
void splusstr(FILE *fic, TVectStr *vect);
void splusvectd(FILE *fic, TVect *vect, char *debut, char *nom);
void splusvectstr(FILE *fic, TVectStr *vect,  char *debut, char *nom);
void splusvectshort(FILE *fic, TVectShort *vect,  char *debut, char *nom);


/* Autres de nls2 */
extern TShortInt CreerVectStr( TShortInt nbele, TVectStr *pvect);
extern void DetruVectStr(TVectStr *pvect);

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++
splus2C
+++++++++++++++++++++++++++++++++++++++++++++++++++++  */
int splus2C( char *nom , char *nomdata, FILE *fic)
/* ............... Arguments d'entree      ....................... */
/* nom : le nom de la structure Splus a creer */
     /* nomdata : le nom de la structure Splus suppose contenir le data-frame
	des donnees, car il faut le rappeler dans le nls2.object */
     /* fic: le  fichier de sortie */
/* ............... Arguments de sortie   ....................... */

     /* ............... Retour ....................................... */
     /* 0 ou un code d'erreur */
{
/* Pour les messages d'erreur */
char message[MAXLGMESS];


TShortInt i,ietap ; /* indice de la dernire tape calcule */
int code=OK;
char  debut[50];


/* Pour les labels */
int j, nthetamult, nbetamult, ltheta, lbeta;
TVectStr NomThetaMult, NomBetaMult;


/* ------------------ debut du corps ------------------------------ */



ietap =  CtxPuss.NbEtapes-1;
if ((ietap <0) || (ietap > 2))
  {
    sprintf(message,
"Invalid value for the step index: %d:  have you called 'nls2C' before? \n", ietap);
    ecrErr(stderr,"splus2C",message,  ERRFOUND);
	return((int)ERRFOUND);
  }

fprintf(fic, "%s <-  list(call = list(call='nls2C', data=", nom);
fprintf(fic, "\"%s\")", nomdata);
fprintf(fic, ", nb.steps = %d,\n", CtxPuss.NbEtapes);
fprintf(fic, " response.name ='%s')\n", Donnees.NomY);
fprintf(fic, " class(%s) <- 'nls2'\n", nom); 
sprintf(debut, "%s$", nom);
splusvectstr(fic, &(Donnees.NomX), debut, "X.names");


if ((code=modelesplus(nom, fic, &Modele)) !=OK)
  return(code);

if ((code=ctxpusssplus(nom, fic, &CtxPuss)) !=OK)
  return(code);

if (Modele.CasSedo==VRAI)
{
 if ((code= ctxintegsplus(nom, fic, &Donnees)) !=OK)
    return(code);
}

if (GNLControle.Voulu.Data==VRAI)
  {
    if ((code= donneessplus(nom, fic, &Donnees)) !=OK)
    return(code);
  }

/* Preparer les labels des parametres en dim multiples */
    nthetamult = Theta[0].Estim.nbele;
    APPEL(CreerVectStr(nthetamult, &(NomThetaMult)));
	nbetamult = Beta[0].Estim.nbele;
	APPEL(CreerVectStr(nbetamult, &(NomBetaMult)));
	ltheta=0;
	lbeta=0;

	for (i=0; i < Donnees.NbCourbe; i++)
	  {
	    for (j=0; j < Modele.NomTheta.nbele; j++)
	      {
		if (Donnees.NbCourbe > 1)
		  sprintf(NomThetaMult.donnees[ltheta++], "%s_c%-d",
			Modele.NomTheta.donnees[j],(i+1));
		else
		  sprintf(NomThetaMult.donnees[ltheta++], "%s",
			Modele.NomTheta.donnees[j]);  
	      }
		for (j=0; j < Modele.NomBeta.nbele; j++)
		  {
		    if (Donnees.NbCourbe > 1)
		      sprintf(NomBetaMult.donnees[lbeta++], "%s_c%-d",
			Modele.NomBeta.donnees[j],(i+1));
		    else
		      sprintf(NomBetaMult.donnees[lbeta++], "%s",
			      Modele.NomBeta.donnees[j]);
		  }
	  } /* fin or (i=0; i < Donnees.NbCourbe; i++) */

/* Ce qu'on recupere toujours du ResNum: le code
ce qui permet de creer, eventuellement, les listes 'stepi' */

for (i=0; i < CtxPuss.NbEtapes; i++)
  {
    if (CtxPuss.NbEtapes > 1)
      {
	fprintf(fic, " %s$step%1d <- list(code=%d)\n", nom, (i+1), ResNum[i].CodePuss);
	/* warning par gcc -Wall avec :
      sprintf(debut, "%s$step%1d$", nom, (i+1));
	*/
	sprintf(debut, "%s$step%1d", nom, (i+1));
	strcat(debut,"$");
      }
    else
      {
	fprintf(fic, " %s$code <- %d\n", nom, ResNum[0].CodePuss);
      sprintf(debut, "%s$", nom);
      }

    if (divsplus( fic, debut, &(CtxNum[i])) != OK)
      {
	ecrErr(stderr,"splus2C","Error in 'divsplus'\n", ERRINT);
	return(ERRINT);
      }

    if (resnumsplus( fic, debut, &(ResNum[i]), i) != OK)
      {
	ecrErr(stderr,"splus2C","Error in 'resnumsplus'\n", ERRINT);
	return(ERRINT);
      }

    if (resstatsplus( fic, debut, &(ResStat[i]), NomThetaMult, NomBetaMult) != OK)
      {
	ecrErr(stderr,"splus2C","Error in 'resstatsplus'\n", ERRINT);
	return(ERRINT);
      }
  
    if (estimsplus(fic, debut, "theta", &(Theta[i]), NomThetaMult ) != OK)
      {
	ecrErr(stderr,"splus2C","Error in 'estimsplus'\n", ERRINT);
	return(ERRINT);
      }
  
    if (Modele.NomBeta.nbele >0)
      {
	if (estimsplus(fic, debut, "beta", &(Beta[i]), NomBetaMult) != OK)
	  {
	    ecrErr(stderr,"splus2C","Error in 'estimsplus'\n", ERRINT);
	    return(ERRINT);
	  }
      }
    if (Modele.CasSedo == VRAI)
      {
	if (sedosplus( fic, debut, &(ResStat[i])) != OK)
	  {
	    ecrErr(stderr,"splus2C","Error in 'sedosplus'\n", ERRINT);
	    return(ERRINT);
	  }
     } /* fin if (Modele.CasSedo == VRAI) */


    if (NbItSv[i] > 0)
      {
	if (itsplus( fic, debut, i) != OK)
	  {
	    ecrErr(stderr,"splus2C","Error in 'itsplus'\n", ERRINT);
	    return(ERRINT);
	  }
      }

  } /* fin for (i=0; i < CtxPuss.NbEtapes; i++) */

DetruVectStr(&NomThetaMult);
if (Modele.NomBeta.nbele > 0)
  DetruVectStr(&NomBetaMult);

return(OK);
}
/* ............... fin splus2C ........................*/

/* -------------------------------------------------------
Ecriture de ce qui concerne les resultats num
----------------------------------------------------------*/
int 
resnumsplus( FILE *fic, char *debut,
	       TResNum *ResNum, TShortInt Etape)
{

    fprintf(fic, " %smessage <- '%s'\n",debut, 
	    recup1C("message",1));

    fprintf(fic, " %snb.iters <- %ld\n", debut, ResNum->NbIter);
    /* On rajoute le reste seulement si requis: en fait, c'est tjrs le cas */
    if (GNLControle.Voulu.ResNum == VRAI)
      {
	    fprintf(fic, " %sstop.crit <- %.*g\n", debut, precision, ResNum->CritArret);
	    fprintf(fic, " %sstat.crit <- %.*g\n", debut, precision, ResNum->CritStat);
	    fprintf(fic, " %slambda <- %.*g\n", debut, precision, ResNum->Lambda);
            if ( ResNum->Log != DBL_MAX)
	    fprintf(fic, " %sloglik <- %.*g\n", debut, precision, ResNum->Log);
	    if ( ResNum->LogFamille != DBL_MAX)
	      fprintf(fic, " %slog.%s <- %.*g\n", debut,
		      recup1C("family",1),
		      precision, ResNum->LogFamille);

	    if ( ResNum->Deviance != DBL_MAX)
	      fprintf(fic, " %sdeviance <- %.*g\n", debut, precision, ResNum->Deviance);

	    fprintf(fic, " %snorm <- %.*g\n", debut, precision, ResNum->Norme);
	    fprintf(fic, " %srss <- %.*g\n", debut, precision, ResNum->Scr);
	    fprintf(fic, " %srss.unweighted <- %.*g\n", debut, precision, ResNum->ScrNP);
	    fprintf(fic, " %ssigma2 <- %.*g\n", debut, precision, ResNum->Sigma);

	splusvectd(fic, &(ResNum->ResidusDev), debut, "dev.residuals");
  } /* fin (GNLControle.Voulu.ResNum == VRAI) */


return(OK);
}
/* ................... fin resnumsplus ........................*/

/* -------------------------------------------------------
Ecriture de ce qui concerne les valeurs estimes des parametres
----------------------------------------------------------*/
int 
estimsplus(FILE *fic, char *debut, char *nom,
	       TParam *Param, TVectStr NomParam)

{
char cible[100], fin[10];

/* ------------------ debut du corps ------------------------------ */

splusvectd(fic, &(Param->Estim), debut, nom);
/* Rajouter les noms */
sprintf(cible, "names(%s", debut);
sprintf(fin, "%s)", nom);
splusvectstr(fic, &(NomParam), cible, fin);

return(OK);
}
/* ................... fin estimsplus ........................*/


/* -------------------------------------------------------
Ecriture de ce qui concerne les resultats stat
----------------------------------------------------------*/
int 
resstatsplus(FILE *fic, char *debut,
	       TResStat *ResStat,
		TVectStr NomThetaMult, TVectStr NomBetaMult)

/* ............... Arguments d'entree      ....................... */
/* nom : le nom de la structure Splus a creer */
     /* fic: le  fichier de sortie */
     /* ............... Retour ....................................... */
     /* 0 ou un code d'erreur */
{
char  labelnull[5], label[100];

/* ------------------ debut du corps ------------------------------ */
sprintf(labelnull, "NULL");
 sprintf(label, "names(%s", debut);


    if (GNLControle.Voulu.Ajustes == VRAI)
      {
	splusvectd(fic, &(ResStat->Ajustes.Valf), debut, "response");
	splusvectd(fic, &(ResStat->Ajustes.VarY), debut, "variance");
	splusvectstr(fic, &(Donnees.NomObs),  label, "response)");
	splusvectstr(fic, &(Donnees.NomObs),  label, "variance)");
      }

    if ( (GNLControle.Voulu.AsVar == VRAI) && (ResStat->AsVar.nblig>0 ))
      {
	splusmatd(fic, &(ResStat->AsVar), debut, "as.var",
		 labelnull,  labelnull);
/* Preparation des labelmults */
	fprintf(fic, "dimnames(%sas.var) <- list(c(", debut);
	splusstr(fic, &(NomThetaMult));
	if (NomBetaMult.nbele >0)
	  {
	    fprintf(fic, ",");
	    splusstr(fic, &(NomBetaMult));
	  }

	fprintf(fic, ") ,c(");
	splusstr(fic, &(NomThetaMult));
	if (NomBetaMult.nbele >0)
	  {
	    fprintf(fic, ",");
	    splusstr(fic, &(NomBetaMult));
	  }

        fprintf(fic, "))\n");
      } /* fin  if (GNLControle.Voulu.AsVar == VRAI) */


    if ( (GNLControle.Voulu.Corr == VRAI) && (ResStat->Corr.nblig >0 ))
      {
	splusmatd(fic, &(ResStat->Corr), debut, "correlation",
		 labelnull,  labelnull);
/* Preparation des label */
	fprintf(fic, "dimnames(%scorrelation) <- list(c(", debut);
	splusstr(fic, &(NomThetaMult));
	if (NomBetaMult.nbele >0)
	  {
	    fprintf(fic, ",");
	    splusstr(fic, &(NomBetaMult));
	  }

	fprintf(fic, ") ,c(");
	splusstr(fic, &(NomThetaMult));
	if (NomBetaMult.nbele >0)
	  {
	    fprintf(fic, ",");
	    splusstr(fic, &(NomBetaMult));
	  }

        fprintf(fic, "))\n");
      } /* fin  if (GNLControle.Voulu.Corr == VRAI) */


    if (GNLControle.Voulu.BVarZBP == VRAI)
      {
	splusmatd(fic, &(ResStat->BVarZBP), debut, "B.varZ.B",
		 labelnull,  labelnull);
      } /* fin  if (GNLControle.Voulu.BVarZBP == VRAI) */



    if (GNLControle.Voulu.EquN == VRAI)
      {
	splusmatd(fic, &(ResStat->EquN.ValB), debut, "B",
		 labelnull,  labelnull);
	splusmatd(fic, &(ResStat->EquN.ValD), debut, "D",
		 labelnull,  labelnull);
	splusvectd(fic, &(ResStat->EquN.ValEta), debut, "Eta");
      } /* fin  if (GNLControle.Voulu.EquN == VRAI) */


    if (GNLControle.Voulu.FctSensib == VRAI) 
      {
	if (ResStat->FctSensib.DValf.nblig >0) {
	splusmatd(fic, &(ResStat->FctSensib.DValf), debut, "d.resp",
		 labelnull,  labelnull);
	fprintf(fic, "dimnames(%sd.resp) <- list(c(", debut);
	splusstr(fic, &(Donnees.NomObs));
	fprintf(fic, ") ,c(");
	splusstr(fic, &(Modele.NomTheta));
        fprintf(fic, "))\n");
	}
	if (iszeromatd( &(ResStat->FctSensib.DVarYTheta)) != VRAI)
	  {
	splusmatd(fic, &(ResStat->FctSensib.DVarYTheta), debut, "d.theta.vari",
		 labelnull,  labelnull);
	fprintf(fic, "dimnames(%sd.theta.vari) <- list(c(", debut);
	splusstr(fic, &(Donnees.NomObs));
	fprintf(fic, ") ,c(");
	splusstr(fic, &(Modele.NomTheta));
        fprintf(fic, "))\n");
	  } /* fin if (iszeromatd( &(ResStat->FctSensib.DVarYTheta)) != VRAI) */


	if (iszeromatd( &(ResStat->FctSensib.DVarYBeta)) != VRAI)
	  {
	splusmatd(fic, &(ResStat->FctSensib.DVarYBeta), debut, "d.beta.vari",
		 labelnull,  labelnull);
	fprintf(fic, "dimnames(%sd.beta.vari) <- list(c(", debut);
	splusstr(fic, &(Donnees.NomObs));
	fprintf(fic, ") ,c(");
	splusstr(fic, &(Modele.NomBeta));
        fprintf(fic, "))\n");
	  } /* fin if (iszeromatd( &(ResStat->FctSensib.DVarYBeta)) != VRAI) */

      } /* fin if (GNLControle.Voulu.FctSensib == VRAI) */



    if (GNLControle.Voulu.Mu == VRAI)
      {
	if (iszerovectd( &(ResStat->Mu3)) != VRAI)
	  {
	    splusvectd(fic, &(ResStat->Mu3), debut, "mu3");
	    splusvectstr(fic, &(Donnees.NomObs),  label, "mu3)");
	  }
	if (iszerovectd( &(ResStat->Mu4))!= VRAI)
	  {
	    splusvectd(fic, &(ResStat->Mu4), debut, "mu4");
	    splusvectstr(fic, &(Donnees.NomObs),  label, "mu4)");
	  }
      } /* fin  if (GNLControle.Voulu.Mu == VRAI) */


    if (GNLControle.Voulu.Residus == VRAI)
      {
	if (iszerovectd( &(ResStat->Residus)) != VRAI)
	  {
	    splusvectd(fic, &(ResStat->Residus), debut, "residuals");
	  }
	if (iszerovectd( &(ResStat->ResidusR))!= VRAI)
	  {
	    splusvectd(fic, &(ResStat->ResidusR), debut, "s.residuals");
	  }
      } /* fin  if (GNLControle.Voulu.Residus == VRAI) */

    if (GNLControle.Voulu.ValW == VRAI)
      {
	splusmatd(fic, &(ResStat->ValW), debut, "W",
		 labelnull,  labelnull);
      }

    if (GNLControle.Voulu.Z == VRAI)
      {
	    splusvectd(fic, &(ResStat->ValZ), debut, "Z");
      }

return(OK);
}
/* ................... fin resstatsplus ........................*/

/* -------------------------------------------------------
Ecriture de ce qui concerne les resultats divers
----------------------------------------------------------*/
int 
divsplus( FILE *fic, char *debut,
	       TCtxNum *CtxNum)

/* ............... Arguments d'entree      ....................... */
/* nom : le nom de la structure Splus a creer */
     /* fic: le  fichier de sortie */
     /* ............... Retour ....................................... */
     /* 0 ou un code d'erreur */
{

/* ------------------ debut du corps ------------------------------ */

    fprintf(fic, " %snh <- %d\n",debut, CtxNum->NbZ);
    fprintf(fic, " %smethod <- '%s'\n",debut, 
	    recup1C("method",1));
   
    fprintf(fic, " %seffic <- ",debut);
    if ( CtxNum->Effic == 1)
      fprintf(fic, "T\n");
    else
      fprintf(fic, "F\n");
      
    fprintf(fic, " %sW.type <- '%s'\n",debut, 
	    recup1C("w.type",1));
    fprintf(fic, " %sstat.crit.type <- '%s'\n",debut, 
	    recup1C("stat.crit.type",1));
    fprintf(fic, " %sstat.crit.code <- '%s'\n",debut, 
	    recup1C("stat.crit.code",1));


return(OK);
}
/* ................... fin divsplus ........................*/



/* -------------------------------------------------------
Ecriture de ce qui concerne les Donnees
----------------------------------------------------------*/
int 
donneessplus(char *nom, FILE *fic, TDonnees *Donnees)

/* ............... Arguments d'entree      ....................... */
/* nom : le nom de la structure Splus a creer */
     /* fic: le  fichier de sortie */
     /* ............... Retour ....................................... */
     /* 0 ou un code d'erreur */
{
int i;
char debut[50];
char cible[100], fin[10], cible2[100];

/* ------------------ debut du corps ------------------------------ */

 fprintf(fic,"%s$data.stat <- list()\n",nom);
sprintf(debut, "%s$data.stat$", nom);

splusvectd(fic, &(Donnees->StatDon.Y1), debut, "Y1");
splusvectd(fic, &(Donnees->StatDon.Y2), debut, "Y2");
splusvectd(fic, &(Donnees->StatDon.S2), debut, "S2");

fprintf(fic,"%s$replications <- c(%ld", nom, Donnees->NbRepet.donnees[0]);
for (i=1; i < Donnees->NbRepet.nbele; i++)
  fprintf(fic," ,%ld", Donnees->NbRepet.donnees[i]);

fprintf(fic,  ")\n");

 if (Donnees->IndiceN >0) {
   fprintf(fic,"%s$nb.N  <- %ld\n", nom, Donnees->IndiceN);
   fprintf(fic,"%s$N.name <- '%s'\n", nom, 
	   recup1C("N.name",1));
 }
   
return(OK);
} 
/* ........ fin donneessplus ............................... */


/* -------------------------------------------------------
Ecriture de ce qui concerne le GNLCtxInteg
----------------------------------------------------------*/
int 
ctxintegsplus(char *nom, FILE *fic, TDonnees *Donnees)

/* ............... Arguments d'entree      ....................... */
/* nom : le nom de la structure Splus a creer */
     /* fic: le  fichier de sortie */
     /* ............... Retour ....................................... */
     /* 0 ou un code d'erreur */
{
char debut[50];

int i,j;

/* ------------------ debut du corps ------------------------------ */

fprintf(fic,"%s$integ.ctx <- list(\n",nom);
fprintf(fic,"  nb.theta.odes=%d)\n", GNLCtxInteg.NbThetaSedo);

sprintf(debut, "%s$integ.ctx$", nom);
splusvectd(fic, &(GNLCtxInteg.T0T), debut, "start");

if (GNLCtxInteg.IndicCi == 0)
  {
    fprintf(fic,  " %scond.start <- c(", debut);
    for ( i = 0; i < Donnees->NbCourbe ; i++ )
    {
    for ( j=0; j < GNLCtxInteg.NbEq ; j++)
      {
	if ((i!=0) || (j!=0))
	  fprintf(fic,  ",");
	fprintf(fic,  " %.*g", precision, GNLCtxInteg.VectCi[i].donnees[j]);
      }
    }
    fprintf(fic,  ")\n");
  } /* fin if (GNLCtxInteg.IndicCi != 0) */



fprintf(fic,  "  %sprint <- %d\n", debut, GNLCtxInteg.ImpInteg );
fprintf(fic,  "  %sitol <- %d\n", debut, GNLCtxInteg.itol );
splusvectd(fic, &(GNLCtxInteg.atol), debut, "atol");
splusvectd(fic, &(GNLCtxInteg.rtol), debut, "rtol");
fprintf(fic,  " %siopt <- c(%d", debut,  GNLCtxInteg.proiwork[0]);
for (i=1; i<9; i++)
  fprintf(fic,  ", %d", GNLCtxInteg.proiwork[i]);
fprintf(fic,  ")\n");

fprintf(fic,  " %sropt <- c(%.*g", debut, precision,  GNLCtxInteg.prorwork[0]);
for (i=1; i<7; i++)
  fprintf(fic,  ", %.*g", precision, GNLCtxInteg.prorwork[i]);
fprintf(fic,  ")\n");

fprintf(fic,  " %sPImpInteg <- %d\n", debut, GNLCtxInteg.ImpInteg);
fprintf(fic,  " %sPjt <- %d\n", debut, GNLCtxInteg.jt);

return(OK);

} 
/* ............. fin de ctxintegsplus ......................*/

/* -------------------------------------------------------
Ecriture de ce qui concerne le CtxPuss
----------------------------------------------------------*/
int 
ctxpusssplus(char *nom, FILE *fic, TCtxPuss *CtxPuss)

/* ............... Arguments d'entree      ....................... */
/* nom : le nom de la structure Splus a creer */
     /* fic: le  fichier de sortie */
     /* ............... Retour ....................................... */
     /* 0 ou un code d'erreur */
{
/* Pour les messages d'erreur */
char message[MAXLGMESS];
/* ------------------ debut du corps ------------------------------ */

fprintf(fic,"%s$stat.ctx <- list(\n",nom);
  fprintf(fic," algorithm='%s'\n", recup1C("algo",1));
  fprintf(fic,", mu.type='%s'\n", recup1C("mu.type",1));
  fprintf(fic,", sigma2.type='%s'\n", recup1C("sigma2.type",1));
fprintf(fic,", omega.c1=");
if (CtxPuss->DirecC == DBL_MAX)
  fprintf(fic," NaN");
else
  fprintf(fic," %.*g\n", precision, CtxPuss->DirecC);

fprintf(fic,", lambda.start=");
if (CtxPuss->Lambda0 == DBL_MAX)
  fprintf(fic," NaN");
else
  fprintf(fic," %.*g\n",precision, CtxPuss->Lambda0);


fprintf(fic,", lambda.c1=");
if (CtxPuss->LambdaC1 == DBL_MAX)
  fprintf(fic," NaN");
else
  fprintf(fic," %.*g\n",precision, CtxPuss->LambdaC1);
fprintf(fic,", lambda.c2=");
if (CtxPuss->LambdaC2 == DBL_MAX)
  fprintf(fic," NaN");
else
	fprintf(fic," %.*g\n",precision, CtxPuss->LambdaC2);

fprintf(fic,", max.stop.crit=");
if (CtxPuss->MaxCritArret == DBL_MAX)
  fprintf(fic," NaN");
else
  fprintf(fic," %.*g\n",precision, CtxPuss->MaxCritArret);

fprintf(fic,", max.err.c2=%ld\n",CtxPuss->MaxDeb);
fprintf(fic,", max.err.c1=%ld\n",CtxPuss->MaxErr);
fprintf(fic,", max.iters=%ld\n",CtxPuss->MaxIter);
fprintf(fic,", max.lambda=");
if (CtxPuss->MaxLambda == DBL_MAX)
  fprintf(fic," NaN");
else
  fprintf(fic," %.*g\n",precision, CtxPuss->MaxLambda);

fprintf(fic,", omega.c2=");
if (CtxPuss->OmegaPas == DBL_MAX)
  fprintf(fic," NaN");
else
  fprintf(fic," %.*g\n",precision, CtxPuss->OmegaPas);

 fprintf(fic,", family= '%s'\n",
	 recup1C("family",1));
fprintf(fic,")\n"); /* on ferme la liste  */

return(OK);
}
/* ................... fin ctxpusssplus ........................*/

/* -------------------------------------------------------
Ecriture de ce qui concerne le modele 
----------------------------------------------------------*/

int 
modelesplus(char *nom, FILE *fic, TModele *Modele)

/* ............... Arguments d'entree      ....................... */
/* nom : le nom de la structure Splus a creer */
     /* fic: le  fichier de sortie */
     /* ............... Retour ....................................... */
     /* 0 ou un code d'erreur */
{
char debut[100];
char message[100];
 int i,trouve;

/* ------------------ debut du corps ------------------------------ */

fprintf(fic,"%s$model <- list(file='%s'\n",nom, Modele->NomFichier);
 fprintf(fic," , vari.type='%s')\n", recup1C("vari.type",1));
sprintf(debut, "%s$model$", nom);
splusvectd(fic, &(Modele->GamF), debut, "gamf");
splusvectd(fic, &(Modele->GamV), debut, "gamv");

if (Modele->CTheta0.Ctr== VRAI)
  {
	splusvectd(fic,&(Modele->CTheta0.EgalN), debut, "eq.theta");
	/* N'ecrire les eqp que si elles sont effectives, i.e
	   pas une squence de 1  nb de parametres */
	trouve=0;
	for (i=0; i<Modele->CTheta0.EgalP.nbele; i++) {
	  if (Modele->CTheta0.EgalP.donnees[i] != i) {
	    break;
	    trouve=1;
	  }
	}
	if (trouve==1) 
	  splusvectshort(fic,&(Modele->CTheta0.EgalP),  debut,"eqp.theta");
	splusvectd(fic,&(Modele->CTheta0.BInf), debut, "inf.theta");
	splusvectd(fic,&(Modele->CTheta0.BSup), debut, "sup.theta");
  }
if (Modele->CBeta0.Ctr== VRAI)
  {
	splusvectd(fic,&(Modele->CBeta0.EgalN), debut, "eq.beta");
	/* N'ecrire les eqp que si elles sont effectives, i.e
	   pas une squence de 1  nb de parametres */
	trouve=0;
	for (i=0; i<Modele->CBeta0.EgalP.nbele; i++) {
	  if (Modele->CBeta0.EgalP.donnees[i] != i) {
	    break;
	    trouve=1;
	  }
	}
	if (trouve==1) 
	  splusvectshort(fic,&(Modele->CBeta0.EgalP),  debut,"eqp.beta");
	splusvectd(fic,&(Modele->CBeta0.BInf),  debut,"inf.beta");
	splusvectd(fic,&(Modele->CBeta0.BSup), debut, "sup.beta");
  }

   fprintf(fic," %s$is.odes <- %d\n", nom, Modele->CasSedo);

 /* rajout des names */
sprintf(debut, "names(%s$model$", nom);
if (Modele->NomGamF.nbele >0)
  {
    splusvectstr(fic, &(Modele->NomGamF), debut, "gamf)");
  } /* fin (Modele->NomGamF.nbele >0) */


if (Modele->NomGamV.nbele >0)
  {
    splusvectstr(fic, &(Modele->NomGamF), debut, "gamv)");
  } /* fin (Modele->NomGamV.nbele >0) */

   

return(OK);
}
/* ........... fin modelesplus .......................*/

/* -------------------------------------------------------
Ecriture de ce qui concerne le sedo
----------------------------------------------------------*/
int 
sedosplus( FILE *fic, char *debut,
	       TResStat *ResStat)


{
int i, j, k, lgdsedo, nbparam ;
TVectStr NomLesF, NomLesDF, NomValInt ;

/* ------------------ debut du corps ------------------------------ */

APPEL(CreerVectStr(GNLCtxInteg.NbEq, &NomLesF));
APPEL(CreerVectStr(GNLCtxInteg.NbEq, &NomLesDF));
APPEL(CreerVectStr(GNLCtxInteg.NbJ, &NomValInt));

if ( spluslabsedo(&NomLesF,&NomLesDF, &NomValInt ) != OK)
  {
    return(ERRINT);
  }
 
 /* FOdes */
fprintf(fic,"%sFOdes <-  array(c(", debut);
for (i=0; i < Donnees.NbObs ; i++)
  {
    for (j=0; j<GNLCtxInteg.NbJ; j++)
      {
	for (k=0; k < GNLCtxInteg.NbEq ; k++)
	  {
	    if ((i>0) || (j>0) || (k >0))
	      fprintf(fic,",");
	    if (ResStat->Sedo.FSedo[i][j][k] == DBL_MAX)
	      fprintf(fic," NaN");
	    else
	      fprintf(fic," %.*g",precision,ResStat->Sedo.FSedo[i][j][k]);
	  }
      }
  }

    fprintf(fic,"),\n dim=c(%d, %d, %ld)) \n",GNLCtxInteg.NbEq,
GNLCtxInteg.NbJ,   Donnees.NbObs);
    fprintf(fic, "%sFOdes <- aperm(%sFOdes,  c(3,2,1))\n", debut, debut);


/* Les labels */
	fprintf(fic, "dimnames(%sFOdes) <- list(c(", debut);
	splusstr(fic, &(Donnees.NomObs));
	fprintf(fic, "), c(");
	splusstr(fic, &(NomValInt));
	fprintf(fic, "), c(");
	splusstr(fic, &(NomLesF));
	fprintf(fic, "))\n");


    /* d.FOdes */
lgdsedo= GNLCtxInteg.LongSys -  GNLCtxInteg.NbEq;

fprintf(fic,"%sd.FOdes <-  array(c(", debut);
for (i=0; i <Donnees.NbObs ; i++)
  {
    for (j=0; j<GNLCtxInteg.NbJ; j++)
      {
	for (k=0; k < lgdsedo ; k++)
	  {
	    if ((i>0) || (j>0) || (k >0))
	      fprintf(fic,",");
	    if (ResStat->Sedo.DFSedo[i][j][k] == DBL_MAX)
	      fprintf(fic," NaN");
	    else
	      fprintf(fic," %.*g",precision,ResStat->Sedo.DFSedo[i][j][k]);
	  }
      }
  }

    fprintf(fic,"),\n dim=c(%d, %d, %ld)) \n", lgdsedo ,
GNLCtxInteg.NbJ,   Donnees.NbObs);
    fprintf(fic, "%sd.FOdes <- aperm(%sd.FOdes,  c(3,2,1))\n", debut, debut);

/* Les labels */
	fprintf(fic, "dimnames(%sd.FOdes) <- list(c(", debut);
	splusstr(fic, &(Donnees.NomObs));
	fprintf(fic, "), c(");
	splusstr(fic, &(NomValInt));
	fprintf(fic, "), c(");
	nbparam = lgdsedo / GNLCtxInteg.NbEq;

	for (i=0; i < GNLCtxInteg.NbEq; i++)
	  {
	    for (j=0; j < nbparam; j++)
	      {
		if ((i > 0) || (j > 0))
		  fprintf(fic, ", ");
	fprintf(fic, "'%s/%s'", NomLesDF.donnees[i], 
			  Modele.NomTheta.donnees[j]);
	      }
	  }
	fprintf(fic, "))\n");

return(OK);
}
/* ........... fin sedosplus .......................*/
/* --------------------------------------------------
Lire sur le fichier du modele NomLesF, LesDF
pour labeller le sedo
------------------------------------------------------- */
int 
spluslabsedo( TVectStr *NomLesF, TVectStr *NomLesDF,
		 TVectStr *NomValInt)
{
FILE *fic;
/* Pour les messages d'erreur */
char message[MAXLGMESS];

char motlu[MAXMOT];
TLogic luF=FAUX, luDF=FAUX, luvalint=FAUX;

if ( (fic= fopen(Modele.NomFichier,"r")) == NULL)
  {
    sprintf(message,
"Error when opening the model description file %s \n", Modele.NomFichier);
    ecrErr(stderr,"spluslabsedo",message,  ERRINT);
	return((int)ERRINT);
  }



while(  fscanf(fic,"%s", motlu) != EOF)
  {

    if (strncmp(motlu,"F", 1)==0)
      {
	luF=VRAI;

	if (MONmots(fic, GNLCtxInteg.NbEq,  NomLesF) != OK)
	  {
	    sprintf(message,
"Error when reading 'F' on the model description file %s \n", Modele.NomFichier);
	    ecrErr(stderr,"spluslabsedo",message,  ERRINT);
	    return((int)ERRINT);
	  }
     continue;
 
      } /* fin if (strncmp(motlu,"F", 1)==0) */


    if (strncmp(motlu,"dF", 2)==0)
      {
	luDF=VRAI;

	if (MONmots(fic, GNLCtxInteg.NbEq,  NomLesDF) != OK)
	  {
	    sprintf(message,
"Error when reading 'dF' on the model description file %s \n", Modele.NomFichier);
	    ecrErr(stderr,"spluslabsedo",message,  ERRINT);
	    return((int)ERRINT);
	  }
     continue;
 
      } /* fin if (strncmp(motlu,"F", 1)==0) */


    if (strncmp(motlu,"valint", 6)==0)
      {
	luvalint=VRAI;

	if (MONmots(fic, GNLCtxInteg.NbJ,  NomValInt) != OK)
	  {
	    sprintf(message,
"Error when reading 'valint' on the model description file %s \n", Modele.NomFichier);
	    ecrErr(stderr,"spluslabsedo",message,  ERRINT);
	    return((int)ERRINT);
	  }
     continue;
 
      } /* fin if (strncmp(motlu,"F", 1)==0) */


  } /* fin while(  fscanf(fic,"%s", motlu) != EOF) */

if ((luF==FAUX) || (luDF==FAUX) || (luvalint==FAUX))
  {
sprintf(message,
"The F, dF or valint declarations not found on the model description file %s \n", Modele.NomFichier);
ecrErr(stderr,"spluslabsedo",message,  ERRINT);
return((int)ERRINT);
  }
return(OK);
}
/* ........... fin spluslabsedo .......................*/

/* --------------------------------------------------
Ecriture d'un vecteur double 
------------------------------------------------------- */
void 
splusvectd(FILE *fic, TVect *vect, char *debut, char *nom)

{
int i;

if (vect->nbele >0)
  {
    fprintf(fic,"%s%s <-  c(", debut, nom);
    for (i=0; i < vect->nbele; i++)
      {
	if (i>0)
	  fprintf(fic,",");
	if (vect->donnees[i] == DBL_MAX)
	  fprintf(fic," NaN");
	else
	  fprintf(fic," %.*g",precision, vect->donnees[i]);
      }
    fprintf(fic,")\n");
  } /* fin if (vect->nbele >0) */
}
/* ............. fin  splusvectd .............................*/


/* --------------------------------------------------
Ecriture d'un vecteur short
------------------------------------------------------- */
void splusvectshort(FILE *fic, TVectShort *vect,  char *debut,char *nom)

{
int i;

if (vect->nbele >0)
  {
    fprintf(fic,"%s%s <-  c(", debut, nom);
    for (i=0; i < vect->nbele; i++)
      {
	if (i>0)
	  fprintf(fic,", %d",vect->donnees[i]);
	else
	  fprintf(fic," %d",vect->donnees[i]);
      }
    fprintf(fic,")\n");
  } /* fin if (vect->nbele >0) */
}
/* ............. fin  splusvectshort .............................*/



/* --------------------------------------------------
Ecriture d'un vecteur char  de names
------------------------------------------------------- */
void splusvectstr(FILE *fic, TVectStr *vect,  char *debut, char *nom)

{
int i;

if (vect->nbele >0)
  {
    fprintf(fic,"%s%s <-  c(", debut, nom);
    for (i=0; i < vect->nbele; i++)
      {
	if (i>0)
	  fprintf(fic," ,'%s'",vect->donnees[i]);
	else
	  fprintf(fic," '%s'",vect->donnees[i]);
      }
    fprintf(fic,")\n");
  } /* fin if (vect->nbele >0) */
}
/* ............. fin  splusvectstr .............................*/


/* --------------------------------------------------
Ecriture d'une matrice double 
------------------------------------------------------- */
void 
splusmatd(FILE *fic, TMat *mat, char *debut, char *nom,
	       char *lablig, char *labcol)

{
int i,j;

if (mat->nblig >0)
  {
    fprintf(fic,"%s%s <-  matrix(c(", debut, nom);
    for (i=0; i < mat->nblig; i++)
      {
	for (j=0; j < mat->nbcol; j++)
	  {
	    if ( (i>0) || (j>0))
	      fprintf(fic,",");
	    if (mat->donnees[i][j] == DBL_MAX)
	      fprintf(fic," NaN");
	    else
	      fprintf(fic," %.*g", precision, mat->donnees[i][j]);
	  }
      }
    fprintf(fic,"), ncol= %d, byrow=TRUE, dimnames= list(%s, %s))\n", 
	    mat->nbcol, lablig, labcol );
  } /* fin if (mat->nbele >0) */
}
/* ............. fin  splusmatd .............................*/


/* --------------------------------------------------
Ecriture d'un vecteur char  de names: uniquement les valeurs
sans symbole d'affectation ni parenthse
------------------------------------------------------- */
void 
splusstr(FILE *fic, TVectStr *vect)

{
int i;

if (vect->nbele >0)
  {
    for (i=0; i < vect->nbele; i++)
      {
	if (i>0)
	  fprintf(fic," ,'%s'",vect->donnees[i]);
	else
	  fprintf(fic," '%s'",vect->donnees[i]);
      }
  } /* fin if (vect->nbele >0) */
}
/* ............. fin  splusstr .............................*/


/* --------------------------------------------------
Renvoyer VRAI si une matrice double ne contient que des zeros
------------------------------------------------------- */
TLogic iszeromatd(TMat *mat)

{
int i,j;

if (mat->nblig >0)
  {
    for (i=0; i < mat->nblig; i++)
      {
	for (j=0; j < mat->nbcol; j++)
	  {
	    if (mat->donnees[i][j] != (TDouble)0)
	      return(FAUX);
	  }
      }
  }
return(VRAI);
}

/* ............. fin  iszeromatd .............................*/


/* --------------------------------------------------
Renvoyer VRAI si une vecteur double ne contient que des zeros
------------------------------------------------------- */
TLogic iszerovectd(TVect *vect)

{
int i;


    for (i=0; i < vect->nbele; i++)
	  {
	    if (vect->donnees[i] != (TDouble)0)
	      return(FAUX);
	  }

return(VRAI);
}

/* ............. fin  iszerovectd .............................*/


/*--------------- Identification fonction ----------
| Nom de la fonction    : monmots
| Role                  : renvoyer les elements d'une |
|  liste du fichier de description du modele      |
| Parametres d'entree   :                          |
| Parametres de sortie  :                          |
--------------------------------------------------*/

/*--------------- Appels croises -------------------
| Fonctions appelees   :                           |
| Fonctions appelantes :                           |
|  la fonction C: spluslabsedo
--------------------------------------------------*/


/*--------------- Definition fonction ------------*/

/*--------------- Fin identification fonction ----*/

int 
MONmots(FILE *fic, TShortInt Nb, TVectStr *Noms)

     /* arguments d'entree : FILE *fic, long Nb */
     /* arguments de sortie : TVectStr *Noms, int *Code */

/*--------------- Fin identification fonction ----*/

{

char chaine[MAXLIG], chlu[MAXLIG];
int i;

strcpy(chaine,"");
do
  {
  if( fscanf(fic,"%s",chlu) == EOF)
    {
    fprintf(stderr,
"\n Error: a key-word not followed by at least one value \n");
    return(ERR);
    }
  strcat(chaine,chlu);
  }  while(strstr(chlu,";")==NULL);

/* dans chaine, les blancs sont otes de la liste */
strcpy(Noms->donnees[0], strtok(chaine,",;"));

for (i=1; i<Nb; i++)
  {
  strcpy(chlu, strtok(NULL, ",;"));
  strcpy(Noms->donnees[i], chlu);
  }
return(OK);
}

/* ------------- fin MONmots ----------------------------- */


/* -------------------------------------------------------
Ecriture de ce qui concerne les resultats par iter
----------------------------------------------------------*/
int 
itsplus( FILE *fic, char *debut, int ietap)

{
char message[MAXLGMESS];
int courbe, acttot, param, iter, obs;
int ik, ij, ieq;

    fprintf(fic, " %siters.sv <- list(nb.iters.sv= %d)\n", debut, NbItSv[ietap]);
    fprintf(fic, " %siters.sv$iter <- c(", debut);
    for (iter=0; iter<NbItSv[ietap]; iter++)
      {
	if (iter >0)
	  fprintf(fic, ",");
      fprintf(fic, "%ld ", ItNum[ietap][iter].NbIter);
      }
    fprintf(fic, ")\n");


    if (GNLControle.VouluIt.Estim==VRAI)
      {  
	/* Theta : matrice nbitsv, multtheta */
	fprintf(fic, " %siters.sv$theta <- matrix(c(", debut);
	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    for (param=0; param < ItTheta[ietap][iter].nbele; param++)
	      {
		if ( (param > 0) || (iter >0))
		  fprintf(fic, ", ");
		if (ItTheta[ietap][iter].donnees[param] ==  DBL_MAX)
		  fprintf(fic, "NAN ");
		else
		  fprintf(fic, "%.*g ",  precision, 
		      ItTheta[ietap][iter].donnees[param]);
	      }
	  } /* fin for (iter=0; */
	
	fprintf(fic, "), nrow=%d, byrow=TRUE)\n", NbItSv[ietap]);
	fprintf(fic, "dimnames(%siters.sv$theta) <- list(c(", debut);
	itlabsplus(fic,  ietap);
	fprintf(fic, ", \n    c(\n");
	if (Donnees.NbCourbe > 1)
	  {
	    for (param=0; param < Modele.NomTheta.nbele; param++)
	      {
		for (courbe=0; courbe < Donnees.NbCourbe; courbe++)
		  {
		    if ((param>0) || (courbe>0))
		      fprintf(fic, ",");
		    fprintf(fic, " '%s_", Modele.NomTheta.donnees[param]);
		    if (courbe==0)
		      fprintf(fic, "%s", Donnees.NomC.donnees[0]);
		    else
		      fprintf(fic, "%s", 
			      Donnees.NomC.donnees[Donnees.NbObsC.donnees[courbe-1]]);
		    fprintf(fic, "' ");
		  }
	      }
	  } /* fin if (Donnees.NbCourbe > 1) */
	else
	  {
	   for (param=0; param < Modele.NomTheta.nbele; param++)
	      {
		if (param>0)
		  fprintf(fic, ",");
		fprintf(fic, " '%s'", 
			    Modele.NomTheta.donnees[param]);
	      }
	  } /* fin eslse */
	
	fprintf(fic, "))\n");

	if (Modele.NomBeta.nbele >0)
	  {
	/* Beta : matrice nbitsv, multbeta */
	fprintf(fic, " %siters.sv$beta <- matrix(c(", debut);
	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    for (param=0; param < ItBeta[ietap][iter].nbele; param++)
	      {
		if (( param>0) || (iter >0))
		  fprintf(fic, ", ");
		if (ItBeta[ietap][iter].donnees[param] ==  DBL_MAX)
		  fprintf(fic, "NAN ");
		else
		  fprintf(fic, "%.*g ",  precision, 
		      ItBeta[ietap][iter].donnees[param]);
	      }
	  } /* fin for (iter=0; */
	
	fprintf(fic, "), nrow=%d, byrow=TRUE)\n", NbItSv[ietap]);
	fprintf(fic, "dimnames(%siters.sv$beta) <- list(c(", debut);
	itlabsplus(fic,  ietap);
	fprintf(fic, ", \n    c(\n");
	if (Donnees.NbCourbe > 1)
	  {
	    for (param=0; param < Modele.NomBeta.nbele; param++)
	      {
		for (courbe=0; courbe < Donnees.NbCourbe; courbe++)
		  {
		    if ((param>0) || (courbe>0))
		      fprintf(fic, ",");
		    fprintf(fic, " '%s_", Modele.NomBeta.donnees[param]);
		    if (courbe==0)
		      fprintf(fic, "%s", Donnees.NomC.donnees[0]);
		    else
		      fprintf(fic, "%s", 
			      Donnees.NomC.donnees[Donnees.NbObsC.donnees[courbe-1]]);
		    fprintf(fic, "' ");
		  }
	      }
	  } /* fin if (Donnees.NbCourbe > 1) */
	else
	  {
	   for (param=0; param < Modele.NomBeta.nbele; param++)
	      {
		if (param>0)
		  fprintf(fic, ",");
		fprintf(fic, " '%s'", 
			    Modele.NomBeta.donnees[param]);
	      }
	  } /* fin eslse */
	
	fprintf(fic, "))\n");
	  } /* fin Beta */

      } /* fin if (GNLControle.VouluIt.Estim==VRAI) */

    if (GNLControle.VouluIt.Ajustes==VRAI)
      {  
	/* response : matrice nbitsv, nbobs */
	fprintf(fic, " %siters.sv$response <- matrix(c(", debut);
	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    for (obs=0; obs < ItStat[ietap][iter].Ajustes.Valf.nbele; obs++)
	      {
		if ((iter >0) || (obs > 0))
		  fprintf(fic, ", ");
		if (ItStat[ietap][iter].Ajustes.Valf.donnees[obs] ==  DBL_MAX)
		  fprintf(fic, "NAN ");
		else
		  fprintf(fic, "%.*g ",  precision, 
			ItStat[ietap][iter].Ajustes.Valf.donnees[obs]);  
	      }
	  } /* fin for (iter=0; */
	
	fprintf(fic, "), nrow=%d, byrow=TRUE)\n", NbItSv[ietap]);
	fprintf(fic, "dimnames(%siters.sv$response) <- list(c(", debut);
	itlabsplus(fic,  ietap);
	fprintf(fic, ", \n    c(\n");
	splusstr(fic, &(Donnees.NomObs));
	fprintf(fic, "))\n");


	/* variance : matrice nbitsv, nbobs */
	if (ItStat[ietap][0].Ajustes.VarY.nbele >0)
	  {

	fprintf(fic, " %siters.sv$variance <- matrix(c(", debut);
	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    for (obs=0; obs < ItStat[ietap][iter].Ajustes.VarY.nbele; obs++)
	      {
		if ((iter >0) || (obs >0))
		  fprintf(fic, ",");
		if (ItStat[ietap][iter].Ajustes.VarY.donnees[obs] ==  DBL_MAX)
		  fprintf(fic, "NAN ");
		else
		  fprintf(fic, "%.*g ",  precision, 
			ItStat[ietap][iter].Ajustes.VarY.donnees[obs]);  
	      }
	  } /* fin for (iter=0; */
	
	fprintf(fic, "), nrow=%d, byrow=TRUE)\n", NbItSv[ietap]);
	fprintf(fic, "dimnames(%siters.sv$variance) <- list(c(", debut);
	itlabsplus(fic,  ietap);
	fprintf(fic, ", \n    c(\n");
	splusstr(fic, &(Donnees.NomObs));
	fprintf(fic, "))\n");
	  } /* fin if (ItStat[ietap][0].Ajustes.VarY.nbele >0) */

      } /* fin if (GNLControle.VouluIt.Ajustes==VRAI) */

    if (GNLControle.VouluIt.FctSensib == VRAI)
      {
	/* d.resp : tableau nbitsv, nbobs, pbase, qu'on lit a l'envers */
	fprintf(fic, " %siters.sv$d.resp <- array(c(", debut);
	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    for (obs=0; obs < ItStat[ietap][iter].FctSensib.DValf.nblig; obs++)
	      {
		for (param=0; param < ItStat[ietap][iter].FctSensib.DValf.nbcol; param++)
		  {
		    if ((iter>0) || (obs >0) || (param >0))
		      fprintf(fic, ", ");
		    if (ItStat[ietap][iter].FctSensib.DValf.donnees[obs][param] ==  DBL_MAX)
		      fprintf(fic, "NAN ");
		    else
		      fprintf(fic, "%.*g ",  precision, 
			ItStat[ietap][iter].FctSensib.DValf.donnees[obs][param]);  
		  } /* fin param */
	      } /*fin obs */
	  } /* fin for (iter=0; */
	
	fprintf(fic, ")\n, dim=c(%d, %ld, %d))\n",
		Modele.NomTheta.nbele,
		Donnees.NbObs,
		NbItSv[ietap]);
	fprintf(fic, "dimnames(%siters.sv$d.resp) <- list(c(", debut);
	splusstr(fic, &(Modele.NomTheta));
	fprintf(fic, "), \n    c(\n");
	splusstr(fic, &(Donnees.NomObs));
	fprintf(fic, "), \n    c(\n");
	itlabsplus(fic,  ietap);
	fprintf(fic, ")\n");
	fprintf(fic, 
"%siters.sv$d.resp <- aperm(%siters.sv$d.resp,  c(3,2,1))\n",
		debut, debut);

	/* d.theta.vari : tableau nbitsv, nbobs, pbase, qu'on lit a l'envers */

	if (ItStat[ietap][0].FctSensib.DVarYTheta.nblig>0)
	  {
	fprintf(fic, " %siters.sv$d.theta.vari <- array(c(", debut);
	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    for (obs=0; obs < ItStat[ietap][iter].FctSensib.DVarYTheta.nblig; obs++)
	      {
		for (param=0; param < ItStat[ietap][iter].FctSensib.DVarYTheta.nbcol; param++)
		  {
		    if ((iter>0) || (obs >0) || (param >0))
		      fprintf(fic, ", ");
		    if (ItStat[ietap][iter].FctSensib.DVarYTheta.donnees[obs][param] ==  DBL_MAX)
		      fprintf(fic, "NAN ");
		    else
		      fprintf(fic, "%.*g ",  precision, 
			ItStat[ietap][iter].FctSensib.DVarYTheta.donnees[obs][param]);  
		  } /* fin param */
	      } /*fin obs */
	  } /* fin for (iter=0; */
	
	fprintf(fic, ")\n, dim=c(%d, %ld, %d))\n",
		Modele.NomTheta.nbele,
		Donnees.NbObs,
		NbItSv[ietap]);
	fprintf(fic, "dimnames(%siters.sv$d.theta.vari) <- list(c(", debut);
	splusstr(fic, &(Modele.NomTheta));
	fprintf(fic, "), \n    c(\n");
	splusstr(fic, &(Donnees.NomObs));
	fprintf(fic, "), \n    c(\n");
	itlabsplus(fic,  ietap);
	fprintf(fic, ")\n");
	fprintf(fic, 
"%siters.sv$d.theta.vari <- aperm(%siters.sv$d.theta.vari,  c(3,2,1))\n",
		debut, debut);
	  } /* fin il y a des DVarYTheta */



	/* d.beta.vari : tableau nbitsv, nbobs, pbase, qu'on lit a l'envers */
	if (ItStat[ietap][0].FctSensib.DVarYBeta.nblig>0)
	  {
	fprintf(fic, " %siters.sv$d.beta.vari <- array(c(", debut);
	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    for (obs=0; obs < ItStat[ietap][iter].FctSensib.DVarYBeta.nblig; obs++)
	      {
		for (param=0; param < ItStat[ietap][iter].FctSensib.DVarYBeta.nbcol; param++)
		  {
		    if ((iter>0) || (obs >0) || (param >0))
		      fprintf(fic, ", ");
		    if (ItStat[ietap][iter].FctSensib.DVarYBeta.donnees[obs][param] ==  DBL_MAX)
		      fprintf(fic, "NAN ");
		    else
		      fprintf(fic, "%.*g ",  precision, 
			ItStat[ietap][iter].FctSensib.DVarYBeta.donnees[obs][param]);  
		  } /* fin param */
	      } /*fin obs */
	  } /* fin for (iter=0; */
	
	fprintf(fic, ")\n, dim=c(%d, %ld, %d))\n",
		Modele.NomBeta.nbele,
		Donnees.NbObs,
		NbItSv[ietap]);
	fprintf(fic, "dimnames(%siters.sv$d.beta.vari) <- list(c(", debut);
	splusstr(fic, &(Modele.NomBeta));
	fprintf(fic, "), \n    c(\n");
	splusstr(fic, &(Donnees.NomObs));
	fprintf(fic, "), \n    c(\n");
	itlabsplus(fic,  ietap);
	fprintf(fic, ")\n");
	fprintf(fic, 
"%siters.sv$d.beta.vari <- aperm(%siters.sv$d.beta.vari,  c(3,2,1))\n",
		debut, debut);
	  } /* fin il y a des DVarYBeta */

      } /* fin FctSensib */



    if (GNLControle.VouluIt.EquN == VRAI)
      {
	/* EquN.ValB: nbitsv, nh, acttot lu a l'envers */

	if (ItStat[ietap][0].EquN.ValB.nblig>0)
	  {
	fprintf(fic, " %siters.sv$B <- array(c(", debut);
	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    for (obs=0; obs < ItStat[ietap][iter].EquN.ValB.nblig; obs++)
	      {
		for (param=0; param < ItStat[ietap][iter].EquN.ValB.nbcol; param++)
		  {
		    if ((iter>0) || (obs >0) || (param >0))
		      fprintf(fic, ", ");
		    if (ItStat[ietap][iter].EquN.ValB.donnees[obs][param] ==  DBL_MAX)
		      fprintf(fic, "NAN ");
		    else
		      fprintf(fic, "%.*g ",  precision, 
			ItStat[ietap][iter].EquN.ValB.donnees[obs][param]);  
		  } /* fin param */
	      } /*fin obs */
	  } /* fin for (iter=0; */
	
	fprintf(fic, ")\n, dim=c(%d, %d, %d))\n",
		ItStat[ietap][0].EquN.ValB.nbcol,
		ItStat[ietap][0].EquN.ValB.nblig,
		NbItSv[ietap]);

	fprintf(fic, "dimnames(%siters.sv$B) <- list(NULL, NULL, c(", debut);
	itlabsplus(fic,  ietap);
	fprintf(fic, ")\n");
	fprintf(fic, 
"%siters.sv$B <- aperm(%siters.sv$B,  c(3,2,1))\n",
		debut, debut);
	  } /* fin il y a des ValB */

	/* EquN.ValD: nbitsv, nh, acttot lu a l'envers */

	if (ItStat[ietap][0].EquN.ValD.nblig>0)
	  {
	fprintf(fic, " %siters.sv$D <- array(c(", debut);
	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    for (obs=0; obs < ItStat[ietap][iter].EquN.ValD.nblig; obs++)
	      {
		for (param=0; param < ItStat[ietap][iter].EquN.ValD.nbcol; param++)
		  {
		    if ((iter>0) || (obs >0) || (param >0))
		      fprintf(fic, ", ");
		    if (ItStat[ietap][iter].EquN.ValD.donnees[obs][param] ==  DBL_MAX)
		      fprintf(fic, "NAN ");
		    else
		      fprintf(fic, "%.*g ",  precision, 
			ItStat[ietap][iter].EquN.ValD.donnees[obs][param]);  
		  } /* fin param */
	      } /*fin obs */
	  } /* fin for (iter=0; */
	
	fprintf(fic, ")\n, dim=c(%d, %d, %d))\n",
		ItStat[ietap][0].EquN.ValD.nbcol,
		ItStat[ietap][0].EquN.ValD.nblig,
		NbItSv[ietap]);

	fprintf(fic, "dimnames(%siters.sv$D) <- list(NULL, NULL, c(", debut);
	itlabsplus(fic,  ietap);
	fprintf(fic, ")\n");
	fprintf(fic, 
"%siters.sv$D <- aperm(%siters.sv$D,  c(3,2,1))\n",
		debut, debut);
	  } /* fin il y a des ValD */

	/* Eta : matrice nbitsv, xxx */
	if (ItStat[ietap][0].EquN.ValEta.nbele >0)
	  {

	fprintf(fic, " %siters.sv$Eta <- matrix(c(", debut);
	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    for (obs=0; obs < ItStat[ietap][iter].EquN.ValEta.nbele; obs++)
	      {
		if ((iter >0) || (obs >0))
		  fprintf(fic, ", ");
		if (ItStat[ietap][iter].EquN.ValEta.donnees[obs] ==  DBL_MAX)
		  fprintf(fic, "NAN ");
		else
		  fprintf(fic, "%.*g ",  precision, 
			ItStat[ietap][iter].EquN.ValEta.donnees[obs]);  
	      }
	  } /* fin for (iter=0; */
	
	fprintf(fic, "), nrow=%d, byrow=TRUE)\n", NbItSv[ietap]);
	fprintf(fic, "dimnames(%siters.sv$Eta) <- list(c(", debut);
	itlabsplus(fic,  ietap);
	fprintf(fic, ", NULL)\n");
	  } /* fin if (ItStat[ietap][0].EquN.ValEta.nbele >0) */


      } /* fin vouluIt.EquN */


    if (GNLControle.VouluIt.ResNum == VRAI)
      {
	/* stop.crit */
	fprintf(fic, " %siters.sv$stop.crit <- c(", debut);
	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    if (iter >0)
	      fprintf(fic, ", ");
	    if (ItNum[ietap][iter].CritArret == DBL_MAX)
	      fprintf(fic, "NaN ");
	    else
	      fprintf(fic, "%.*g ",  precision, ItNum[ietap][iter].CritArret);
	  }
	fprintf(fic, ")\nnames(%siters.sv$stop.crit) <- c(", debut);
	itlabsplus(fic,  ietap);

	/* stat.crit */
	fprintf(fic, " %siters.sv$stat.crit <- c(", debut);
	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    if (iter >0)
	      fprintf(fic, ", ");
	    if (ItNum[ietap][iter].CritStat == DBL_MAX)
	      fprintf(fic, "NaN ");
	    else
	      fprintf(fic, "%.*g ",  precision, ItNum[ietap][iter].CritStat);
	  }
	fprintf(fic, ")\nnames(%siters.sv$stat.crit) <- c(", debut);
	itlabsplus(fic,  ietap);


	/* sigma2 */
	fprintf(fic, " %siters.sv$sigma2 <- c(", debut);
	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    if (iter >0)
	      fprintf(fic, ", ");
	    if (ItNum[ietap][iter].Sigma == DBL_MAX)
	      fprintf(fic, "NaN ");
	    else
	      fprintf(fic, "%.*g ",  precision, ItNum[ietap][iter].Sigma);
	  }
	fprintf(fic, ")\nnames(%siters.sv$sigma2) <- c(", debut);
	itlabsplus(fic,  ietap);


	/* lambda */
	fprintf(fic, " %siters.sv$lambda <- c(", debut);
	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    if (iter >0)
	      fprintf(fic, ", ");
	    if (ItNum[ietap][iter].Lambda == DBL_MAX)
	      fprintf(fic, "NaN ");
	    else
	      fprintf(fic, "%.*g ",  precision, ItNum[ietap][iter].Lambda);
	  }
	fprintf(fic, ")\nnames(%siters.sv$lambda) <- c(", debut);
	itlabsplus(fic, ietap);



	/* omega */
	fprintf(fic, " %siters.sv$omega <- c(NaN", debut);
	/* Pas d'omega  la 1iere iteration */
	for (iter=1; iter<NbItSv[ietap]; iter++)
	  {
	    fprintf(fic, ", ");
	    if ( ItOmega[ietap][iter] == DBL_MAX)
	      fprintf(fic, "NaN ");
	    else
	      fprintf(fic, "%.*g ",  precision, ItOmega[ietap][iter]);
	  }
	fprintf(fic, ")\nnames(%siters.sv$omega) <- c(", debut);
	itlabsplus(fic,  ietap);



	/* direction : matrice nbitsv, acttot */
	acttot = Theta[ietap].Act.nbele + Beta[ietap].Act.nbele;
	fprintf(fic, " %siters.sv$direction <- matrix(c(NaN", debut);
	/* Pas d'direction  la 1iere iteration */
	for (param=1; param < acttot; param++)
	  fprintf(fic, ", NaN");
	
	for (iter=1; iter<NbItSv[ietap]; iter++)
	  {
	    if (ItDirec[ietap][iter].nbele != acttot)
	      {
		sprintf(message,
"ItDirec[%d][%d].nbele=%d but %d active parameters!\n",
			ietap, iter, ItDirec[ietap][iter].nbele , acttot);
		ecrErr(stderr,"itsplus",message,  ERRINT);
		return((int)ERRINT);
	      }
	    for (param=0; param < acttot; param++)
	      {
		if ( ItDirec[ietap][iter].donnees[param] == DBL_MAX)
		  fprintf(fic, ", NaN ");
		else
		  fprintf(fic, ", %.*g ",  precision, 
		      ItDirec[ietap][iter].donnees[param]);
	      }
	  } /* fin for (iter=1; */
	
	fprintf(fic, "), nrow=%d, byrow=TRUE)\n", NbItSv[ietap]);
	fprintf(fic, "dimnames(%siters.sv$direction) <- list(c(", debut);
	itlabsplus(fic,  ietap);
	fprintf(fic, ", NULL)\n");

      } /* fin if (GNLControle.VouluIt.ResNum == VRAI) */

    if ((GNLControle.VouluIt.Sedo == VRAI) && (Modele.CasSedo == VRAI))
      {
	/* FOdes : array nbitsv, nbobs, nbj, nbeq */
	fprintf(fic, " %siters.sv$FOdes <- array(c(", debut);
	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    for (ik=0; ik <Donnees.NbObs; ik++)
	      {
	    for (ij =0; ij < GNLCtxInteg.NbJ; ij++)
	      {
		for (ieq=0; ieq < GNLCtxInteg.NbEq; ieq++)
		  {
		    if ( (iter>0) || (ik >0) || (ij >0) || (ieq >0))
		      fprintf(fic, ", ");
		    if (ItStat[ietap][iter].Sedo.FSedo[ik][ij][ieq] == DBL_MAX)
		      fprintf(fic, "NAN ");
		    else
		      fprintf(fic, "%.*g ",  precision, 
				ItStat[ietap][iter].Sedo.FSedo[ik][ij][ieq]);
		  } /* fin ieq */
	      } /* fin ij */
	      } /* fin ik */
	  } /* fin for (iter=0; */
	
	fprintf(fic, "), \n dim=c(%d, %d, %ld, %d))\n",
		GNLCtxInteg.NbEq, GNLCtxInteg.NbJ, Donnees.NbObs,
		NbItSv[ietap]);

	fprintf(fic, "dimnames(%siters.sv$FOdes) <- list(NULL, NULL, c(",
		debut);
	splusstr(fic, &(Donnees.NomObs));
	fprintf(fic, ") ,c(");
	itlabsplus(fic,  ietap);
	fprintf(fic, ")\n");
	fprintf(fic, 
"%siters.sv$FOdes <- aperm(%siters.sv$FOdes,  c(4, 3,2,1))\n",
		debut, debut);
      } /* fin if CasSedo */


return(OK);
}
/* ................... fin itsplus ........................*/


/* -------------------------------------------------------
Ecriture de ce qui concerne les labels par iter
----------------------------------------------------------*/
void
itlabsplus( FILE *fic, int ietap)

{
int iter;

	for (iter=0; iter<NbItSv[ietap]; iter++)
	  {
	    if (iter >0)
	      fprintf(fic, ",");
	    fprintf(fic, "'iter%-ld'", ItNum[ietap][iter].NbIter);
	  }
	fprintf(fic, ")\n");
}
/* ................... fin itlabsplus ........................*/



